$(function() {
    function calibrationcompanionViewModel_retra(parameters) {
        var self = this;

        self.settingsViewModel = parameters[0];
        self.calibrationcompanionViewModel = parameters[1];

        let mainViewModel = self.calibrationcompanionViewModel;

        self.profile_selection_retra = ko.observable();
        self.first_layer_nozzle_retra = ko.observable();
        self.regular_nozzle_retra = ko.observable();
        self.regular_bed_retra = ko.observable();
        self.first_layer_bed_retra = ko.observable();
        self.fan_speed_retra = ko.observable();
        self.fan_layer_retra = ko.observable();
        self.first_layer_speed_retra = ko.observable();
        self.regular_speed_retra = ko.observable();
        self.travel_speed_retra = ko.observable();
        self.flow_retra = ko.observable();
        self.abl_method_retra = ko.observable();
        self.start_gcode_retra = ko.observable();
        self.end_gcode_retra = ko.observable();

        let myParent;
        let myBase = [];
        let inputListRetraDist = [];
        let spanControlGroupBox = [];
        let spanControlGroup1 = [];
        let spanControl1 = [];
        let spanInputAppend1 = [];
        let spanAddon1 = [];
        let spanControlGroup2 = [];
        let spanControl2 = [];
        let spanInputAppend2 = [];
        let spanAddon2 = [];
        let inputListRetraSpeed = [];
        let stageImageRetra = [];
        let layerHeightRetra = [];
        let baseImage;

        let stageHeightRetra, baseHeight;

        let array = [];

        //let stageHeightRetra = 4; //(mm)
        //let baseHeight = 2; //(mm)

        let r = 0;
        let oldR = -1;

        let pluginSettings;

        self.onBeforeBinding = function () {
            pluginSettings = self.settingsViewModel.settings.plugins.calibrationcompanion;
            self.profile_selection_retra(pluginSettings.profile_selection_retra());
            self.first_layer_nozzle_retra(pluginSettings.first_layer_nozzle_retra());
            self.regular_nozzle_retra(pluginSettings.regular_nozzle_retra());
            self.regular_bed_retra(pluginSettings.regular_bed_retra());
            self.first_layer_bed_retra(pluginSettings.first_layer_bed_retra());
            self.fan_speed_retra(pluginSettings.fan_speed_retra());
            self.fan_layer_retra(pluginSettings.fan_layer_retra());
            self.first_layer_speed_retra(pluginSettings.first_layer_speed_retra());
            self.regular_speed_retra(pluginSettings.regular_speed_retra());
            self.travel_speed_retra(pluginSettings.travel_speed_retra());
            self.flow_retra(pluginSettings.flow_retra());
            self.abl_method_retra(pluginSettings.abl_method_retra());
            self.start_gcode_retra(pluginSettings.start_gcode_retra());
            self.end_gcode_retra(pluginSettings.end_gcode_retra());
        }
        
        let restrictedInputsRetra = ["#first-layer-nozzle-retra", "#regular-nozzle-retra", "#first-layer-bed-retra", "#regular-bed-retra", "#fan-speed-retra", "#fan-layer-retra",
            "#first-layer-speed-retra", "#regular-speed-retra", "#travel-speed-retra", "#flow-retra", "#abl-method-retra", "#start-gcode-retra", "#end-gcode-retra"];
        let saveInputsRetra = ["first_layer_nozzle_retra", "regular_nozzle_retra", "first_layer_bed", "regular_bed_retra", "fan_speed_retra", "fan_layer_retra",
            "first_layer_speed_retra", "regular_speed_retra", "travel_speed_retra", "flow_retra", "abl_method_retra", "start_gcode_retra", "end_gcode_retra"];
        let restrictedInputsProfile = ["abl-method-retra", "end-gcode-retra", "fan-layer-retra", "fan-speed-retra", "first-layer-nozzle-retra",
            "first-layer-speed-retra", "flow-retra", "regular-bed-retra", "regular-nozzle-retra", "regular-speed-retra", "novalue",
            "novalue", "start-gcode-retra", "travel-speed-retra", "first-layer-bed-retra"];
        let restrictedSettingsProfile = ["abl_method", "end_gcode", "fan_layer", "fan_speed", "first_layer_nozzle",
            "first_layer_speed", "flow", "regular_bed", "regular_nozzle", "regular_speed", "novalue",
            "novalue", "start_gcode", "travel_speed", "first_layer_bed"];
        let saveSettingsProfile, saveSettingsRetra, saveSettingsProfileRetra;

        self.onAfterBinding = function () {
            $(restrictedInputsRetra.join(",")).each(function() {
                let element = this
                let div = this.parentNode.parentNode.parentNode;
                let id = element.id
                saveSettingsRetra = saveInputsRetra[restrictedInputsRetra.indexOf('#' + this.id)]
                saveSettingsProfileRetra = element.value;
                if (restrictedInputsRetra.indexOf('#' + id) <= 7) {
                    mainViewModel.checkValue(element, div, mainViewModel.allowedArrayClassic)
                } else if (restrictedInputsRetra.indexOf('#' + id) === 8) {
                    mainViewModel.checkValue(element, div, mainViewModel.allowedArrayComma)
                }
            });
            if (mainViewModel.nozzle_size() === "0.6") {
                stageHeightRetra = 4.2;
                baseHeight = 1.8;
            } else {
                stageHeightRetra = 4;
                baseHeight = 2;
            }
            mainViewModel.spanValRetra = Math.round(baseHeight/(mainViewModel.nozzle_size()/2));
        }
        
        let settingName, settingValue;

        document.getElementById("load-profile-retra").onclick = function() {
            settingName = [];
            settingValue = [];
            if (self.profile_selection_retra() !== "") {
                mainViewModel.firstTime = Date.now();
                mainViewModel.startLoading()
                for (let x = 0; x < restrictedSettingsProfile.length; x++) {
                    if (restrictedSettingsProfile[x] !== "novalue") {
                        let element = document.getElementById(restrictedInputsProfile[x]);
                        saveSettingsProfile = restrictedSettingsProfile[x] + "_" + self.profile_selection_retra();
                        saveSettingsRetra = restrictedSettingsProfile[x] + "_retra";
                        saveSettingsProfileRetra = pluginSettings[saveSettingsProfile]()
                        element.value = saveSettingsProfileRetra; // loading setting
                        settingName.push(saveSettingsRetra);
                        settingValue.push(saveSettingsProfileRetra);
                        mainViewModel.sortToCheck(element, "loaded");
                    }
                }
                mainViewModel.saveSettingsLoading(settingName, settingValue, "loaded and saved")
            } else {
                self.PNotify = new PNotify(mainViewModel.PNotifyData.noProfileMessage)
            }
        }

        self.addRetraction = function () {
            if (mainViewModel.nozzle_size() === "0.6") {
                stageHeightRetra = 4.2;
                baseHeight = 1.8;
            } else {
                stageHeightRetra = 4;
                baseHeight = 2;
            }
            if (mainViewModel.bed_size_z() > mainViewModel.spanValRetra * (mainViewModel.nozzle_size()/2)) {
                oldR = r;
                r++;
                myParent = document.getElementById("retraStage");

                myBase[r] = document.createElement("div");
                myBase[r].id = "myBase" + r;
                myBase[r].className = "baseText";

                myBase[r].append("Stage " + r)

                myBase[r].appendChild(mainViewModel.whitespace.cloneNode())

                spanControlGroupBox[r] = document.createElement("span");
                spanControlGroupBox[r].className = "control-box-retra"

                myBase[r].appendChild(spanControlGroupBox[r])

                spanControlGroup1[r] = document.createElement("span");
                spanControlGroup1[r].className = "control-group";

                spanControlGroupBox[r].appendChild(spanControlGroup1[r])

                spanControl1[r] = document.createElement("span");
                spanControl1[r].className = "controls";

                spanControlGroup1[r].appendChild(spanControl1[r])

                spanInputAppend1[r] = document.createElement("span");
                spanInputAppend1[r].className = "input-append";

                spanControl1[r].appendChild(spanInputAppend1[r])

                inputListRetraDist[r] = document.createElement("input");
                inputListRetraDist[r].type = "text";
                inputListRetraDist[r].id = "inputListRetraDist" + r;
                inputListRetraDist[r].value = 2 + ((r - 1) / 10) * 2;
                inputListRetraDist[r].className = "smallSizeTextbox";
                spanInputAppend1[r].appendChild(inputListRetraDist[r]);

                spanAddon1[r] = document.createElement("span");
                spanAddon1[r].className = "add-on";
                spanAddon1[r].textContent = "mm";

                spanInputAppend1[r].appendChild(spanAddon1[r]);

                spanControlGroup2[r] = document.createElement("span");
                spanControlGroup2[r].className = "control-group";

                spanControlGroupBox[r].appendChild(spanControlGroup2[r])

                spanControl2[r] = document.createElement("span");
                spanControl2[r].className = "controls";

                spanControlGroup2[r].appendChild(spanControl2[r])

                spanInputAppend2[r] = document.createElement("span");
                spanInputAppend2[r].className = "input-append";

                spanControl2[r].appendChild(spanInputAppend2[r])

                inputListRetraSpeed[r] = document.createElement("input");
                inputListRetraSpeed[r].type = "text";
                inputListRetraSpeed[r].id = "inputListRetraSpeed" + r;
                array.push("#" + inputListRetraSpeed[r].id);
                inputListRetraSpeed[r].value = 40;
                inputListRetraSpeed[r].className = "smallSizeTextbox";
                spanInputAppend2[r].appendChild(inputListRetraSpeed[r]);

                spanAddon2[r] = document.createElement("span");
                spanAddon2[r].className = "add-on";
                spanAddon2[r].textContent = "mm/s";

                spanInputAppend2[r].appendChild(spanAddon2[r])

                myBase[r].appendChild(mainViewModel.whitespace.cloneNode())
                myBase[r].appendChild(mainViewModel.whitespace.cloneNode())
                myBase[r].appendChild(mainViewModel.whitespace.cloneNode())
                myBase[r].appendChild(mainViewModel.whitespace.cloneNode())
                myBase[r].appendChild(mainViewModel.whitespace.cloneNode())

                stageImageRetra[r] = document.createElement("img");
                stageImageRetra[r].src = "/plugin/calibrationcompanion/static/images/retractionStage1.jpg";
                stageImageRetra[r].style.width = "10%";
                stageImageRetra[r].alt = "Retraction tower stage";
                myBase[r].appendChild(stageImageRetra[r]);

                myBase[r].appendChild(mainViewModel.whitespace.cloneNode())
                myBase[r].appendChild(mainViewModel.whitespace.cloneNode())

                myBase[r].appendChild(stageImageRetra[r].cloneNode());

                layerHeightRetra[r] = document.createElement("span");
                layerHeightRetra[r].className = "layerHeightRetra"
                layerHeightRetra[r].textContent = mainViewModel.spanValRetra + 1;
                myBase[r].appendChild(layerHeightRetra[r])
                mainViewModel.spanValRetra = Math.ceil(mainViewModel.spanValRetra + stageHeightRetra / (mainViewModel.nozzle_size() / 2));

                myParent.insertBefore(myBase[r], myBase[r - 1]);

                if (r === 1 && oldR === 0) {
                    baseImage = document.createElement("img");
                    baseImage.src = "/plugin/calibrationcompanion/static/images/retractionBase1.jpg";
                    baseImage.alt = "Retraction tower base";
                    baseImage.className = "retractionBase";
                    myBase[r].parentNode.insertBefore(baseImage, myBase[r].nextSibling);
                }
            } else {
                self.PNotify = new PNotify(mainViewModel.PNotifyData.zHeightWarning)
            }
        }
        self.removeRetraction = function () {
            oldR = r;
            if (Math.sign(r) === 1) {
                mainViewModel.spanValRetra = Math.round(mainViewModel.spanValRetra - stageHeightRetra / (mainViewModel.nozzle_size() / 2));
                myBase[r].remove();
                r--;
            } else {
                r = 0;
            }
            if (r === 0 && oldR === 1) {
                baseImage.remove();
            }
        }

        mainViewModel.resetRetra = function() {
            while(r>0) {
                self.removeRetraction();
            }
            mainViewModel.spanValRetra = 0;
        }

        $(document).on("input", function(e) {
            let id = e.target.id;
            let element = e.target;
            if (id.includes("inputListRetraDist") || id.includes("inputListRetraSpeed")) {
                mainViewModel.checkValue(element, element.parentNode.parentNode, mainViewModel.allowedArrayComma);
            }
        });

        let GStatus, layerStatus, EStatus;
        let relative_pos_x, relative_pos_y, relative_pos_z;
        let gcode_generated = [];
        let pos_x = [];
        let pos_y = [];
        let pos_z = [];

        let returningPosX;
        let returningPosY;
        let first_x_absolute_pos, first_y_absolute_pos;

        let startFeedRate = [];
        let startZHeight = [];

        let printing_speed, l, start_gcode, end_gcode;
        document.getElementById("retra-tower").onclick = function () {
            $('#retra-tower').button('loading');
            if (r === 0) {
                self.PNotify = new PNotify(mainViewModel.PNotifyData.noStageMessage)
                return;
            }
            let array = [];
            let el = document.getElementById("retraction-calibrationcompanion").getElementsByClassName("control-group");
            for (let x=0; x<el.length; x++) {
                array[x] = el[x].attributes[0].nodeValue;
                if (array[x].includes("error")) {
                    self.PNotify = new PNotify(mainViewModel.PNotifyData.errorMessage)
                    return
                }
            }
            mainViewModel.flowCube = false
            l = 0;
            mainViewModel.last_feed_rate = 0;
            start_gcode = document.getElementById("start-gcode-retra").value;
            end_gcode = document.getElementById("end-gcode-retra").value;
            mainViewModel.variable.first_layer_nozzle = document.getElementById("first-layer-nozzle-retra").value;
            mainViewModel.variable.regular_nozzle = document.getElementById("regular-nozzle-retra").value;
            mainViewModel.variable.first_layer_bed = document.getElementById("first-layer-bed-retra").value;
            mainViewModel.variable.regular_bed = document.getElementById("regular-bed-retra").value;
            mainViewModel.variable.fan_speed = document.getElementById("fan-speed-retra").value;
            mainViewModel.variable.fan_layer = document.getElementById("fan-layer-retra").value;
            mainViewModel.variable.first_layer_speed = document.getElementById("first-layer-speed-retra").value * 60;
            mainViewModel.variable.regular_speed = document.getElementById("regular-speed-retra").value * 60;
            mainViewModel.variable.travel_speed = document.getElementById("travel-speed-retra").value * 60;
            mainViewModel.variable.retraction_speed = document.getElementById("inputListRetraSpeed1").value * 60;
            mainViewModel.variable.retraction_distance = document.getElementById("inputListRetraDist1").value;
            mainViewModel.variable.flow = document.getElementById("flow-retra").value;
            mainViewModel.variable.abl_method = document.getElementById("abl-method-retra").value;
            mainViewModel.variable.filename = "retratower";
            for (let s = 0; s <= r; s++) {
                let boolean = [true]
                if (s === 0) {
                    mainViewModel.first_x_pos = String(mainViewModel.bed_center_x + 32 / 2);
                    mainViewModel.first_y_pos = String(mainViewModel.bed_center_y + 8 / 2);
                    mainViewModel.first_z_pos = String((mainViewModel.nozzle_size()/2)*l);
                    first_x_absolute_pos = mainViewModel.first_x_pos;
                    first_y_absolute_pos = mainViewModel.first_y_pos;
                    retraBaseTowerCoord(parseFloat(mainViewModel.nozzle_size()));
                    for (let z = 0; z<=relative_pos_x.length; z++) {
                        if (mainViewModel.relative_positioning()) {
                            pos_x[z] = relative_pos_x[z]
                            pos_y[z] = relative_pos_y[z]
                            pos_z[z] = relative_pos_z[z]
                        } else {
                            mainViewModel.getAbsoluteCoordinate(relative_pos_x[z], relative_pos_y[z], relative_pos_z[z], boolean[z])
                            pos_x[z] = mainViewModel.xAbsolute[z];
                            pos_y[z] = mainViewModel.yAbsolute[z];
                            pos_z[z] = mainViewModel.zAbsolute[z];
                        }
                    }
                    if (mainViewModel.relative_positioning()) {
                        if (mainViewModel.nozzle_size() === "0.4") {
                            returningPosX = mainViewModel.getReturningPosition(relative_pos_x) - 32 + 1.5 * mainViewModel.nozzle_size();
                            returningPosY = mainViewModel.getReturningPosition(relative_pos_y) - 8 / 2 + 4 / 2;
                        } else if (mainViewModel.nozzle_size() === "0.6") {
                            returningPosX = mainViewModel.getReturningPosition(relative_pos_x) - 2.8 + 1.5 * mainViewModel.nozzle_size();
                            returningPosY = mainViewModel.getReturningPosition(relative_pos_y) - 8 / 2 + 4.5 / 2;
                        } else if (mainViewModel.nozzle_size() === "0.8") {
                            returningPosX = mainViewModel.getReturningPosition(relative_pos_x) - 2.8 + 1.5 * mainViewModel.nozzle_size();
                            returningPosY = mainViewModel.getReturningPosition(relative_pos_y) - 8 / 2 + 4.5 / 2;
                        }
                    } else {
                        pos_x.splice(0, 1);
                        pos_y.splice(0, 1);
                        pos_z.splice(0, 1);
                        if (mainViewModel.nozzle_size() === "0.4") {
                            returningPosX = parseFloat(pos_x[pos_x.length-1]) + mainViewModel.getReturningPosition(relative_pos_x) - 32 + 1.5 * mainViewModel.nozzle_size();
                            returningPosY = parseFloat(pos_y[pos_y.length-1]) + mainViewModel.getReturningPosition(relative_pos_y) - 8 / 2 + 4 / 2;
                        } else if (mainViewModel.nozzle_size() === "0.6") {
                            returningPosX = parseFloat(pos_x[pos_x.length-1]) + mainViewModel.getReturningPosition(relative_pos_x) - 2.8 + 1.5 * mainViewModel.nozzle_size();
                            returningPosY = parseFloat(pos_y[pos_y.length-1]) + mainViewModel.getReturningPosition(relative_pos_y) - 8 / 2 + 4.5 / 2;
                        } else if (mainViewModel.nozzle_size() === "0.8") {
                            returningPosX = parseFloat(pos_x[pos_x.length-1]) + mainViewModel.getReturningPosition(relative_pos_x) - 32 + 1.5 * mainViewModel.nozzle_size();
                            returningPosY = parseFloat(pos_y[pos_y.length-1]) + mainViewModel.getReturningPosition(relative_pos_y) - 8 / 2 + 4.5 / 2;
                        }
                    }
                } else {
                    startZHeight[s] = parseFloat(mainViewModel.zLastAbsolute) + parseFloat(mainViewModel.nozzle_size())/2
                    startFeedRate[s] = mainViewModel.feed_rate
                    retraTowerCoord(parseFloat(mainViewModel.nozzle_size()));
                    for (let z = 0; z<=relative_pos_x.length; z++) {
                        if (mainViewModel.relative_positioning()) {
                            pos_x[z] = relative_pos_x[z]
                            pos_y[z] = relative_pos_y[z]
                            pos_z[z] = relative_pos_z[z]
                        } else {
                            mainViewModel.first_x_pos = returningPosX
                            mainViewModel.first_y_pos = returningPosY
                            mainViewModel.first_z_pos = (mainViewModel.nozzle_size()/2)*l
                            mainViewModel.getAbsoluteCoordinate(relative_pos_x[z], relative_pos_y[z], relative_pos_z[z], boolean[z])
                            pos_x[z] = mainViewModel.xAbsolute[z]
                            pos_y[z] = mainViewModel.yAbsolute[z]
                            pos_z[z] = mainViewModel.zAbsolute[z]
                        }
                    }
                    if (!mainViewModel.relative_positioning()) {
                        pos_x.splice(0, 1);
                        pos_y.splice(0, 1);
                        pos_z.splice(0, 1);
                    }
                }
                gcode_generated[s] = [];
                for (let x = 0; x < relative_pos_x.length; x++) {
                    if (l <= 1) {
                        printing_speed = mainViewModel.variable.first_layer_speed;
                    } else {
                        printing_speed = mainViewModel.variable.regular_speed;
                    }
                    if (GStatus[x] !== "null") {
                            if (pos_z[x] === "null") {
                                if (GStatus[x] === "G0") {
                                    gcode_generated[s][x] = GStatus[x] + " F" + mainViewModel.variable.travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + ";\n";
                                } else {
                                    if (EStatus[x] !== "null") {
                                        if (mainViewModel.relative_positioning()) {
                                            if (EStatus[x] === "retract" && s >= 1) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E-" + document.getElementById("inputListRetraDist" + s).value + ";\n";
                                            } else if (EStatus[x] === "extrude" && s >= 1) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + "E" + document.getElementById("inputListRetraDist" + s).value + ";\n";
                                            } else if (EStatus[x] === "retract" && s === 0) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed1").value * 60 + " E-" + document.getElementById("inputListRetraDist1").value + ";\n";
                                            } else if (EStatus[x] === "extrude" && s === 0) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed1").value * 60 + " E" + document.getElementById("inputListRetraDist1").value + ";\n";
                                            }
                                        } else {
                                            if (EStatus[x] === "retract" && s >= 1) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + (mainViewModel.feed_rate - document.getElementById("inputListRetraDist" + s).value).toFixed(5) + ";\n";
                                            } else if (EStatus[x] === "extrude" && s >= 1) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + mainViewModel.feed_rate + ";\n";
                                            } else if (EStatus[x] === "retract" && s === 0) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed1").value * 60 + " E" + (mainViewModel.feed_rate - document.getElementById("inputListRetraDist1").value).toFixed(5) + ";\n";
                                            } else if (EStatus[x] === "extrude" && s === 0) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed1").value * 60 + " E" + mainViewModel.feed_rate + ";\n";
                                            }
                                        }
                                    } else {
                                        mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                                        gcode_generated[s][x] = GStatus[x] + " F" + printing_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " E" + mainViewModel.feed_rate + ";\n";
                                    }
                                }
                            } else {
                                if (GStatus[x] === "G0") {
                                    gcode_generated[s][x] = GStatus[x] + " F" + mainViewModel.variable.travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + ";\n";
                                } else {
                                    mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                                    gcode_generated[s][x] = GStatus[x] + " F" + printing_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + " E" + mainViewModel.feed_rate + ";\n";
                                }
                        }
                    } else if (layerStatus[x] === "LAYER") {
                            if (l >= 1 && l <= mainViewModel.variable.fan_layer) {
                                if (l === 1) {
                                    gcode_generated[s][x] = "M104 S" + mainViewModel.variable.regular_nozzle + ";\n" + ";LAYER:" + l + "\n" +
                                        "M106 S" + Math.round(l * (mainViewModel.variable.fan_speed * (255 / 100) * 10) / mainViewModel.variable.fan_layer) / 10 + ";\n";
                                } else {
                                    gcode_generated[s][x] = ";LAYER:" + l + "\n" +
                                        "M106 S" + Math.round(l * (mainViewModel.variable.fan_speed * (255 / 100) * 10) / mainViewModel.variable.fan_layer) / 10 + ";\n";
                                }
                            } else {
                                gcode_generated[s][x] = ";LAYER:" + l + "\n"
                            }
                            l++;
                        }
                    }
                if (s === 1) {
                    if (mainViewModel.relative_positioning()) {
                        gcode_generated[s].unshift("M117 St" + s + "/" + r + " ReD" + document.getElementById("inputListRetraDist" + s).value + " ReS" + document.getElementById("inputListRetraSpeed" + s).value + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E-" + document.getElementById("inputListRetraDist" + s).value + ";\n" +
                            "G0 F" + mainViewModel.variable.travel_speed + " Z" + mainViewModel.nozzle_size() / 2 + "\n" +
                            "G0 F" + mainViewModel.variable.travel_speed + " X" + returningPosX + " Y" + returningPosY + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + document.getElementById("inputListRetraDist" + s).value + ";\n");
                    } else {
                        gcode_generated[s].unshift("M117 St" + s + "/" + r + " ReD" + document.getElementById("inputListRetraDist" + s).value + " ReS" + document.getElementById("inputListRetraSpeed" + s).value + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + (parseFloat(startFeedRate[s]) - document.getElementById("inputListRetraDist" + s).value).toFixed(5) + ";\n" +
                            "G0 F" + mainViewModel.variable.travel_speed + " Z" + (startZHeight[s] + parseFloat(mainViewModel.nozzle_size())/2) + "\n" +
                            "G0 F" + mainViewModel.variable.travel_speed + " X" + returningPosX + " Y" + returningPosY + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + parseFloat(startFeedRate[s]) + ";\n");
                    }
                }
                if (s >= 2) {
                    if (mainViewModel.relative_positioning()) {
                        gcode_generated[s].unshift("M117 St" + s + "/" + r + " ReD" + document.getElementById("inputListRetraDist" + s).value + " ReS" + document.getElementById("inputListRetraSpeed" + s).value + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E-" + document.getElementById("inputListRetraDist" + s).value + ";\n" +
                            "G0 F" + mainViewModel.variable.travel_speed + " Z" + mainViewModel.nozzle_size() / 2 + "\n" +
                            "G0 F" + mainViewModel.variable.travel_speed + " X" + mainViewModel.getReturningPosition(relative_pos_x) + " Y" + mainViewModel.getReturningPosition(relative_pos_y) + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + document.getElementById("inputListRetraDist" + s).value + ";\n");
                    } else {
                        gcode_generated[s].unshift("M117 St" + s + "/" + r + " ReD" + document.getElementById("inputListRetraDist" + s).value + " ReS" + document.getElementById("inputListRetraSpeed" + s).value + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + (parseFloat(startFeedRate[s]) - document.getElementById("inputListRetraDist" + s).value).toFixed(5) + ";\n" +
                            "G0 F" + mainViewModel.variable.travel_speed + " Z" + (startZHeight[s] + parseFloat(mainViewModel.nozzle_size())/2) + "\n" +
                            "G0 F" + mainViewModel.variable.travel_speed + " X" + (parseFloat(pos_x[pos_x.length-1])+parseFloat(mainViewModel.getReturningPosition(relative_pos_x))).toFixed(3) + " Y" + (parseFloat(pos_y[pos_y.length-1])+parseFloat(mainViewModel.getReturningPosition(relative_pos_y))).toFixed(3) + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + parseFloat(startFeedRate[s]) + ";\n");
                    }
                }
            }
            if (mainViewModel.relative_positioning()) {
                gcode_generated.unshift("G91;\n")
            }

            mainViewModel.callSettings();

            for (const [key, value] of Object.entries(mainViewModel.settingsCallable)) {
                start_gcode = start_gcode.replaceAll("[" + key + "]", value);
            }
            gcode_generated.unshift("G28;\n\n" +
                ";---------ABL METHOD---------\n" + mainViewModel.variable.abl_method + ";\n;---------ABL METHOD---------\n\n" +
                ";---------START G-CODE---------\n" + start_gcode + ";\n;---------START G-CODE---------\n\n" +
                "G92 E0;\nG0 F" + mainViewModel.variable.travel_speed + " X" + first_x_absolute_pos + " Y" + first_y_absolute_pos +
                ";\n" + "G0 F" + mainViewModel.variable.travel_speed + " Z" + mainViewModel.nozzle_size() / 2 + ";\n")

            for (const [key, value] of Object.entries(mainViewModel.settingsCallable)) {
                end_gcode = end_gcode.replaceAll("[" + key + "]", value);
            }
            gcode_generated.push(end_gcode);

            let url = OctoPrint.getBlueprintUrl('calibrationcompanion') + "downloadFile";
            OctoPrint.post(url, {"name": mainViewModel.getFullFilename(mainViewModel.variable.filename), "generated gcode": gcode_generated.flat().join('')})

            gcode_generated = [];
            pos_x = [];
            pos_y = [];
            pos_z = [];
            startZHeight = [];
            startFeedRate = [];
        }

        function retraBaseTowerCoord(nozzle_size) {
            if (nozzle_size === 0.4) {
                GStatus = ['null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0'];
                EStatus = ['null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
                relative_pos_x = ['null', '-0.541', '-31.995', '-0.519', '-0.528', '-0.49', '-0.453', '-0.414', '-0.345', '-0.285', '-0.207', '-0.127', '-0.047', '0.037', '0.121', '0.198', '0.273', '0.349', '0.396', '0.458', '0.487', '0.52', '0.541', '31.995', '0.519', '0.528', '0.49', '0.453', '0.414', '0.345', '0.285', '0.205', '0.129', '0.047', '-0.037', '-0.121', '-0.198', '-0.273', '-0.349', '-0.396', '-0.458', '-0.487', '-0.52', '0.067', '-0.596', '-32.025', '-0.562', '-0.588', '-0.548', '-0.508', '-0.459', '-0.389', '-0.318', '-0.231', '-0.144', '-0.051', '0.041', '0.135', '0.222', '0.306', '0.387', '0.446', '0.51', '0.546', '0.58', '0.596', '32.025', '0.562', '0.588', '0.548', '0.508', '0.459', '0.389', '0.318', '0.23', '0.145', '0.051', '-0.041', '-0.135', '-0.222', '-0.306', '-0.387', '-0.446', '-0.51', '-0.546', '-0.58', '-0.072', '-0.06', '-0.487', '-31.979', '-0.459', '-0.48', '-0.427', '-0.399', '-0.371', '-0.303', '-0.251', '-0.185', '-0.113', '-0.04', '0.033', '0.106', '0.174', '0.24', '0.314', '0.347', '0.406', '0.433', '0.459', '0.487', '31.979', '0.459', '0.48', '0.427', '0.399', '0.371', '0.304', '0.252', '0.182', '0.113', '0.041', '-0.033', '-0.106', '-0.174', '-0.24', '-0.314', '-0.347', '-0.406', '-0.433', '-0.459', '0.067', '0.926', '0.435', '0.708', '0.447', '0.151', '-0.045', '-0.125', '-0.192', '-0.271', '-0.409', '-0.778', '-0.164', '1.309', '0.257', '-2.385', '-0.604', '3.01', '-0.07', '-3.506', '-0.565', '3.934', '-0.189', '-4.311', '-0.566', '4.641', '-0.274', '-4.932', '-0.566', '5.185', '-0.354', '-5.397', '-0.565', '5.559', '-0.464', '-5.661', '-0.566', '5.697', '-0.566', '-5.696', '-0.566', '5.696', '-0.565', '-5.697', '-0.565', '5.696', '-0.566', '-5.696', '-0.566', '5.697', '-0.566', '-5.697', '-0.565', '5.696', '-0.565', '-5.697', '-0.566', '5.697', '-0.566', '-5.696', '-0.566', '5.696', '-0.565', '-5.697', '-0.565', '5.696', '-0.566', '-5.696', '-0.566', '5.697', '-0.566', '-5.696', '-0.565', '5.695', '-0.565', '-5.696', '-0.566', '5.696', '-0.566', '-5.695', '-0.566', '5.696', '-0.566', '-5.696', '-0.565', '5.695', '-0.565', '-5.696', '-0.566', '5.696', '-0.566', '-5.696', '-0.565', '5.696', '-0.565', '-5.697', '-0.566', '5.697', '-0.566', '-5.696', '-0.566', '5.696', '-0.565', '-5.697', '-0.565', '5.696', '-0.566', '-5.696', '-0.566', '5.697', '-0.566', '-5.696', '-0.566', '5.696', '-0.565', '-5.697', '-0.565', '5.696', '-0.566', '-5.696', '-0.566', '5.697', '-0.566', '-5.697', '-0.565', '5.696', '-0.565', '-5.697', '-0.566', '5.697', '-0.566', '-5.661', '-0.464', '5.56', '-0.566', '-5.396', '-0.354', '5.184', '-0.566', '-4.932', '-0.274', '4.641', '-0.566', '-4.31', '-0.189', '3.933', '-0.565', '-3.506', '-0.07', '3.01', '-0.604', '-2.386', '0.261', '1.307', '-0.132', 'null', '0', '-0.033', '0.938', '33.001', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '-0.059', '-0.494', '-31.948', '-0.494', '-0.456', '-0.439', '-0.407', '-0.355', '-0.306', '-0.248', '-0.183', '-0.109', '-0.038', '0.038', '0.109', '0.183', '0.248', '0.306', '0.355', '0.407', '0.439', '0.456', '0.494', '31.948', '0.494', '0.456', '0.439', '0.407', '0.355', '0.306', '0.248', '0.183', '0.109', '0.038', '-0.038', '-0.109', '-0.183', '-0.248', '-0.306', '-0.355', '-0.407', '-0.439', '-0.456', '0.021', '0.973', '0.438', '0.637', '0.607', '-0.429', '-1.874', '-0.685', '2.679', '-0.019', '-3.239', '-0.566', '3.702', '-0.164', '-4.103', '-0.566', '4.459', '-0.253', '-4.772', '-0.565', '5.046', '-0.332', '-5.28', '-0.566', '5.47', '-0.425', '-5.61', '-0.566', '5.684', '-0.55', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.691', '-0.502', '5.627', '-0.566', '-5.495', '-0.383', '5.313', '-0.566', '-5.086', '-0.297', '4.817', '-0.566', '-4.512', '-0.215', '4.162', '-0.566', '-3.765', '-0.115', '3.314', '-0.572', '-2.779', '0.099', '2.016', '-0.082', 'null', '0', '-0.02', '-1.069', '-0.708', '-0.268', '-0.195', '-0.117', '-0.041', '0.041', '0.117', '0.195', '0.268', '0.708', '0.438', '0.468', '0.49', '0.149', '32.887', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '0.69', '-6.395', '2.828', '5.123', '0.504', '-2.754', '-1.89', '-6.64', '-2.828', '6.64', '-2.829', '-6.64', '-2.828', '6.64', '-2.829', '-6.639', '-2.829', '6.64', '-2.829', '-6.639', '-2.829', '6.639', '-2.828', '-6.639', '-2.585', '6.395', '-2.828', '-5.123', '-0.503', '2.753', '0.027', 'null', '0', '33.03', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '-0.005', '2.754', '-0.504', '-5.123', '-2.828', '6.396', '-2.583', '-6.641', '-2.829', '6.641', '-2.828', '-6.641', '-2.828', '6.64', '-2.828', '-6.64', '-2.829', '6.641', '-2.829', '-6.64', '-2.829', '6.641', '-2.829', '-6.64', '-2.585', '6.397', '-2.829', '-5.123', '-0.504', '2.755', '0.025', 'null', '0', '33.03', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '0.69', '-6.395', '2.828', '5.123', '0.504', '-2.754', '-1.89', '-6.64', '-2.828', '6.64', '-2.829', '-6.64', '-2.828', '6.64', '-2.829', '-6.639', '-2.829', '6.64', '-2.829', '-6.639', '-2.829', '6.639', '-2.828', '-6.639', '-2.585', '6.395', '-2.828', '-5.123', '-0.503', '2.753', '0.027', 'null', '0', '33.03', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '-0.005', '2.754', '-0.504', '-5.123', '-2.828', '6.396', '-2.583', '-6.641', '-2.829', '6.641', '-2.828', '-6.641', '-2.828', '6.64', '-2.828', '-6.64', '-2.829', '6.641', '-2.829', '-6.64', '-2.829', '6.641', '-2.829', '-6.64', '-2.585', '6.397', '-2.829', '-5.123', '-0.504', '2.755', '0.025', 'null', '0', '33.03', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '0.69', '-6.395', '2.828', '5.123', '0.504', '-2.754', '-1.89', '-6.64', '-2.828', '6.64', '-2.829', '-6.64', '-2.828', '6.64', '-2.829', '-6.639', '-2.829', '6.64', '-2.829', '-6.639', '-2.829', '6.639', '-2.828', '-6.639', '-2.585', '6.395', '-2.828', '-5.123', '-0.503', '2.753', '0.027', 'null', '0', '33.03', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '-0.005', '2.754', '-0.504', '-5.123', '-2.828', '6.396', '-2.583', '-6.641', '-2.829', '6.641', '-2.828', '-6.641', '-2.828', '6.64', '-2.828', '-6.64', '-2.829', '6.641', '-2.829', '-6.64', '-2.829', '6.641', '-2.829', '-6.64', '-2.585', '6.397', '-2.829', '-5.123', '-0.504', '2.755', '0.025', 'null', '0', '33.034', 'null', 'null', '-0.559', '-32.025', '-0.487', '-0.511', '-0.495', '-0.459', '-0.402', '-0.345', '-0.281', '-0.203', '-0.125', '-0.042', '0.003', '0.039', '0.123', '0.205', '0.281', '0.345', '0.402', '0.459', '0.49', '0.515', '0.559', '32.025', '0.487', '0.043', '0.468', '0.495', '0.459', '0.402', '0.345', '0.281', '0.203', '0.125', '0.042', '-0.003', '-0.039', '-0.123', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.49', '-0.515', '0.063', '-0.603', '-31.983', '-0.093', '-0.512', '-0.08', '-0.499', '-0.55', '-0.515', '-0.45', '-0.385', '-0.316', '-0.225', '-0.14', '-0.047', '0.005', '0.041', '0.018', '0.121', '0.227', '0.316', '0.385', '0.45', '0.515', '0.545', '0.577', '0.603', '31.983', '0.093', '0.512', '0.08', '0.499', '0.55', '0.515', '0.45', '0.385', '0.316', '0.225', '0.14', '0.047', '-0.005', '-0.041', '-0.018', '-0.121', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.545', '-0.577', '-0.069', '-0.059', '-0.501', '-32.011', '-0.429', '-0.453', '-0.44', '-0.407', '-0.355', '-0.306', '-0.248', '-0.18', '-0.112', '-0.036', '0.005', '0.031', '0.109', '0.183', '0.248', '0.306', '0.355', '0.407', '0.435', '0.457', '0.501', '32.011', '0.451', '0.431', '0.44', '0.407', '0.355', '0.306', '0.248', '0.18', '0.112', '0.036', '-0.005', '-0.031', '-0.109', '-0.183', '-0.248', '-0.306', '-0.355', '-0.407', '-0.435', '-0.457', '0.022', '0.969', '0.438', '0.708', '0.268', '0.195', '0.116', '0', '-0.226', '-0.408', '-1.309', '-0.822', '2.391', '0.022', '-3.013', '-0.565', '3.504', '-0.141', '-3.929', '-0.566', '4.306', '-0.233', '-4.638', '-0.566', '4.929', '-0.312', '-5.183', '-0.566', '5.394', '-0.402', '-5.558', '-0.566', '5.662', '-0.532', '-5.695', '-0.566', '5.695', '-0.566', '-5.695', '-0.565', '5.695', '-0.566', '-5.696', '-0.565', '5.695', '-0.565', '-5.696', '-0.566', '5.695', '-0.565', '-5.695', '-0.566', '5.695', '-0.566', '-5.695', '-0.566', '5.696', '-0.566', '-5.696', '-0.566', '5.696', '-0.566', '-5.695', '-0.566', '5.695', '-0.566', '-5.695', '-0.565', '5.695', '-0.566', '-5.696', '-0.565', '5.695', '-0.565', '-5.696', '-0.566', '5.696', '-0.566', '-5.695', '-0.566', '5.695', '-0.566', '-5.695', '-0.566', '5.696', '-0.566', '-5.696', '-0.566', '5.696', '-0.565', '-5.696', '-0.566', '5.695', '-0.566', '-5.695', '-0.565', '5.695', '-0.566', '-5.695', '-0.566', '5.695', '-0.565', '-5.696', '-0.566', '5.696', '-0.566', '-5.695', '-0.566', '5.695', '-0.566', '-5.695', '-0.565', '5.695', '-0.566', '-5.696', '-0.566', '5.696', '-0.565', '-5.696', '-0.566', '5.695', '-0.566', '-5.695', '-0.565', '5.695', '-0.566', '-5.695', '-0.532', '5.661', '-0.565', '-5.559', '-0.402', '5.395', '-0.566', '-5.184', '-0.312', '4.93', '-0.566', '-4.639', '-0.233', '4.307', '-0.566', '-3.93', '-0.14', '3.504', '-0.565', '-3.013', '0.021', '2.395', '-0.826', '-1.309', '-0.324', 'null', '0', '-0.083', '0.681', '0.381', '0.438', '0.469', '0.768', '32.757', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '-0.059', '-0.494', '-31.948', '-0.494', '-0.456', '-0.439', '-0.407', '-0.355', '-0.306', '-0.248', '-0.183', '-0.109', '-0.038', '0.038', '0.109', '0.183', '0.248', '0.306', '0.355', '0.407', '0.439', '0.456', '0.494', '31.948', '0.494', '0.456', '0.439', '0.407', '0.355', '0.306', '0.248', '0.183', '0.109', '0.038', '-0.038', '-0.109', '-0.183', '-0.248', '-0.306', '-0.355', '-0.407', '-0.439', '-0.456', '0.021', '0.973', '0.438', '0.637', '0.607', '-0.429', '-1.874', '-0.685', '2.679', '-0.019', '-3.239', '-0.566', '3.702', '-0.164', '-4.103', '-0.566', '4.459', '-0.253', '-4.772', '-0.565', '5.046', '-0.332', '-5.28', '-0.566', '5.47', '-0.425', '-5.61', '-0.566', '5.684', '-0.55', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.691', '-0.502', '5.627', '-0.566', '-5.495', '-0.383', '5.313', '-0.566', '-5.086', '-0.297', '4.817', '-0.566', '-4.512', '-0.215', '4.162', '-0.566', '-3.765', '-0.115', '3.314', '-0.572', '-2.779', '0.099', '2.016', '-0.082'];
                relative_pos_y = ['null', '0.047', '0.003', '-0.041', '-0.122', '-0.198', '-0.273', '-0.349', '-0.396', '-0.458', '-0.487', '-0.514', '-0.535', '-0.531', '-0.525', '-0.488', '-0.453', '-0.414', '-0.345', '-0.285', '-0.207', '-0.129', '-0.047', '-0.003', '0.041', '0.122', '0.198', '0.273', '0.349', '0.396', '0.457', '0.484', '0.519', '0.534', '0.531', '0.525', '0.488', '0.453', '0.414', '0.345', '0.285', '0.207', '0.129', '0.395', '0.052', '0.003', '-0.044', '-0.136', '-0.222', '-0.306', '-0.387', '-0.446', '-0.51', '-0.546', '-0.58', '-0.588', '-0.602', '-0.581', '-0.548', '-0.508', '-0.459', '-0.389', '-0.318', '-0.231', '-0.144', '-0.052', '-0.003', '0.044', '0.136', '0.222', '0.306', '0.387', '0.446', '0.51', '0.544', '0.582', '0.588', '0.602', '0.581', '0.548', '0.508', '0.459', '0.389', '0.318', '0.231', '0.144', '-0.434', '-0.347', '0.043', '0.003', '-0.037', '-0.11', '-0.172', '-0.241', '-0.314', '-0.347', '-0.404', '-0.432', '-0.459', '-0.464', '-0.482', '-0.461', '-0.428', '-0.399', '-0.371', '-0.303', '-0.253', '-0.184', '-0.113', '-0.043', '-0.003', '0.037', '0.11', '0.172', '0.241', '0.314', '0.347', '0.405', '0.429', '0.458', '0.465', '0.484', '0.461', '0.428', '0.399', '0.371', '0.303', '0.253', '0.184', '0.113', '0.272', '-0.373', '-0.271', '-0.723', '-0.892', '-1.001', '-0.505', '-0.5', '-0.456', '-0.434', '-0.401', '-0.644', '0.406', '1.309', '0.823', '-2.385', '-0.038', '3.01', '0.495', '-3.505', '0', '3.934', '0.376', '-4.31', '0', '4.64', '0.292', '-4.932', '0', '5.184', '0.212', '-5.396', '0', '5.559', '0.102', '-5.661', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0.001', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.661', '0.101', '5.56', '0', '-5.396', '0.211', '5.185', '0', '-4.932', '0.291', '4.641', '0', '-4.31', '0.376', '3.934', '0', '-3.506', '0.496', '3.01', '-0.039', '-2.386', '0.827', '1.307', '0.325', 'null', '0', '0.081', '0.228', '0.166', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.348', '0.039', '0', '-0.039', '-0.109', '-0.183', '-0.248', '-0.306', '-0.355', '-0.407', '-0.439', '-0.456', '-0.468', '-0.468', '-0.456', '-0.439', '-0.407', '-0.355', '-0.306', '-0.248', '-0.183', '-0.109', '-0.039', '0', '0.039', '0.109', '0.183', '0.248', '0.306', '0.355', '0.407', '0.439', '0.456', '0.468', '0.468', '0.456', '0.439', '0.407', '0.355', '0.306', '0.248', '0.183', '0.109', '0.279', '-0.374', '-0.268', '-0.637', '-1.026', '-0.103', '1.874', '0.12', '-2.68', '-0.546', '3.239', '0', '-3.702', '-0.401', '4.103', '0', '-4.459', '-0.312', '4.771', '0', '-5.047', '-0.233', '5.28', '0', '-5.47', '-0.14', '5.61', '0', '-5.684', '-0.016', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.691', '-0.064', '-5.627', '0', '5.496', '-0.183', '-5.313', '0', '5.086', '-0.268', '-4.818', '0', '4.513', '-0.352', '-4.161', '0', '3.765', '-0.45', '-3.315', '0.006', '2.78', '-0.665', '-2.016', '-0.338', 'null', '0', '-0.088', '0.564', '0.708', '0.438', '0.468', '0.49', '0.504', '0.504', '0.49', '0.468', '0.438', '0.708', '0.268', '0.195', '0.117', '0.011', '0.158', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.244', '-6.395', '0', '5.123', '-2.325', '-2.754', '6.595', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0.244', '6.395', '0', '-5.123', '2.325', '2.753', '-0.115', 'null', '0', '0.198', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.044', '-2.753', '-2.325', '5.123', '0', '-6.396', '-0.245', '6.641', '0', '-6.641', '0', '6.641', '-0.001', '-6.64', '0', '6.64', '0', '-6.64', '0', '6.64', '0', '-6.64', '0', '6.64', '-0.244', '-6.396', '0', '5.123', '-2.324', '-2.755', '0.119', 'null', '0', '6.515', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.244', '-6.395', '0', '5.123', '-2.325', '-2.754', '6.595', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0.244', '6.395', '0', '-5.123', '2.325', '2.753', '-0.115', 'null', '0', '0.198', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.044', '-2.753', '-2.325', '5.123', '0', '-6.396', '-0.245', '6.641', '0', '-6.641', '0', '6.641', '-0.001', '-6.64', '0', '6.64', '0', '-6.64', '0', '6.64', '0', '-6.64', '0', '6.64', '-0.244', '-6.396', '0', '5.123', '-2.324', '-2.755', '0.119', 'null', '0', '6.515', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.244', '-6.395', '0', '5.123', '-2.325', '-2.754', '6.595', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0.244', '6.395', '0', '-5.123', '2.325', '2.753', '-0.115', 'null', '0', '0.198', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.044', '-2.753', '-2.325', '5.123', '0', '-6.396', '-0.245', '6.641', '0', '-6.641', '0', '6.641', '-0.001', '-6.64', '0', '6.64', '0', '-6.64', '0', '6.64', '0', '-6.64', '0', '6.64', '-0.244', '-6.396', '0', '5.123', '-2.324', '-2.755', '0.119', 'null', '0', '6.513', 'null', 'null', '0.045', '-0.005', '-0.039', '-0.123', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.49', '-0.515', '-0.54', '-0.044', '-0.487', '-0.511', '-0.495', '-0.459', '-0.402', '-0.345', '-0.281', '-0.203', '-0.124', '-0.045', '0.005', '0.039', '0.01', '0.113', '0.205', '0.281', '0.345', '0.402', '0.459', '0.49', '0.515', '0.539', '0.045', '0.487', '0.511', '0.495', '0.459', '0.402', '0.345', '0.281', '0.203', '0.124', '0.397', '0.048', '0', '-0.006', '-0.041', '-0.018', '-0.121', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.545', '-0.577', '-0.595', '-0.084', '-0.512', '-0.08', '-0.499', '-0.55', '-0.515', '-0.45', '-0.385', '-0.316', '-0.225', '-0.14', '-0.048', '0', '0.006', '0.041', '0.018', '0.121', '0.227', '0.316', '0.385', '0.45', '0.515', '0.545', '0.577', '0.595', '0.084', '0.512', '0.08', '0.499', '0.55', '0.515', '0.45', '0.385', '0.316', '0.225', '0.14', '-0.434', '-0.348', '0.04', '-0.005', '-0.035', '-0.108', '-0.183', '-0.248', '-0.306', '-0.355', '-0.407', '-0.433', '-0.46', '-0.466', '-0.089', '-0.385', '-0.453', '-0.44', '-0.407', '-0.355', '-0.306', '-0.248', '-0.181', '-0.11', '-0.04', '0.005', '0.04', '0.103', '0.183', '0.248', '0.306', '0.355', '0.407', '0.433', '0.46', '0.466', '0.091', '0.383', '0.453', '0.44', '0.407', '0.355', '0.306', '0.248', '0.181', '0.11', '0.278', '-0.372', '-0.268', '-0.708', '-0.438', '-0.469', '-0.486', '-0.911', '-1.01', '0.168', '-1.309', '-0.256', '2.391', '0.587', '-3.012', '0', '3.504', '0.425', '-3.929', '0', '4.305', '0.333', '-4.638', '0', '4.929', '0.254', '-5.183', '-0.001', '5.394', '0.164', '-5.558', '0', '5.661', '0.034', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '-0.001', '-5.695', '0', '5.695', '0', '-5.695', '-0.001', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0.033', '5.662', '0', '-5.559', '0.164', '5.395', '-0.001', '-5.184', '0.254', '4.93', '0', '-4.639', '0.333', '4.306', '0', '-3.93', '0.426', '3.504', '0', '-3.013', '0.587', '2.395', '-0.26', '-1.309', '0.136', 'null', '0', '0.033', '0.868', '0.327', '0.268', '0.195', '0.123', '0.163', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.348', '0.039', '0', '-0.039', '-0.109', '-0.183', '-0.248', '-0.306', '-0.355', '-0.407', '-0.439', '-0.456', '-0.468', '-0.468', '-0.456', '-0.439', '-0.407', '-0.355', '-0.306', '-0.248', '-0.183', '-0.109', '-0.039', '0', '0.039', '0.109', '0.183', '0.248', '0.306', '0.355', '0.407', '0.439', '0.456', '0.468', '0.468', '0.456', '0.439', '0.407', '0.355', '0.306', '0.248', '0.183', '0.109', '0.279', '-0.374', '-0.268', '-0.637', '-1.026', '-0.103', '1.874', '0.12', '-2.68', '-0.546', '3.239', '0', '-3.702', '-0.401', '4.103', '0', '-4.459', '-0.312', '4.771', '0', '-5.047', '-0.233', '5.28', '0', '-5.47', '-0.14', '5.61', '0', '-5.684', '-0.016', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.691', '-0.064', '-5.627', '0', '5.496', '-0.183', '-5.313', '0', '5.086', '-0.268', '-4.818', '0', '4.513', '-0.352', '-4.161', '0', '3.765', '-0.45', '-3.315', '0.006', '2.78', '-0.665', '-2.016', '-0.338'];
                relative_pos_z = ['null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
                layerStatus = ['LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
            }
            if (nozzle_size === 0.6) {
                GStatus = ['null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1'];
                EStatus = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                relative_pos_x = ['null',	'-0.515',	'-31.936',	'-0.515',	'-0.477',	'-0.442',	'-0.418',	'-0.369',	'-0.316',	'-0.257',	'-0.183',	'-0.115',	'-0.037',	'0.037',	'0.115',	'0.183',	'0.257',	'0.316',	'0.369',	'0.418',	'0.442',	'0.477',	'0.515',	'31.936',	'0.515',	'0.477',	'0.442',	'0.418',	'0.369',	'0.316',	'0.257',	'0.183',	'0.115',	'0.037',	'-0.037',	'-0.115',	'-0.183',	'-0.257',	'-0.316',	'-0.369',	'-0.418',	'-0.442',	'-0.477',	'0.093',	'-0.586',	'-31.98',	'-0.586',	'-0.569',	'-0.532',	'-0.498',	'-0.44',	'-0.376',	'-0.306',	'-0.22',	'-0.137',	'-0.045',	'0.045',	'0.137',	'0.22',	'0.306',	'0.376',	'0.44',	'0.498',	'0.532',	'0.569',	'0.586',	'31.98',	'0.586',	'0.569',	'0.532',	'0.498',	'0.44',	'0.376',	'0.306',	'0.22',	'0.137',	'0.045',	'-0.045',	'-0.137',	'-0.22',	'-0.306',	'-0.376',	'-0.44',	'-0.498',	'-0.532',	'-0.569',	'-0.103',	'-0.087',	'-0.438',	'-31.896',	'-0.438',	'-0.393',	'-0.352',	'-0.342',	'-0.297',	'-0.256',	'-0.21',	'-0.145',	'-0.095',	'-0.029',	'0.029',	'0.095',	'0.145',	'0.21',	'0.256',	'0.297',	'0.342',	'0.352',	'0.393',	'0.438',	'31.896',	'0.438',	'0.393',	'0.352',	'0.342',	'0.297',	'0.256',	'0.21',	'0.145',	'0.095',	'0.029',	'-0.029',	'-0.095',	'-0.145',	'-0.21',	'-0.256',	'-0.297',	'-0.342',	'-0.352',	'-0.393',	'null',	'1.824',	'null',	'-1.754',	'-0.907',	'2.674',	'-0.214',	'-3.309',	'-0.848',	'3.804',	'-0.466',	'-4.187',	'-0.848',	'4.445',	'-0.755',	'-4.539',	'-0.848',	'4.538',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.849',	'-4.538',	'-0.849',	'4.539',	'-0.849',	'-4.538',	'-0.849',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.755',	'4.446',	'-0.849',	'-4.186',	'-0.467',	'3.805',	'-0.849',	'-3.309',	'-0.214',	'2.674',	'-0.907',	'-1.754',	'null',	'0',	'34.695',	'null',	'null',	'-0.515',	'-31.936',	'-0.515',	'-0.477',	'-0.442',	'-0.418',	'-0.369',	'-0.316',	'-0.257',	'-0.183',	'-0.115',	'-0.037',	'0.037',	'0.115',	'0.183',	'0.257',	'0.316',	'0.369',	'0.418',	'0.442',	'0.477',	'0.515',	'31.936',	'0.515',	'0.477',	'0.442',	'0.418',	'0.369',	'0.316',	'0.257',	'0.183',	'0.115',	'0.037',	'-0.037',	'-0.115',	'-0.183',	'-0.257',	'-0.316',	'-0.369',	'-0.418',	'-0.442',	'-0.477',	'0.093',	'-0.586',	'-31.98',	'-0.586',	'-0.569',	'-0.532',	'-0.498',	'-0.44',	'-0.376',	'-0.306',	'-0.22',	'-0.137',	'-0.045',	'0.045',	'0.137',	'0.22',	'0.306',	'0.376',	'0.44',	'0.498',	'0.532',	'0.569',	'0.586',	'31.98',	'0.586',	'0.569',	'0.532',	'0.498',	'0.44',	'0.376',	'0.306',	'0.22',	'0.137',	'0.045',	'-0.045',	'-0.137',	'-0.22',	'-0.306',	'-0.376',	'-0.44',	'-0.498',	'-0.532',	'-0.569',	'-0.103',	'-0.087',	'-0.438',	'-31.896',	'-0.438',	'-0.393',	'-0.352',	'-0.342',	'-0.297',	'-0.256',	'-0.21',	'-0.145',	'-0.095',	'-0.029',	'0.029',	'0.095',	'0.145',	'0.21',	'0.256',	'0.297',	'0.342',	'0.352',	'0.393',	'0.438',	'31.896',	'0.438',	'0.393',	'0.352',	'0.342',	'0.297',	'0.256',	'0.21',	'0.145',	'0.095',	'0.029',	'-0.029',	'-0.095',	'-0.145',	'-0.21',	'-0.256',	'-0.297',	'-0.342',	'-0.352',	'-0.393',	'null',	'1.81',	'null',	'-1.685',	'-0.92',	'2.639',	'-0.206',	'-3.281',	'-0.849',	'3.781',	'-0.458',	'-4.171',	'-0.849',	'4.439',	'-0.747',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.849',	'-4.54',	'-0.848',	'4.54',	'-0.849',	'-4.54',	'-0.848',	'4.54',	'-0.849',	'-4.54',	'-0.848',	'4.54',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.54',	'-0.848',	'-4.54',	'-0.763',	'4.454',	'-0.848',	'-4.205',	'-0.471',	'3.827',	'-0.848',	'-3.336',	'-0.222',	'2.709',	'-0.893',	'-1.825',	'null',	'0',	'34.708',	'null',	'null',	'-0.515',	'-31.936',	'-0.515',	'-0.477',	'-0.442',	'-0.418',	'-0.369',	'-0.316',	'-0.257',	'-0.183',	'-0.115',	'-0.037',	'0.037',	'0.115',	'0.183',	'0.257',	'0.316',	'0.369',	'0.418',	'0.442',	'0.477',	'0.515',	'31.936',	'0.515',	'0.477',	'0.442',	'0.418',	'0.369',	'0.316',	'0.257',	'0.183',	'0.115',	'0.037',	'-0.037',	'-0.115',	'-0.183',	'-0.257',	'-0.316',	'-0.369',	'-0.418',	'-0.442',	'-0.477',	'0.093',	'-0.586',	'-31.98',	'-0.586',	'-0.569',	'-0.532',	'-0.498',	'-0.44',	'-0.376',	'-0.306',	'-0.22',	'-0.137',	'-0.045',	'0.045',	'0.137',	'0.22',	'0.306',	'0.376',	'0.44',	'0.498',	'0.532',	'0.569',	'0.586',	'31.98',	'0.586',	'0.569',	'0.532',	'0.498',	'0.44',	'0.376',	'0.306',	'0.22',	'0.137',	'0.045',	'-0.045',	'-0.137',	'-0.22',	'-0.306',	'-0.376',	'-0.44',	'-0.498',	'-0.532',	'-0.569',	'-0.103',	'-0.087',	'-0.438',	'-31.896',	'-0.438',	'-0.393',	'-0.352',	'-0.342',	'-0.297',	'-0.256',	'-0.21',	'-0.145',	'-0.095',	'-0.029',	'0.029',	'0.095',	'0.145',	'0.21',	'0.256',	'0.297',	'0.342',	'0.352',	'0.393',	'0.438',	'31.896',	'0.438',	'0.393',	'0.352',	'0.342',	'0.297',	'0.256',	'0.21',	'0.145',	'0.095',	'0.029',	'-0.029',	'-0.095',	'-0.145',	'-0.21',	'-0.256',	'-0.297',	'-0.342',	'-0.352',	'-0.393',	'null',	'1.824',	'null',	'-1.754',	'-0.907',	'2.674',	'-0.214',	'-3.309',	'-0.848',	'3.804',	'-0.466',	'-4.187',	'-0.848',	'4.445',	'-0.755',	'-4.539',	'-0.848',	'4.538',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.849',	'-4.538',	'-0.849',	'4.539',	'-0.849',	'-4.538',	'-0.849',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.755',	'4.446',	'-0.849',	'-4.186',	'-0.467',	'3.805',	'-0.849',	'-3.309',	'-0.214',	'2.674',	'-0.907',	'-1.754',	'null',	'0',	'34.695',	'null',	'null',	'-0.515',	'-31.936',	'-0.515',	'-0.477',	'-0.442',	'-0.418',	'-0.369',	'-0.316',	'-0.257',	'-0.183',	'-0.115',	'-0.037',	'0.037',	'0.115',	'0.183',	'0.257',	'0.316',	'0.369',	'0.418',	'0.442',	'0.477',	'0.515',	'31.936',	'0.515',	'0.477',	'0.442',	'0.418',	'0.369',	'0.316',	'0.257',	'0.183',	'0.115',	'0.037',	'-0.037',	'-0.115',	'-0.183',	'-0.257',	'-0.316',	'-0.369',	'-0.418',	'-0.442',	'-0.477',	'0.093',	'-0.586',	'-31.98',	'-0.586',	'-0.569',	'-0.532',	'-0.498',	'-0.44',	'-0.376',	'-0.306',	'-0.22',	'-0.137',	'-0.045',	'0.045',	'0.137',	'0.22',	'0.306',	'0.376',	'0.44',	'0.498',	'0.532',	'0.569',	'0.586',	'31.98',	'0.586',	'0.569',	'0.532',	'0.498',	'0.44',	'0.376',	'0.306',	'0.22',	'0.137',	'0.045',	'-0.045',	'-0.137',	'-0.22',	'-0.306',	'-0.376',	'-0.44',	'-0.498',	'-0.532',	'-0.569',	'-0.103',	'-0.087',	'-0.438',	'-31.896',	'-0.438',	'-0.393',	'-0.352',	'-0.342',	'-0.297',	'-0.256',	'-0.21',	'-0.145',	'-0.095',	'-0.029',	'0.029',	'0.095',	'0.145',	'0.21',	'0.256',	'0.297',	'0.342',	'0.352',	'0.393',	'0.438',	'31.896',	'0.438',	'0.393',	'0.352',	'0.342',	'0.297',	'0.256',	'0.21',	'0.145',	'0.095',	'0.029',	'-0.029',	'-0.095',	'-0.145',	'-0.21',	'-0.256',	'-0.297',	'-0.342',	'-0.352',	'-0.393',	'null',	'1.81',	'null',	'-1.685',	'-0.92',	'2.639',	'-0.206',	'-3.281',	'-0.849',	'3.781',	'-0.458',	'-4.171',	'-0.849',	'4.439',	'-0.747',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.849',	'-4.54',	'-0.848',	'4.54',	'-0.849',	'-4.54',	'-0.848',	'4.54',	'-0.849',	'-4.54',	'-0.848',	'4.54',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.54',	'-0.848',	'-4.54',	'-0.763',	'4.454',	'-0.848',	'-4.205',	'-0.471',	'3.827',	'-0.848',	'-3.336',	'-0.222',	'2.709',	'-0.893',	'-1.825',	'null',	'0',	'34.708',	'null',	'null',	'-0.515',	'-31.936',	'-0.515',	'-0.477',	'-0.442',	'-0.418',	'-0.369',	'-0.316',	'-0.257',	'-0.183',	'-0.115',	'-0.037',	'0.037',	'0.115',	'0.183',	'0.257',	'0.316',	'0.369',	'0.418',	'0.442',	'0.477',	'0.515',	'31.936',	'0.515',	'0.477',	'0.442',	'0.418',	'0.369',	'0.316',	'0.257',	'0.183',	'0.115',	'0.037',	'-0.037',	'-0.115',	'-0.183',	'-0.257',	'-0.316',	'-0.369',	'-0.418',	'-0.442',	'-0.477',	'0.093',	'-0.586',	'-31.98',	'-0.586',	'-0.569',	'-0.532',	'-0.498',	'-0.44',	'-0.376',	'-0.306',	'-0.22',	'-0.137',	'-0.045',	'0.045',	'0.137',	'0.22',	'0.306',	'0.376',	'0.44',	'0.498',	'0.532',	'0.569',	'0.586',	'31.98',	'0.586',	'0.569',	'0.532',	'0.498',	'0.44',	'0.376',	'0.306',	'0.22',	'0.137',	'0.045',	'-0.045',	'-0.137',	'-0.22',	'-0.306',	'-0.376',	'-0.44',	'-0.498',	'-0.532',	'-0.569',	'-0.103',	'-0.087',	'-0.438',	'-31.896',	'-0.438',	'-0.393',	'-0.352',	'-0.342',	'-0.297',	'-0.256',	'-0.21',	'-0.145',	'-0.095',	'-0.029',	'0.029',	'0.095',	'0.145',	'0.21',	'0.256',	'0.297',	'0.342',	'0.352',	'0.393',	'0.438',	'31.896',	'0.438',	'0.393',	'0.352',	'0.342',	'0.297',	'0.256',	'0.21',	'0.145',	'0.095',	'0.029',	'-0.029',	'-0.095',	'-0.145',	'-0.21',	'-0.256',	'-0.297',	'-0.342',	'-0.352',	'-0.393',	'null',	'1.824',	'null',	'-1.754',	'-0.907',	'2.674',	'-0.214',	'-3.309',	'-0.848',	'3.804',	'-0.466',	'-4.187',	'-0.848',	'4.445',	'-0.755',	'-4.539',	'-0.848',	'4.538',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.848',	'-4.539',	'-0.849',	'4.539',	'-0.849',	'-4.538',	'-0.849',	'4.539',	'-0.849',	'-4.538',	'-0.849',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.848',	'4.539',	'-0.849',	'-4.539',	'-0.755',	'4.446',	'-0.849',	'-4.186',	'-0.467',	'3.805',	'-0.849',	'-3.309',	'-0.214',	'2.674',	'-0.907',	'-1.754',	'null',	'0',	'34.695',	'null',	'null',	'-0.515',	'-31.936',	'-0.515',	'-0.477',	'-0.442',	'-0.418',	'-0.369',	'-0.316',	'-0.257',	'-0.183',	'-0.115',	'-0.037',	'0.037',	'0.115',	'0.183',	'0.257',	'0.316',	'0.369',	'0.418',	'0.442',	'0.477',	'0.515',	'31.936',	'0.515',	'0.477',	'0.442',	'0.418',	'0.369',	'0.316',	'0.257',	'0.183',	'0.115',	'0.037',	'-0.037',	'-0.115',	'-0.183',	'-0.257',	'-0.316',	'-0.369',	'-0.418',	'-0.442',	'-0.477',	'0.093',	'-0.586',	'-31.98',	'-0.586',	'-0.569',	'-0.532',	'-0.498',	'-0.44',	'-0.376',	'-0.306',	'-0.22',	'-0.137',	'-0.045',	'0.045',	'0.137',	'0.22',	'0.306',	'0.376',	'0.44',	'0.498',	'0.532',	'0.569',	'0.586',	'31.98',	'0.586',	'0.569',	'0.532',	'0.498',	'0.44',	'0.376',	'0.306',	'0.22',	'0.137',	'0.045',	'-0.045',	'-0.137',	'-0.22',	'-0.306',	'-0.376',	'-0.44',	'-0.498',	'-0.532',	'-0.569',	'-0.103',	'-0.087',	'-0.438',	'-31.896',	'-0.438',	'-0.393',	'-0.352',	'-0.342',	'-0.297',	'-0.256',	'-0.21',	'-0.145',	'-0.095',	'-0.029',	'0.029',	'0.095',	'0.145',	'0.21',	'0.256',	'0.297',	'0.342',	'0.352',	'0.393',	'0.438',	'31.896',	'0.438',	'0.393',	'0.352',	'0.342',	'0.297',	'0.256',	'0.21',	'0.145',	'0.095',	'0.029',	'-0.029',	'-0.095',	'-0.145',	'-0.21',	'-0.256',	'-0.297',	'-0.342',	'-0.352',	'-0.393',	'null',	'1.81',	'null',	'-1.685',	'-0.92',	'2.639',	'-0.206',	'-3.281',	'-0.849',	'3.781',	'-0.458',	'-4.171',	'-0.849',	'4.439',	'-0.747',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.848',	'-4.541',	'-0.848',	'4.54',	'-0.849',	'-4.54',	'-0.848',	'4.54',	'-0.849',	'-4.54',	'-0.848',	'4.54',	'-0.849',	'-4.54',	'-0.848',	'4.54',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.541',	'-0.849',	'-4.54',	'-0.849',	'4.54',	'-0.848',	'-4.54',	'-0.763',	'4.454',	'-0.848',	'-4.205',	'-0.471',	'3.827',	'-0.848',	'-3.336',	'-0.222',	'2.709',	'-0.893',	'-1.825'];
                relative_pos_y = ['null',	'0.04',	'0',	'-0.04',	'-0.115',	'-0.183',	'-0.257',	'-0.316',	'-0.369',	'-0.418',	'-0.442',	'-0.476',	'-0.484',	'-0.484',	'-0.476',	'-0.442',	'-0.418',	'-0.369',	'-0.316',	'-0.257',	'-0.183',	'-0.115',	'-0.04',	'0',	'0.04',	'0.115',	'0.183',	'0.257',	'0.316',	'0.369',	'0.418',	'0.442',	'0.476',	'0.484',	'0.484',	'0.476',	'0.442',	'0.418',	'0.369',	'0.316',	'0.257',	'0.183',	'0.115',	'0.594',	'0.046',	'0',	'-0.046',	'-0.137',	'-0.22',	'-0.306',	'-0.376',	'-0.44',	'-0.498',	'-0.532',	'-0.569',	'-0.576',	'-0.576',	'-0.569',	'-0.532',	'-0.498',	'-0.44',	'-0.376',	'-0.306',	'-0.22',	'-0.137',	'-0.046',	'0',	'0.046',	'0.137',	'0.22',	'0.306',	'0.376',	'0.44',	'0.498',	'0.532',	'0.569',	'0.576',	'0.576',	'0.569',	'0.532',	'0.498',	'0.44',	'0.376',	'0.306',	'0.22',	'0.137',	'-0.651',	'-0.527',	'0.034',	'0',	'-0.034',	'-0.095',	'-0.145',	'-0.21',	'-0.256',	'-0.297',	'-0.342',	'-0.352',	'-0.391',	'-0.388',	'-0.388',	'-0.391',	'-0.352',	'-0.342',	'-0.297',	'-0.256',	'-0.21',	'-0.145',	'-0.095',	'-0.034',	'0',	'0.034',	'0.095',	'0.145',	'0.21',	'0.256',	'0.297',	'0.342',	'0.352',	'0.391',	'0.388',	'0.388',	'0.391',	'0.352',	'0.342',	'0.297',	'0.256',	'0.21',	'0.145',	'0.095',	'null',	'-2.933',	'null',	'-1.755',	'-0.058',	'2.674',	'0.635',	'-3.309',	'0',	'3.804',	'0.382',	'-4.186',	'0',	'4.445',	'0.094',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0.093',	'4.446',	'0',	'-4.187',	'0.382',	'3.805',	'0',	'-3.31',	'0.635',	'2.675',	'-0.059',	'-1.754',	'null',	'0',	'2.604',	'null',	'null',	'0.04',	'0',	'-0.04',	'-0.115',	'-0.183',	'-0.257',	'-0.316',	'-0.369',	'-0.418',	'-0.442',	'-0.476',	'-0.484',	'-0.484',	'-0.476',	'-0.442',	'-0.418',	'-0.369',	'-0.316',	'-0.257',	'-0.183',	'-0.115',	'-0.04',	'0',	'0.04',	'0.115',	'0.183',	'0.257',	'0.316',	'0.369',	'0.418',	'0.442',	'0.476',	'0.484',	'0.484',	'0.476',	'0.442',	'0.418',	'0.369',	'0.316',	'0.257',	'0.183',	'0.115',	'0.594',	'0.046',	'0',	'-0.046',	'-0.137',	'-0.22',	'-0.306',	'-0.376',	'-0.44',	'-0.498',	'-0.532',	'-0.569',	'-0.576',	'-0.576',	'-0.569',	'-0.532',	'-0.498',	'-0.44',	'-0.376',	'-0.306',	'-0.22',	'-0.137',	'-0.046',	'0',	'0.046',	'0.137',	'0.22',	'0.306',	'0.376',	'0.44',	'0.498',	'0.532',	'0.569',	'0.576',	'0.576',	'0.569',	'0.532',	'0.498',	'0.44',	'0.376',	'0.306',	'0.22',	'0.137',	'-0.651',	'-0.527',	'0.034',	'0',	'-0.034',	'-0.095',	'-0.145',	'-0.21',	'-0.256',	'-0.297',	'-0.342',	'-0.352',	'-0.391',	'-0.388',	'-0.388',	'-0.391',	'-0.352',	'-0.342',	'-0.297',	'-0.256',	'-0.21',	'-0.145',	'-0.095',	'-0.034',	'0',	'0.034',	'0.095',	'0.145',	'0.21',	'0.256',	'0.297',	'0.342',	'0.352',	'0.391',	'0.388',	'0.388',	'0.391',	'0.352',	'0.342',	'0.297',	'0.256',	'0.21',	'0.145',	'0.095',	'null',	'-1.963',	'null',	'1.685',	'0.071',	'-2.639',	'-0.642',	'3.281',	'0',	'-3.781',	'-0.39',	'4.171',	'0',	'-4.438',	'-0.102',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'-0.085',	'-4.455',	'0',	'4.204',	'-0.377',	'-3.827',	'0',	'3.336',	'-0.627',	'-2.709',	'0.044',	'1.826',	'null',	'0',	'3.461',	'null',	'null',	'0.04',	'0',	'-0.04',	'-0.115',	'-0.183',	'-0.257',	'-0.316',	'-0.369',	'-0.418',	'-0.442',	'-0.476',	'-0.484',	'-0.484',	'-0.476',	'-0.442',	'-0.418',	'-0.369',	'-0.316',	'-0.257',	'-0.183',	'-0.115',	'-0.04',	'0',	'0.04',	'0.115',	'0.183',	'0.257',	'0.316',	'0.369',	'0.418',	'0.442',	'0.476',	'0.484',	'0.484',	'0.476',	'0.442',	'0.418',	'0.369',	'0.316',	'0.257',	'0.183',	'0.115',	'0.594',	'0.046',	'0',	'-0.046',	'-0.137',	'-0.22',	'-0.306',	'-0.376',	'-0.44',	'-0.498',	'-0.532',	'-0.569',	'-0.576',	'-0.576',	'-0.569',	'-0.532',	'-0.498',	'-0.44',	'-0.376',	'-0.306',	'-0.22',	'-0.137',	'-0.046',	'0',	'0.046',	'0.137',	'0.22',	'0.306',	'0.376',	'0.44',	'0.498',	'0.532',	'0.569',	'0.576',	'0.576',	'0.569',	'0.532',	'0.498',	'0.44',	'0.376',	'0.306',	'0.22',	'0.137',	'-0.651',	'-0.527',	'0.034',	'0',	'-0.034',	'-0.095',	'-0.145',	'-0.21',	'-0.256',	'-0.297',	'-0.342',	'-0.352',	'-0.391',	'-0.388',	'-0.388',	'-0.391',	'-0.352',	'-0.342',	'-0.297',	'-0.256',	'-0.21',	'-0.145',	'-0.095',	'-0.034',	'0',	'0.034',	'0.095',	'0.145',	'0.21',	'0.256',	'0.297',	'0.342',	'0.352',	'0.391',	'0.388',	'0.388',	'0.391',	'0.352',	'0.342',	'0.297',	'0.256',	'0.21',	'0.145',	'0.095',	'null',	'-2.933',	'null',	'-1.755',	'-0.058',	'2.674',	'0.635',	'-3.309',	'0',	'3.804',	'0.382',	'-4.186',	'0',	'4.445',	'0.094',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0.093',	'4.446',	'0',	'-4.187',	'0.382',	'3.805',	'0',	'-3.31',	'0.635',	'2.675',	'-0.059',	'-1.754',	'null',	'0',	'2.604',	'null',	'null',	'0.04',	'0',	'-0.04',	'-0.115',	'-0.183',	'-0.257',	'-0.316',	'-0.369',	'-0.418',	'-0.442',	'-0.476',	'-0.484',	'-0.484',	'-0.476',	'-0.442',	'-0.418',	'-0.369',	'-0.316',	'-0.257',	'-0.183',	'-0.115',	'-0.04',	'0',	'0.04',	'0.115',	'0.183',	'0.257',	'0.316',	'0.369',	'0.418',	'0.442',	'0.476',	'0.484',	'0.484',	'0.476',	'0.442',	'0.418',	'0.369',	'0.316',	'0.257',	'0.183',	'0.115',	'0.594',	'0.046',	'0',	'-0.046',	'-0.137',	'-0.22',	'-0.306',	'-0.376',	'-0.44',	'-0.498',	'-0.532',	'-0.569',	'-0.576',	'-0.576',	'-0.569',	'-0.532',	'-0.498',	'-0.44',	'-0.376',	'-0.306',	'-0.22',	'-0.137',	'-0.046',	'0',	'0.046',	'0.137',	'0.22',	'0.306',	'0.376',	'0.44',	'0.498',	'0.532',	'0.569',	'0.576',	'0.576',	'0.569',	'0.532',	'0.498',	'0.44',	'0.376',	'0.306',	'0.22',	'0.137',	'-0.651',	'-0.527',	'0.034',	'0',	'-0.034',	'-0.095',	'-0.145',	'-0.21',	'-0.256',	'-0.297',	'-0.342',	'-0.352',	'-0.391',	'-0.388',	'-0.388',	'-0.391',	'-0.352',	'-0.342',	'-0.297',	'-0.256',	'-0.21',	'-0.145',	'-0.095',	'-0.034',	'0',	'0.034',	'0.095',	'0.145',	'0.21',	'0.256',	'0.297',	'0.342',	'0.352',	'0.391',	'0.388',	'0.388',	'0.391',	'0.352',	'0.342',	'0.297',	'0.256',	'0.21',	'0.145',	'0.095',	'null',	'-1.963',	'null',	'1.685',	'0.071',	'-2.639',	'-0.642',	'3.281',	'0',	'-3.781',	'-0.39',	'4.171',	'0',	'-4.438',	'-0.102',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'-0.085',	'-4.455',	'0',	'4.204',	'-0.377',	'-3.827',	'0',	'3.336',	'-0.627',	'-2.709',	'0.044',	'1.826',	'null',	'0',	'3.461',	'null',	'null',	'0.04',	'0',	'-0.04',	'-0.115',	'-0.183',	'-0.257',	'-0.316',	'-0.369',	'-0.418',	'-0.442',	'-0.476',	'-0.484',	'-0.484',	'-0.476',	'-0.442',	'-0.418',	'-0.369',	'-0.316',	'-0.257',	'-0.183',	'-0.115',	'-0.04',	'0',	'0.04',	'0.115',	'0.183',	'0.257',	'0.316',	'0.369',	'0.418',	'0.442',	'0.476',	'0.484',	'0.484',	'0.476',	'0.442',	'0.418',	'0.369',	'0.316',	'0.257',	'0.183',	'0.115',	'0.594',	'0.046',	'0',	'-0.046',	'-0.137',	'-0.22',	'-0.306',	'-0.376',	'-0.44',	'-0.498',	'-0.532',	'-0.569',	'-0.576',	'-0.576',	'-0.569',	'-0.532',	'-0.498',	'-0.44',	'-0.376',	'-0.306',	'-0.22',	'-0.137',	'-0.046',	'0',	'0.046',	'0.137',	'0.22',	'0.306',	'0.376',	'0.44',	'0.498',	'0.532',	'0.569',	'0.576',	'0.576',	'0.569',	'0.532',	'0.498',	'0.44',	'0.376',	'0.306',	'0.22',	'0.137',	'-0.651',	'-0.527',	'0.034',	'0',	'-0.034',	'-0.095',	'-0.145',	'-0.21',	'-0.256',	'-0.297',	'-0.342',	'-0.352',	'-0.391',	'-0.388',	'-0.388',	'-0.391',	'-0.352',	'-0.342',	'-0.297',	'-0.256',	'-0.21',	'-0.145',	'-0.095',	'-0.034',	'0',	'0.034',	'0.095',	'0.145',	'0.21',	'0.256',	'0.297',	'0.342',	'0.352',	'0.391',	'0.388',	'0.388',	'0.391',	'0.352',	'0.342',	'0.297',	'0.256',	'0.21',	'0.145',	'0.095',	'null',	'-2.933',	'null',	'-1.755',	'-0.058',	'2.674',	'0.635',	'-3.309',	'0',	'3.804',	'0.382',	'-4.186',	'0',	'4.445',	'0.094',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0',	'4.539',	'0',	'-4.539',	'0.093',	'4.446',	'0',	'-4.187',	'0.382',	'3.805',	'0',	'-3.31',	'0.635',	'2.675',	'-0.059',	'-1.754',	'null',	'0',	'2.604',	'null',	'null',	'0.04',	'0',	'-0.04',	'-0.115',	'-0.183',	'-0.257',	'-0.316',	'-0.369',	'-0.418',	'-0.442',	'-0.476',	'-0.484',	'-0.484',	'-0.476',	'-0.442',	'-0.418',	'-0.369',	'-0.316',	'-0.257',	'-0.183',	'-0.115',	'-0.04',	'0',	'0.04',	'0.115',	'0.183',	'0.257',	'0.316',	'0.369',	'0.418',	'0.442',	'0.476',	'0.484',	'0.484',	'0.476',	'0.442',	'0.418',	'0.369',	'0.316',	'0.257',	'0.183',	'0.115',	'0.594',	'0.046',	'0',	'-0.046',	'-0.137',	'-0.22',	'-0.306',	'-0.376',	'-0.44',	'-0.498',	'-0.532',	'-0.569',	'-0.576',	'-0.576',	'-0.569',	'-0.532',	'-0.498',	'-0.44',	'-0.376',	'-0.306',	'-0.22',	'-0.137',	'-0.046',	'0',	'0.046',	'0.137',	'0.22',	'0.306',	'0.376',	'0.44',	'0.498',	'0.532',	'0.569',	'0.576',	'0.576',	'0.569',	'0.532',	'0.498',	'0.44',	'0.376',	'0.306',	'0.22',	'0.137',	'-0.651',	'-0.527',	'0.034',	'0',	'-0.034',	'-0.095',	'-0.145',	'-0.21',	'-0.256',	'-0.297',	'-0.342',	'-0.352',	'-0.391',	'-0.388',	'-0.388',	'-0.391',	'-0.352',	'-0.342',	'-0.297',	'-0.256',	'-0.21',	'-0.145',	'-0.095',	'-0.034',	'0',	'0.034',	'0.095',	'0.145',	'0.21',	'0.256',	'0.297',	'0.342',	'0.352',	'0.391',	'0.388',	'0.388',	'0.391',	'0.352',	'0.342',	'0.297',	'0.256',	'0.21',	'0.145',	'0.095',	'null',	'-1.963',	'null',	'1.685',	'0.071',	'-2.639',	'-0.642',	'3.281',	'0',	'-3.781',	'-0.39',	'4.171',	'0',	'-4.438',	'-0.102',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'0',	'-4.54',	'0',	'4.54',	'-0.085',	'-4.455',	'0',	'4.204',	'-0.377',	'-3.827',	'0',	'3.336',	'-0.627',	'-2.709',	'0.044',	'1.826'];
                relative_pos_z = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                layerStatus = ['LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
            }
            if (nozzle_size === 0.8) {
                GStatus = ['null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1'];
                EStatus = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                relative_pos_x = ['null',	'-0.497',	'-31.888',	'-0.497',	'-0.42',	'-0.416',	'-0.363',	'-0.337',	'-0.288',	'-0.223',	'-0.172',	'-0.102',	'-0.035',	'0.035',	'0.102',	'0.172',	'0.223',	'0.288',	'0.337',	'0.363',	'0.416',	'0.42',	'0.497',	'31.888',	'0.497',	'0.42',	'0.416',	'0.363',	'0.337',	'0.288',	'0.223',	'0.172',	'0.102',	'0.035',	'-0.035',	'-0.102',	'-0.172',	'-0.223',	'-0.288',	'-0.337',	'-0.363',	'-0.416',	'-0.42',	'0.122',	'-0.581',	'-31.964',	'-0.581',	'-0.548',	'-0.525',	'-0.479',	'-0.429',	'-0.368',	'-0.293',	'-0.218',	'-0.131',	'-0.045',	'0.045',	'0.131',	'0.218',	'0.293',	'0.368',	'0.429',	'0.479',	'0.525',	'0.548',	'0.581',	'31.964',	'0.581',	'0.548',	'0.525',	'0.479',	'0.429',	'0.368',	'0.293',	'0.218',	'0.131',	'0.045',	'-0.045',	'-0.131',	'-0.218',	'-0.293',	'-0.368',	'-0.429',	'-0.479',	'-0.525',	'-0.548',	'-0.137',	'-0.106',	'-0.412',	'-31.816',	'-0.412',	'-0.291',	'-0.309',	'-0.256',	'-0.24',	'-0.207',	'-0.16',	'-0.124',	'-0.071',	'-0.026',	'0.026',	'0.071',	'0.124',	'0.16',	'0.207',	'0.24',	'0.256',	'0.309',	'0.291',	'0.412',	'31.816',	'0.412',	'0.291',	'0.309',	'0.256',	'0.24',	'0.207',	'0.16',	'0.124',	'0.071',	'0.026',	'-0.026',	'-0.071',	'-0.124',	'-0.16',	'-0.207',	'-0.24',	'-0.256',	'-0.309',	'-0.291',	'null',	'0.177',	'null',	'1.108',	'-0.038',	'-2.287',	'-1.131',	'2.953',	'-0.755',	'-3.33',	'-1.131',	'3.379',	'-1.131',	'-3.379',	'-1.132',	'3.379',	'-1.131',	'-3.379',	'-1.132',	'3.38',	'-1.132',	'-3.379',	'-1.131',	'3.379',	'-1.131',	'-3.38',	'-1.131',	'3.379',	'-1.131',	'-3.379',	'-1.132',	'3.379',	'-1.131',	'-3.379',	'-1.132',	'3.38',	'-1.132',	'-3.379',	'-1.131',	'3.379',	'-1.131',	'-3.38',	'-1.131',	'3.379',	'-1.131',	'-3.379',	'-1.132',	'3.379',	'-1.131',	'-3.379',	'-1.132',	'3.38',	'-1.132',	'-3.379',	'-1.131',	'3.379',	'-1.131',	'-3.38',	'-1.131',	'3.379',	'-1.131',	'-3.33',	'-0.754',	'2.953',	'-1.132',	'-2.287',	'-0.038',	'1.109',	'null',	'0',	'32.939',	'null',	'null',	'-0.497',	'-31.888',	'-0.497',	'-0.42',	'-0.416',	'-0.363',	'-0.337',	'-0.288',	'-0.223',	'-0.172',	'-0.102',	'-0.035',	'0.035',	'0.102',	'0.172',	'0.223',	'0.288',	'0.337',	'0.363',	'0.416',	'0.42',	'0.497',	'31.888',	'0.497',	'0.42',	'0.416',	'0.363',	'0.337',	'0.288',	'0.223',	'0.172',	'0.102',	'0.035',	'-0.035',	'-0.102',	'-0.172',	'-0.223',	'-0.288',	'-0.337',	'-0.363',	'-0.416',	'-0.42',	'0.122',	'-0.581',	'-31.964',	'-0.581',	'-0.548',	'-0.525',	'-0.479',	'-0.429',	'-0.368',	'-0.293',	'-0.218',	'-0.131',	'-0.045',	'0.045',	'0.131',	'0.218',	'0.293',	'0.368',	'0.429',	'0.479',	'0.525',	'0.548',	'0.581',	'31.964',	'0.581',	'0.548',	'0.525',	'0.479',	'0.429',	'0.368',	'0.293',	'0.218',	'0.131',	'0.045',	'-0.045',	'-0.131',	'-0.218',	'-0.293',	'-0.368',	'-0.429',	'-0.479',	'-0.525',	'-0.548',	'-0.137',	'-0.106',	'-0.412',	'-31.816',	'-0.412',	'-0.291',	'-0.309',	'-0.256',	'-0.24',	'-0.207',	'-0.16',	'-0.124',	'-0.071',	'-0.026',	'0.026',	'0.071',	'0.124',	'0.16',	'0.207',	'0.24',	'0.256',	'0.309',	'0.291',	'0.412',	'31.816',	'0.412',	'0.291',	'0.309',	'0.256',	'0.24',	'0.207',	'0.16',	'0.124',	'0.071',	'0.026',	'-0.026',	'-0.071',	'-0.124',	'-0.16',	'-0.207',	'-0.24',	'-0.256',	'-0.309',	'-0.291',	'null',	'1.32',	'null',	'-2.035',	'-1.131',	'2.79',	'-0.665',	'-3.256',	'-1.132',	'3.381',	'-1.132',	'-3.38',	'-1.132',	'3.381',	'-1.131',	'-3.381',	'-1.131',	'3.38',	'-1.131',	'-3.381',	'-1.131',	'3.381',	'-1.132',	'-3.38',	'-1.132',	'3.381',	'-1.131',	'-3.381',	'-1.132',	'3.381',	'-1.131',	'-3.381',	'-1.131',	'3.38',	'-1.131',	'-3.381',	'-1.131',	'3.381',	'-1.132',	'-3.38',	'-1.132',	'3.381',	'-1.131',	'-3.381',	'-1.132',	'3.381',	'-1.131',	'-3.381',	'-1.131',	'3.38',	'-1.131',	'-3.381',	'-1.131',	'3.381',	'-1.132',	'-3.38',	'-1.132',	'3.381',	'-1.131',	'-3.367',	'-0.861',	'3.096',	'-1.131',	'-2.511',	'-0.208',	'1.57',	'null',	'0',	'32.545',	'null',	'null',	'-0.497',	'-31.888',	'-0.497',	'-0.42',	'-0.416',	'-0.363',	'-0.337',	'-0.288',	'-0.223',	'-0.172',	'-0.102',	'-0.035',	'0.035',	'0.102',	'0.172',	'0.223',	'0.288',	'0.337',	'0.363',	'0.416',	'0.42',	'0.497',	'31.888',	'0.497',	'0.42',	'0.416',	'0.363',	'0.337',	'0.288',	'0.223',	'0.172',	'0.102',	'0.035',	'-0.035',	'-0.102',	'-0.172',	'-0.223',	'-0.288',	'-0.337',	'-0.363',	'-0.416',	'-0.42',	'0.122',	'-0.581',	'-31.964',	'-0.581',	'-0.548',	'-0.525',	'-0.479',	'-0.429',	'-0.368',	'-0.293',	'-0.218',	'-0.131',	'-0.045',	'0.045',	'0.131',	'0.218',	'0.293',	'0.368',	'0.429',	'0.479',	'0.525',	'0.548',	'0.581',	'31.964',	'0.581',	'0.548',	'0.525',	'0.479',	'0.429',	'0.368',	'0.293',	'0.218',	'0.131',	'0.045',	'-0.045',	'-0.131',	'-0.218',	'-0.293',	'-0.368',	'-0.429',	'-0.479',	'-0.525',	'-0.548',	'-0.137',	'-0.106',	'-0.412',	'-31.816',	'-0.412',	'-0.291',	'-0.309',	'-0.256',	'-0.24',	'-0.207',	'-0.16',	'-0.124',	'-0.071',	'-0.026',	'0.026',	'0.071',	'0.124',	'0.16',	'0.207',	'0.24',	'0.256',	'0.309',	'0.291',	'0.412',	'31.816',	'0.412',	'0.291',	'0.309',	'0.256',	'0.24',	'0.207',	'0.16',	'0.124',	'0.071',	'0.026',	'-0.026',	'-0.071',	'-0.124',	'-0.16',	'-0.207',	'-0.24',	'-0.256',	'-0.309',	'-0.291',	'null',	'0.177',	'null',	'1.108',	'-0.038',	'-2.287',	'-1.131',	'2.953',	'-0.755',	'-3.33',	'-1.131',	'3.379',	'-1.131',	'-3.379',	'-1.132',	'3.379',	'-1.131',	'-3.379',	'-1.132',	'3.38',	'-1.132',	'-3.379',	'-1.131',	'3.379',	'-1.131',	'-3.38',	'-1.131',	'3.379',	'-1.131',	'-3.379',	'-1.132',	'3.379',	'-1.131',	'-3.379',	'-1.132',	'3.38',	'-1.132',	'-3.379',	'-1.131',	'3.379',	'-1.131',	'-3.38',	'-1.131',	'3.379',	'-1.131',	'-3.379',	'-1.132',	'3.379',	'-1.131',	'-3.379',	'-1.132',	'3.38',	'-1.132',	'-3.379',	'-1.131',	'3.379',	'-1.131',	'-3.38',	'-1.131',	'3.379',	'-1.131',	'-3.33',	'-0.754',	'2.953',	'-1.132',	'-2.287',	'-0.038',	'1.109',	'null',	'0',	'32.939',	'null',	'null',	'-0.497',	'-31.888',	'-0.497',	'-0.42',	'-0.416',	'-0.363',	'-0.337',	'-0.288',	'-0.223',	'-0.172',	'-0.102',	'-0.035',	'0.035',	'0.102',	'0.172',	'0.223',	'0.288',	'0.337',	'0.363',	'0.416',	'0.42',	'0.497',	'31.888',	'0.497',	'0.42',	'0.416',	'0.363',	'0.337',	'0.288',	'0.223',	'0.172',	'0.102',	'0.035',	'-0.035',	'-0.102',	'-0.172',	'-0.223',	'-0.288',	'-0.337',	'-0.363',	'-0.416',	'-0.42',	'0.122',	'-0.581',	'-31.964',	'-0.581',	'-0.548',	'-0.525',	'-0.479',	'-0.429',	'-0.368',	'-0.293',	'-0.218',	'-0.131',	'-0.045',	'0.045',	'0.131',	'0.218',	'0.293',	'0.368',	'0.429',	'0.479',	'0.525',	'0.548',	'0.581',	'31.964',	'0.581',	'0.548',	'0.525',	'0.479',	'0.429',	'0.368',	'0.293',	'0.218',	'0.131',	'0.045',	'-0.045',	'-0.131',	'-0.218',	'-0.293',	'-0.368',	'-0.429',	'-0.479',	'-0.525',	'-0.548',	'-0.137',	'-0.106',	'-0.412',	'-31.816',	'-0.412',	'-0.291',	'-0.309',	'-0.256',	'-0.24',	'-0.207',	'-0.16',	'-0.124',	'-0.071',	'-0.026',	'0.026',	'0.071',	'0.124',	'0.16',	'0.207',	'0.24',	'0.256',	'0.309',	'0.291',	'0.412',	'31.816',	'0.412',	'0.291',	'0.309',	'0.256',	'0.24',	'0.207',	'0.16',	'0.124',	'0.071',	'0.026',	'-0.026',	'-0.071',	'-0.124',	'-0.16',	'-0.207',	'-0.24',	'-0.256',	'-0.309',	'-0.291',	'null',	'1.32',	'null',	'-2.035',	'-1.131',	'2.79',	'-0.665',	'-3.256',	'-1.132',	'3.381',	'-1.132',	'-3.38',	'-1.132',	'3.381',	'-1.131',	'-3.381',	'-1.131',	'3.38',	'-1.131',	'-3.381',	'-1.131',	'3.381',	'-1.132',	'-3.38',	'-1.132',	'3.381',	'-1.131',	'-3.381',	'-1.132',	'3.381',	'-1.131',	'-3.381',	'-1.131',	'3.38',	'-1.131',	'-3.381',	'-1.131',	'3.381',	'-1.132',	'-3.38',	'-1.132',	'3.381',	'-1.131',	'-3.381',	'-1.132',	'3.381',	'-1.131',	'-3.381',	'-1.131',	'3.38',	'-1.131',	'-3.381',	'-1.131',	'3.381',	'-1.132',	'-3.38',	'-1.132',	'3.381',	'-1.131',	'-3.367',	'-0.861',	'3.096',	'-1.131',	'-2.511',	'-0.208',	'1.57'];
                relative_pos_y = ['null',	'0.039',	'0',	'-0.039',	'-0.101',	'-0.172',	'-0.223',	'-0.288',	'-0.337',	'-0.363',	'-0.416',	'-0.426',	'-0.435',	'-0.435',	'-0.426',	'-0.416',	'-0.363',	'-0.337',	'-0.288',	'-0.223',	'-0.172',	'-0.101',	'-0.039',	'0',	'0.039',	'0.101',	'0.172',	'0.223',	'0.288',	'0.337',	'0.363',	'0.416',	'0.426',	'0.435',	'0.435',	'0.426',	'0.416',	'0.363',	'0.337',	'0.288',	'0.223',	'0.172',	'0.101',	'0.793',	'0.046',	'0',	'-0.046',	'-0.131',	'-0.218',	'-0.293',	'-0.368',	'-0.429',	'-0.479',	'-0.525',	'-0.548',	'-0.563',	'-0.563',	'-0.548',	'-0.525',	'-0.479',	'-0.429',	'-0.368',	'-0.293',	'-0.218',	'-0.131',	'-0.046',	'0',	'0.046',	'0.131',	'0.218',	'0.293',	'0.368',	'0.429',	'0.479',	'0.525',	'0.548',	'0.563',	'0.563',	'0.548',	'0.525',	'0.479',	'0.429',	'0.368',	'0.293',	'0.218',	'0.131',	'-0.869',	'-0.708',	'0.033',	'0',	'-0.033',	'-0.07',	'-0.127',	'-0.157',	'-0.207',	'-0.24',	'-0.262',	'-0.3',	'-0.297',	'-0.317',	'-0.317',	'-0.297',	'-0.3',	'-0.262',	'-0.24',	'-0.207',	'-0.157',	'-0.127',	'-0.07',	'-0.033',	'0',	'0.033',	'0.07',	'0.127',	'0.157',	'0.207',	'0.24',	'0.262',	'0.3',	'0.297',	'0.317',	'0.317',	'0.297',	'0.3',	'0.262',	'0.24',	'0.207',	'0.157',	'0.127',	'0.07',	'null',	'-3.582',	'null',	'1.108',	'1.093',	'-2.287',	'0',	'2.953',	'0.377',	'-3.33',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.33',	'0.377',	'2.953',	'0',	'-2.287',	'1.093',	'1.109',	'null',	'0',	'1.157',	'null',	'null',	'0.039',	'0',	'-0.039',	'-0.101',	'-0.172',	'-0.223',	'-0.288',	'-0.337',	'-0.363',	'-0.416',	'-0.426',	'-0.435',	'-0.435',	'-0.426',	'-0.416',	'-0.363',	'-0.337',	'-0.288',	'-0.223',	'-0.172',	'-0.101',	'-0.039',	'0',	'0.039',	'0.101',	'0.172',	'0.223',	'0.288',	'0.337',	'0.363',	'0.416',	'0.426',	'0.435',	'0.435',	'0.426',	'0.416',	'0.363',	'0.337',	'0.288',	'0.223',	'0.172',	'0.101',	'0.793',	'0.046',	'0',	'-0.046',	'-0.131',	'-0.218',	'-0.293',	'-0.368',	'-0.429',	'-0.479',	'-0.525',	'-0.548',	'-0.563',	'-0.563',	'-0.548',	'-0.525',	'-0.479',	'-0.429',	'-0.368',	'-0.293',	'-0.218',	'-0.131',	'-0.046',	'0',	'0.046',	'0.131',	'0.218',	'0.293',	'0.368',	'0.429',	'0.479',	'0.525',	'0.548',	'0.563',	'0.563',	'0.548',	'0.525',	'0.479',	'0.429',	'0.368',	'0.293',	'0.218',	'0.131',	'-0.869',	'-0.708',	'0.033',	'0',	'-0.033',	'-0.07',	'-0.127',	'-0.157',	'-0.207',	'-0.24',	'-0.262',	'-0.3',	'-0.297',	'-0.317',	'-0.317',	'-0.297',	'-0.3',	'-0.262',	'-0.24',	'-0.207',	'-0.157',	'-0.127',	'-0.07',	'-0.033',	'0',	'0.033',	'0.07',	'0.127',	'0.157',	'0.207',	'0.24',	'0.262',	'0.3',	'0.297',	'0.317',	'0.317',	'0.297',	'0.3',	'0.262',	'0.24',	'0.207',	'0.157',	'0.127',	'0.07',	'null',	'-2.323',	'null',	'2.035',	'0',	'-2.79',	'-0.466',	'3.256',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.366',	'-0.27',	'-3.096',	'0',	'2.511',	'-0.924',	'-1.57',	'null',	'0',	'4.435',	'null',	'null',	'0.039',	'0',	'-0.039',	'-0.101',	'-0.172',	'-0.223',	'-0.288',	'-0.337',	'-0.363',	'-0.416',	'-0.426',	'-0.435',	'-0.435',	'-0.426',	'-0.416',	'-0.363',	'-0.337',	'-0.288',	'-0.223',	'-0.172',	'-0.101',	'-0.039',	'0',	'0.039',	'0.101',	'0.172',	'0.223',	'0.288',	'0.337',	'0.363',	'0.416',	'0.426',	'0.435',	'0.435',	'0.426',	'0.416',	'0.363',	'0.337',	'0.288',	'0.223',	'0.172',	'0.101',	'0.793',	'0.046',	'0',	'-0.046',	'-0.131',	'-0.218',	'-0.293',	'-0.368',	'-0.429',	'-0.479',	'-0.525',	'-0.548',	'-0.563',	'-0.563',	'-0.548',	'-0.525',	'-0.479',	'-0.429',	'-0.368',	'-0.293',	'-0.218',	'-0.131',	'-0.046',	'0',	'0.046',	'0.131',	'0.218',	'0.293',	'0.368',	'0.429',	'0.479',	'0.525',	'0.548',	'0.563',	'0.563',	'0.548',	'0.525',	'0.479',	'0.429',	'0.368',	'0.293',	'0.218',	'0.131',	'-0.869',	'-0.708',	'0.033',	'0',	'-0.033',	'-0.07',	'-0.127',	'-0.157',	'-0.207',	'-0.24',	'-0.262',	'-0.3',	'-0.297',	'-0.317',	'-0.317',	'-0.297',	'-0.3',	'-0.262',	'-0.24',	'-0.207',	'-0.157',	'-0.127',	'-0.07',	'-0.033',	'0',	'0.033',	'0.07',	'0.127',	'0.157',	'0.207',	'0.24',	'0.262',	'0.3',	'0.297',	'0.317',	'0.317',	'0.297',	'0.3',	'0.262',	'0.24',	'0.207',	'0.157',	'0.127',	'0.07',	'null',	'-3.582',	'null',	'1.108',	'1.093',	'-2.287',	'0',	'2.953',	'0.377',	'-3.33',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.33',	'0.377',	'2.953',	'0',	'-2.287',	'1.093',	'1.109',	'null',	'0',	'1.157',	'null',	'null',	'0.039',	'0',	'-0.039',	'-0.101',	'-0.172',	'-0.223',	'-0.288',	'-0.337',	'-0.363',	'-0.416',	'-0.426',	'-0.435',	'-0.435',	'-0.426',	'-0.416',	'-0.363',	'-0.337',	'-0.288',	'-0.223',	'-0.172',	'-0.101',	'-0.039',	'0',	'0.039',	'0.101',	'0.172',	'0.223',	'0.288',	'0.337',	'0.363',	'0.416',	'0.426',	'0.435',	'0.435',	'0.426',	'0.416',	'0.363',	'0.337',	'0.288',	'0.223',	'0.172',	'0.101',	'0.793',	'0.046',	'0',	'-0.046',	'-0.131',	'-0.218',	'-0.293',	'-0.368',	'-0.429',	'-0.479',	'-0.525',	'-0.548',	'-0.563',	'-0.563',	'-0.548',	'-0.525',	'-0.479',	'-0.429',	'-0.368',	'-0.293',	'-0.218',	'-0.131',	'-0.046',	'0',	'0.046',	'0.131',	'0.218',	'0.293',	'0.368',	'0.429',	'0.479',	'0.525',	'0.548',	'0.563',	'0.563',	'0.548',	'0.525',	'0.479',	'0.429',	'0.368',	'0.293',	'0.218',	'0.131',	'-0.869',	'-0.708',	'0.033',	'0',	'-0.033',	'-0.07',	'-0.127',	'-0.157',	'-0.207',	'-0.24',	'-0.262',	'-0.3',	'-0.297',	'-0.317',	'-0.317',	'-0.297',	'-0.3',	'-0.262',	'-0.24',	'-0.207',	'-0.157',	'-0.127',	'-0.07',	'-0.033',	'0',	'0.033',	'0.07',	'0.127',	'0.157',	'0.207',	'0.24',	'0.262',	'0.3',	'0.297',	'0.317',	'0.317',	'0.297',	'0.3',	'0.262',	'0.24',	'0.207',	'0.157',	'0.127',	'0.07',	'null',	'-2.323',	'null',	'2.035',	'0',	'-2.79',	'-0.466',	'3.256',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.38',	'0',	'-3.38',	'0',	'3.366',	'-0.27',	'-3.096',	'0',	'2.511',	'-0.924',	'-1.57'];
                relative_pos_z = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                layerStatus = ['LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
            }
            return [GStatus, layerStatus, relative_pos_x, relative_pos_y, relative_pos_z, EStatus];
        }

        function retraTowerCoord(nozzle_size) {
            if (nozzle_size === 0.4) {
                GStatus = ['null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0'];
                layerStatus = ['LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
                relative_pos_x = ['null', '-0.152', '-0.17', '-0.165', '-0.164', '-0.12', '-0.143', '-0.147', '-0.129', '-0.116', '-0.111', '-0.091', '-0.08', '-0.055', '-0.051', '-0.017', '-0.005', '0.015', '0.034', '0.051', '0.075', '0.051', '0.128', '0.108', '0.131', '0.132', '0.164', '0.128', '0.175', '0.151', '0.177', '0.156', '0.173', '0.164', '0.094', '0.202', '0.086', '0.136', '0.103', '0.126', '0.085', '0.061', '0.036', '0.036', '0.015', '-0.007', '-0.027', '-0.037', '-0.062', '-0.077', '-0.091', '-0.111', '-0.118', '-0.091', '-0.145', '-0.189', '-0.147', '-0.175', '0.063', '-0.202', '-0.207', '-0.218', '-0.192', '-0.158', '-0.189', '-0.18', '-0.172', '-0.142', '-0.138', '-0.119', '-0.096', '-0.075', '-0.063', '-0.022', '-0.007', '0.02', '0.043', '0.064', '0.092', '0.071', '0.158', '0.143', '0.159', '0.174', '0.193', '0.183', '0.203', '0.21', '0.207', '0.212', '0.203', '0.209', '0.138', '0.231', '0.132', '0.159', '0.141', '0.154', '0.106', '0.079', '0.046', '0.045', '0.02', '-0.009', '-0.032', '-0.052', '-0.076', '-0.096', '-0.119', '-0.138', '-0.143', '-0.128', '-0.178', '-0.236', '-0.194', '-0.214', '-0.066', '-0.058', '-0.106', '-0.125', '-0.13', '-0.118', '-0.084', '-0.112', '-0.111', '-0.084', '-0.092', '-0.085', '-0.063', '-0.063', '-0.035', '-0.043', '-0.009', '-0.005', '0.012', '0.024', '0.034', '0.096', '0.091', '0.084', '0.099', '0.096', '0.132', '0.077', '0.137', '0.108', '0.131', '0.118', '0.14', '0.12', '0.046', '0.169', '0.06', '0.098', '0.07', '0.093', '0.069', '0.047', '0.025', '0.025', '0.012', '-0.007', '-0.021', '-0.023', '-0.046', '-0.06', '-0.064', '-0.088', '-0.081', '-0.071', '-0.099', '-0.154', '-0.094', '-0.14', '0.026', '-0.802', '-0.44', '-0.201', '-0.12', '0.436', '1.042', '0.417', '-1.31', '0.286', '1.305', '0.143', '-1.025', '-0.008', 'null', '-0.002', '0.564', '1.114', '1.088', '24.81', '1.072', '1.179', 'null', '-0.164', '-0.12', '-0.143', '-0.147', '-0.129', '-0.116', '-0.111', '-0.091', '-0.08', '-0.055', '-0.051', '-0.017', '-0.005', '0.015', '0.034', '0.051', '0.075', '0.051', '0.128', '0.108', '0.131', '0.132', '0.164', '0.128', '0.175', '0.151', '0.177', '0.156', '0.173', '0.164', '0.094', '0.202', '0.086', '0.136', '0.103', '0.126', '0.085', '0.061', '0.036', '0.036', '0.015', '-0.007', '-0.027', '-0.037', '-0.062', '-0.077', '-0.091', '-0.111', '-0.118', '-0.091', '-0.145', '-0.189', '-0.147', '-0.175', '-0.152', '-0.17', '-0.165', '-0.077', '-0.192', '-0.158', '-0.189', '-0.18', '-0.172', '-0.142', '-0.138', '-0.119', '-0.096', '-0.075', '-0.063', '-0.022', '-0.007', '0.02', '0.043', '0.064', '0.092', '0.071', '0.158', '0.143', '0.159', '0.174', '0.193', '0.183', '0.203', '0.21', '0.207', '0.212', '0.203', '0.209', '0.138', '0.231', '0.132', '0.159', '0.141', '0.154', '0.106', '0.079', '0.046', '0.045', '0.02', '-0.009', '-0.032', '-0.052', '-0.076', '-0.096', '-0.119', '-0.138', '-0.143', '-0.128', '-0.178', '-0.236', '-0.194', '-0.214', '-0.202', '-0.207', '-0.218', '0.078', '0.064', '-0.118', '-0.084', '-0.112', '-0.111', '-0.084', '-0.092', '-0.085', '-0.063', '-0.063', '-0.035', '-0.043', '-0.009', '-0.005', '0.012', '0.024', '0.034', '0.096', '0.091', '0.084', '0.099', '0.096', '0.132', '0.077', '0.137', '0.108', '0.131', '0.118', '0.14', '0.12', '0.046', '0.169', '0.06', '0.098', '0.07', '0.093', '0.069', '0.047', '0.025', '0.025', '0.012', '-0.007', '-0.021', '-0.023', '-0.046', '-0.06', '-0.064', '-0.088', '-0.081', '-0.071', '-0.099', '-0.154', '-0.094', '-0.14', '-0.106', '-0.125', '-0.13', '-0.032', '-0.623', '-0.322', '-0.2', '0.435', '1.028', '0.422', '-1.307', '0.283', '1.309', '0.147', '-1.04', '-0.058', '0', '-0.013', '-0.624', '-0.376', '-0.152', '0.11', '0.202', '0.734', '-0.012', 'null', '-0.166', '-0.187', '-0.162', '-0.157', '-0.164', '-0.115', '-0.13', '-0.099', '-0.085', '-0.066', '-0.047', '-0.023', '-0.006', '0.015', '0.035', '0.059', '0.07', '0.094', '0.12', '0.118', '0.143', '0.155', '0.167', '0.165', '0.187', '0.184', '0.186', '0.186', '0.184', '0.187', '0.165', '0.167', '0.155', '0.143', '0.118', '0.12', '0.094', '0.07', '0.059', '0.035', '0.015', '-0.006', '-0.023', '-0.047', '-0.066', '-0.085', '-0.099', '-0.13', '-0.115', '-0.164', '-0.157', '-0.162', '-0.179', '-0.184', '-0.189', '-0.183', '-0.2', '-0.059', '-0.22', '-0.22', '-0.211', '-0.193', '-0.191', '-0.154', '-0.155', '-0.123', '-0.108', '-0.077', '-0.06', '-0.03', '-0.007', '0.019', '0.043', '0.072', '0.088', '0.119', '0.142', '0.149', '0.178', '0.188', '0.205', '0.211', '0.232', '0.217', '0.236', '0.236', '0.217', '0.232', '0.211', '0.205', '0.188', '0.178', '0.149', '0.142', '0.119', '0.088', '0.072', '0.043', '0.019', '-0.007', '-0.03', '-0.06', '-0.077', '-0.108', '-0.123', '-0.155', '-0.154', '-0.191', '-0.193', '-0.211', '-0.22', '-0.221', '-0.234', '-0.229', '-0.236', '0.071', '0.053', '-0.128', '-0.133', '-0.139', '-0.115', '-0.129', '-0.086', '-0.099', '-0.08', '-0.063', '-0.05', '-0.039', '-0.015', '-0.006', '0.01', '0.029', '0.048', '0.046', '0.076', '0.098', '0.087', '0.107', '0.12', '0.136', '0.119', '0.157', '0.12', '0.155', '0.155', '0.12', '0.157', '0.119', '0.136', '0.12', '0.107', '0.087', '0.098', '0.076', '0.046', '0.048', '0.029', '0.01', '-0.006', '-0.015', '-0.039', '-0.05', '-0.063', '-0.08', '-0.099', '-0.086', '-0.129', '-0.115', '-0.141', '-0.13', '-0.129', '-0.156', '-0.139', '-0.157', '-0.029', '0.83', '0.544', '0.226', '0.24', '-0.441', '-1.126', '-0.473', '1.508', '-0.226', '-1.623', '-0.238', '1.533', '-0.454', '-1.191', '-0.348', 'null', '-0.091', '-0.288', '-1.084', '-24.303', '-1.014', '-1.445', 'null', '-0.189', '-0.183', '-0.2', '-0.166', '-0.187', '-0.162', '-0.157', '-0.164', '-0.115', '-0.13', '-0.099', '-0.085', '-0.066', '-0.047', '-0.023', '-0.006', '0.015', '0.035', '0.059', '0.07', '0.094', '0.12', '0.118', '0.143', '0.155', '0.167', '0.165', '0.187', '0.184', '0.186', '0.186', '0.184', '0.187', '0.165', '0.167', '0.155', '0.143', '0.118', '0.12', '0.094', '0.07', '0.059', '0.035', '0.015', '-0.006', '-0.023', '-0.047', '-0.066', '-0.085', '-0.099', '-0.13', '-0.115', '-0.164', '-0.157', '-0.162', '-0.179', '-0.184', '0.068', '-0.234', '-0.229', '-0.236', '-0.22', '-0.22', '-0.211', '-0.193', '-0.191', '-0.154', '-0.155', '-0.123', '-0.108', '-0.077', '-0.06', '-0.03', '-0.007', '0.019', '0.043', '0.072', '0.088', '0.119', '0.142', '0.149', '0.178', '0.188', '0.205', '0.211', '0.232', '0.217', '0.236', '0.236', '0.217', '0.232', '0.211', '0.205', '0.188', '0.178', '0.149', '0.142', '0.119', '0.088', '0.072', '0.043', '0.019', '-0.007', '-0.03', '-0.06', '-0.077', '-0.108', '-0.123', '-0.155', '-0.154', '-0.191', '-0.193', '-0.211', '-0.22', '-0.221', '-0.071', '-0.052', '-0.156', '-0.139', '-0.157', '-0.128', '-0.133', '-0.139', '-0.115', '-0.129', '-0.086', '-0.099', '-0.08', '-0.063', '-0.05', '-0.039', '-0.015', '-0.006', '0.01', '0.029', '0.048', '0.046', '0.076', '0.098', '0.087', '0.107', '0.12', '0.136', '0.119', '0.157', '0.12', '0.155', '0.155', '0.12', '0.157', '0.119', '0.136', '0.12', '0.107', '0.087', '0.098', '0.076', '0.046', '0.048', '0.029', '0.01', '-0.006', '-0.015', '-0.039', '-0.05', '-0.063', '-0.08', '-0.099', '-0.086', '-0.129', '-0.115', '-0.141', '-0.13', '-0.129', '0.059', '0.73', '0.31', '0.259', '-0.44', '-1.107', '-0.479', '1.502', '-0.224', '-1.622', '-0.24', '1.537', '-0.448', '-1.207', '-0.35', '0', '-0.09', '0.262', '0.454', '1.172', '0.016', 'null', '-0.22', '-0.2', '-0.22', '-0.198', '-0.191', '-0.2', '-0.168', '-0.17', '-0.155', '-0.131', '-0.104', '-0.106', '-0.068', '-0.055', '-0.025', '-0.007', '0.017', '0.039', '0.066', '0.083', '0.102', '0.121', '0.145', '0.16', '0.167', '0.195', '0.181', '0.207', '0.209', '0.206', '0.206', '0.209', '0.207', '0.181', '0.195', '0.167', '0.16', '0.145', '0.121', '0.102', '0.083', '0.066', '0.039', '0.017', '-0.007', '-0.025', '-0.055', '-0.068', '-0.106', '-0.104', '-0.131', '-0.155', '-0.17', '-0.168', '-0.2', '-0.191', '-0.198', '0.061', '-0.256', '-0.25', '-0.256', '-0.245', '-0.239', '-0.231', '-0.212', '-0.203', '-0.184', '-0.159', '-0.133', '-0.123', '-0.084', '-0.064', '-0.033', '-0.008', '0.021', '0.047', '0.079', '0.099', '0.128', '0.146', '0.174', '0.198', '0.201', '0.225', '0.231', '0.253', '0.239', '0.258', '0.258', '0.239', '0.253', '0.231', '0.225', '0.201', '0.198', '0.174', '0.146', '0.128', '0.099', '0.079', '0.047', '0.021', '-0.008', '-0.033', '-0.064', '-0.084', '-0.123', '-0.133', '-0.159', '-0.184', '-0.203', '-0.212', '-0.231', '-0.239', '-0.245', '-0.072', '-0.043', '-0.19', '-0.152', '-0.19', '-0.137', '-0.16', '-0.156', '-0.136', '-0.14', '-0.118', '-0.102', '-0.09', '-0.08', '-0.053', '-0.046', '-0.017', '-0.007', '0.013', '0.029', '0.057', '0.064', '0.078', '0.105', '0.1', '0.137', '0.131', '0.166', '0.126', '0.184', '0.143', '0.175', '0.175', '0.143', '0.184', '0.126', '0.166', '0.131', '0.137', '0.1', '0.105', '0.078', '0.064', '0.057', '0.029', '0.013', '-0.007', '-0.017', '-0.046', '-0.053', '-0.08', '-0.09', '-0.102', '-0.118', '-0.14', '-0.136', '-0.156', '-0.16', '-0.137', '0.059', '-0.799', '-0.505', '-0.419', '-0.14', '-0.246', '0.44', '1.283', '0.495', '-1.709', '0.195', '1.884', '0.284', '-1.883', '0.372', '1.702', '0.067', '-1.266', '0.019', 'null', '0.005', '1.356', '0.983', '24.636', '1.013', '1.588', 'null', '-0.198', '-0.191', '-0.2', '-0.168', '-0.17', '-0.155', '-0.131', '-0.104', '-0.106', '-0.068', '-0.055', '-0.025', '-0.007', '0.017', '0.039', '0.066', '0.083', '0.102', '0.121', '0.145', '0.16', '0.167', '0.195', '0.181', '0.207', '0.209', '0.206', '0.206', '0.209', '0.207', '0.181', '0.195', '0.167', '0.16', '0.145', '0.121', '0.102', '0.083', '0.066', '0.039', '0.017', '-0.007', '-0.025', '-0.055', '-0.068', '-0.106', '-0.104', '-0.131', '-0.155', '-0.17', '-0.168', '-0.2', '-0.191', '-0.198', '-0.22', '-0.2', '-0.22', '-0.061', '-0.245', '-0.239', '-0.231', '-0.212', '-0.203', '-0.184', '-0.159', '-0.133', '-0.123', '-0.084', '-0.064', '-0.033', '-0.008', '0.021', '0.047', '0.079', '0.099', '0.128', '0.146', '0.174', '0.198', '0.201', '0.225', '0.231', '0.253', '0.239', '0.258', '0.258', '0.239', '0.253', '0.231', '0.225', '0.201', '0.198', '0.174', '0.146', '0.128', '0.099', '0.079', '0.047', '0.021', '-0.008', '-0.033', '-0.064', '-0.084', '-0.123', '-0.133', '-0.159', '-0.184', '-0.203', '-0.212', '-0.231', '-0.239', '-0.245', '-0.256', '-0.25', '-0.256', '0.072', '0.043', '-0.137', '-0.16', '-0.156', '-0.136', '-0.14', '-0.118', '-0.102', '-0.09', '-0.08', '-0.053', '-0.046', '-0.017', '-0.007', '0.013', '0.029', '0.057', '0.064', '0.078', '0.105', '0.1', '0.137', '0.131', '0.166', '0.126', '0.184', '0.143', '0.175', '0.175', '0.143', '0.184', '0.126', '0.166', '0.131', '0.137', '0.1', '0.105', '0.078', '0.064', '0.057', '0.029', '0.013', '-0.007', '-0.017', '-0.046', '-0.053', '-0.08', '-0.09', '-0.102', '-0.118', '-0.14', '-0.136', '-0.156', '-0.16', '-0.137', '-0.19', '-0.152', '-0.19', '-0.06', '-0.809', '-0.318', '-0.331', '0.44', '1.265', '0.5', '-1.7', '0.191', '1.881', '0.287', '-1.886', '0.369', '1.711', '0.073', '-1.285', '0.019', '0', '0.005', '-0.809', '-0.479', '-0.337', '-0.173', '0.013', '0.21', '0.354', '1.036', 'null', '-0.209', '-0.206', '-0.196', '-0.187', '-0.176', '-0.171', '-0.15', '-0.129', '-0.116', '-0.1', '-0.069', '-0.054', '-0.028', '-0.008', '0.015', '0.041', '0.059', '0.083', '0.105', '0.127', '0.143', '0.148', '0.179', '0.178', '0.203', '0.193', '0.206', '0.216', '0.212', '0.192', '0.209', '0.196', '0.177', '0.171', '0.17', '0.133', '0.127', '0.107', '0.083', '0.066', '0.039', '0.018', '-0.005', '-0.028', '-0.049', '-0.077', '-0.089', '-0.112', '-0.142', '-0.14', '-0.167', '-0.175', '-0.2', '-0.194', '-0.187', '-0.231', '-0.201', '-0.02', '-0.255', '-0.245', '-0.24', '-0.226', '-0.22', '-0.196', '-0.19', '-0.154', '-0.142', '-0.117', '-0.086', '-0.065', '-0.021', '-0.014', '-0.009', '0.018', '0.05', '0.074', '0.1', '0.124', '0.153', '0.174', '0.184', '0.213', '0.22', '0.237', '0.239', '0.248', '0.267', '0.247', '0.24', '0.248', '0.241', '0.219', '0.205', '0.202', '0.162', '0.153', '0.129', '0.103', '0.076', '0.049', '0.022', '-0.006', '-0.032', '-0.061', '-0.092', '-0.109', '-0.139', '-0.164', '-0.177', '-0.2', '-0.216', '-0.231', '-0.239', '-0.241', '-0.259', '-0.251', '0.02', '0.021', '-0.169', '-0.162', '-0.161', '-0.137', '-0.138', '-0.156', '-0.105', '-0.099', '-0.092', '-0.091', '-0.045', '-0.047', '-0.021', '-0.007', '0.009', '0.04', '0.043', '0.065', '0.084', '0.103', '0.108', '0.119', '0.144', '0.145', '0.158', '0.159', '0.148', '0.186', '0.171', '0.146', '0.167', '0.145', '0.149', '0.14', '0.132', '0.101', '0.105', '0.081', '0.071', '0.054', '0.029', '0.014', '-0.005', '-0.02', '-0.038', '-0.065', '-0.071', '-0.085', '-0.111', '-0.115', '-0.133', '-0.135', '-0.173', '-0.146', '-0.133', '-0.205', '-0.151', '-0.03', '0.752', '0.45', '0.58', '-0.413', '-0.794', '-0.64', '1.509', '-0.134', '-1.808', '-0.332', '1.905', '-0.32', '-1.828', '-0.146', '1.556', '-0.6', '-0.928', '-0.332', 'null', '-0.085', '-0.356', '-1.083', '-24.509', '-0.962', '-0.854', 'null', '-0.187', '-0.231', '-0.201', '-0.209', '-0.206', '-0.196', '-0.187', '-0.176', '-0.171', '-0.15', '-0.129', '-0.116', '-0.1', '-0.069', '-0.054', '-0.028', '-0.008', '0.015', '0.041', '0.059', '0.083', '0.105', '0.127', '0.143', '0.148', '0.179', '0.178', '0.203', '0.193', '0.206', '0.216', '0.212', '0.192', '0.209', '0.196', '0.177', '0.171', '0.17', '0.133', '0.127', '0.107', '0.083', '0.066', '0.039', '0.018', '-0.005', '-0.028', '-0.049', '-0.077', '-0.089', '-0.112', '-0.142', '-0.14', '-0.167', '-0.175', '-0.2', '-0.194', '0.112', '-0.241', '-0.259', '-0.251', '-0.255', '-0.245', '-0.24', '-0.226', '-0.22', '-0.196', '-0.19', '-0.154', '-0.142', '-0.117', '-0.086', '-0.065', '-0.021', '-0.014', '-0.009', '0.018', '0.05', '0.074', '0.1', '0.124', '0.153', '0.174', '0.184', '0.213', '0.22', '0.237', '0.239', '0.248', '0.267', '0.247', '0.24', '0.248', '0.241', '0.219', '0.205', '0.202', '0.162', '0.153', '0.129', '0.103', '0.076', '0.049', '0.022', '-0.006', '-0.032', '-0.061', '-0.092', '-0.109', '-0.139', '-0.164', '-0.177', '-0.2', '-0.216', '-0.231', '-0.239', '-0.121', '-0.1', '-0.133', '-0.205', '-0.151', '-0.169', '-0.162', '-0.161', '-0.137', '-0.138', '-0.156', '-0.105', '-0.099', '-0.092', '-0.091', '-0.045', '-0.047', '-0.021', '-0.007', '0.009', '0.04', '0.043', '0.065', '0.084', '0.103', '0.108', '0.119', '0.144', '0.145', '0.158', '0.159', '0.148', '0.186', '0.171', '0.146', '0.167', '0.145', '0.149', '0.14', '0.132', '0.101', '0.105', '0.081', '0.071', '0.054', '0.029', '0.014', '-0.005', '-0.02', '-0.038', '-0.065', '-0.071', '-0.085', '-0.111', '-0.115', '-0.133', '-0.135', '-0.173', '-0.146', '0.059', '0.606', '0.588', '-0.414', '-0.752', '-0.653', '1.493', '-0.13', '-1.802', '-0.333', '1.904', '-0.317', '-1.834', '-0.15', '1.57', '-0.591', '-0.961', '-0.333', 'null', '0', '-0.085', '0.511', '0.463', '0.548', '0.564', '0.532', '0.388', '0.791', '1.074', '24.532', '0.962', '1.066', 'null', 'null', '-0.219', '-0.191', '-0.19', '-0.186', '-0.154', '-0.153', '-0.131', '-0.123', '-0.092', '-0.079', '-0.049', '-0.029', '-0.009', '0.013', '0.042', '0.058', '0.085', '0.106', '0.115', '0.151', '0.144', '0.18', '0.181', '0.197', '0.193', '0.215', '0.214', '0.208', '0.201', '0.192', '0.212', '0.17', '0.177', '0.153', '0.152', '0.12', '0.105', '0.087', '0.066', '0.037', '0.021', '-0.004', '-0.025', '-0.05', '-0.078', '-0.086', '-0.115', '-0.139', '-0.141', '-0.163', '-0.189', '-0.17', '-0.211', '-0.201', '-0.209', '-0.21', '-0.199', '-0.066', '-0.251', '-0.249', '-0.217', '-0.226', '-0.193', '-0.185', '-0.161', '-0.145', '-0.11', '-0.097', '-0.06', '-0.035', '-0.011', '0.017', '0.05', '0.072', '0.101', '0.127', '0.144', '0.177', '0.183', '0.213', '0.22', '0.235', '0.239', '0.25', '0.273', '0.241', '0.242', '0.242', '0.25', '0.21', '0.213', '0.19', '0.175', '0.15', '0.13', '0.103', '0.077', '0.048', '0.016', '0.008', '-0.004', '-0.031', '-0.062', '-0.089', '-0.11', '-0.139', '-0.162', '-0.178', '-0.196', '-0.224', '-0.216', '-0.246', '-0.245', '-0.256', '-0.251', '-0.247', '0.069', '0.06', '-0.177', '-0.16', '-0.133', '-0.16', '-0.117', '-0.125', '-0.099', '-0.104', '-0.069', '-0.066', '-0.038', '-0.021', '-0.008', '0.011', '0.032', '0.048', '0.064', '0.086', '0.092', '0.124', '0.108', '0.137', '0.154', '0.155', '0.148', '0.174', '0.173', '0.162', '0.177', '0.131', '0.168', '0.144', '0.137', '0.121', '0.122', '0.095', '0.081', '0.073', '0.052', '0.028', '0.017', '-0.004', '-0.019', '-0.036', '-0.069', '-0.062', '-0.096', '-0.118', '-0.094', '-0.134', '-0.162', '-0.127', '-0.169', '-0.151', '-0.181', '-0.164', '-0.151', '-0.029', '-0.717', '-0.406', '-0.151', '-0.25', '0.439', '1.266', '0.498', '-1.701', '0.193', '1.882', '0.284', '-1.884', '0.37', '1.708', '0.073', '-1.284', '0.015', 'null', '0.004', '-1.538', '-1', '-24.617', '-1.017', '-1.583', 'null', '-0.209', '-0.21', '-0.199', '-0.219', '-0.191', '-0.19', '-0.186', '-0.154', '-0.153', '-0.131', '-0.123', '-0.092', '-0.079', '-0.049', '-0.029', '-0.009', '0.013', '0.042', '0.058', '0.085', '0.106', '0.115', '0.151', '0.144', '0.18', '0.181', '0.197', '0.193', '0.215', '0.214', '0.208', '0.201', '0.192', '0.212', '0.17', '0.177', '0.153', '0.152', '0.12', '0.105', '0.087', '0.066', '0.037', '0.021', '-0.004', '-0.025', '-0.05', '-0.078', '-0.086', '-0.115', '-0.139', '-0.141', '-0.163', '-0.189', '-0.17', '-0.211', '-0.201', '0.07', '-0.256', '-0.251', '-0.247', '-0.251', '-0.249', '-0.217', '-0.226', '-0.193', '-0.185', '-0.161', '-0.145', '-0.11', '-0.097', '-0.06', '-0.035', '-0.011', '0.017', '0.05', '0.072', '0.101', '0.127', '0.144', '0.177', '0.183', '0.213', '0.22', '0.235', '0.239', '0.25', '0.273', '0.241', '0.242', '0.242', '0.25', '0.21', '0.213', '0.19', '0.175', '0.15', '0.13', '0.103', '0.077', '0.048', '0.016', '0.008', '-0.004', '-0.031', '-0.062', '-0.089', '-0.11', '-0.139', '-0.162', '-0.178', '-0.196', '-0.224', '-0.216', '-0.246', '-0.245', '-0.074', '-0.055', '-0.181', '-0.164', '-0.151', '-0.177', '-0.16', '-0.133', '-0.16', '-0.117', '-0.125', '-0.099', '-0.104', '-0.069', '-0.066', '-0.038', '-0.021', '-0.008', '0.011', '0.032', '0.048', '0.064', '0.086', '0.092', '0.124', '0.108', '0.137', '0.154', '0.155', '0.148', '0.174', '0.173', '0.162', '0.177', '0.131', '0.168', '0.144', '0.137', '0.121', '0.122', '0.095', '0.081', '0.073', '0.052', '0.028', '0.017', '-0.004', '-0.019', '-0.036', '-0.069', '-0.062', '-0.096', '-0.118', '-0.094', '-0.134', '-0.162', '-0.127', '-0.169', '-0.151', '0.062', '-0.793', '-0.511', '-0.406', '-0.151', '-0.25', '0.44', '1.283', '0.494', '-1.711', '0.197', '1.884', '0.282', '-1.881', '0.372', '1.7', '0.067', '-1.264', '0.015', 'null', '0', '0.004', '1.493', '1.046', '24.458', '1.013', '0.303', '1.501', 'null', 'null', '-0.212', '-0.195', '-0.204', '-0.19', '-0.19', '-0.081', '-0.078', '-0.142', '-0.137', '-0.125', '-0.095', '-0.067', '-0.06', '-0.015', '-0.011', '-0.009', '0.015', '0.037', '0.058', '0.087', '0.107', '0.109', '0.156', '0.143', '0.172', '0.189', '0.198', '0.195', '0.104', '0.23', '0.097', '0.193', '0.21', '0.195', '0.197', '0.186', '0.168', '0.163', '0.138', '0.127', '0.11', '0.084', '0.067', '0.024', '0.016', '0.02', '-0.004', '-0.025', '-0.048', '-0.075', '-0.088', '-0.115', '-0.135', '-0.148', '-0.156', '-0.173', '-0.203', '-0.188', '-0.194', '-0.141', '-0.075', '-0.216', '-0.018', '-0.249', '-0.247', '-0.247', '-0.225', '-0.227', '-0.109', '-0.088', '-0.179', '-0.16', '-0.149', '-0.113', '-0.057', '-0.033', '-0.039', '-0.026', '-0.023', '-0.012', '-0.011', '0.018', '0.047', '0.07', '0.102', '0.13', '0.138', '0.179', '0.186', '0.201', '0.228', '0.23', '0.14', '0.109', '0.14', '0.252', '0.128', '0.23', '0.257', '0.236', '0.24', '0.227', '0.201', '0.195', '0.174', '0.147', '0.136', '0.061', '0.043', '0.077', '0.032', '0.017', '0.018', '0.007', '-0.004', '-0.031', '-0.058', '-0.09', '-0.109', '-0.139', '-0.161', '-0.178', '-0.192', '-0.211', '-0.241', '-0.231', '-0.153', '-0.095', '-0.155', '-0.094', '-0.26', '0.018', '0.017', '-0.167', '-0.158', '-0.154', '-0.158', '-0.15', '-0.117', '-0.12', '-0.107', '-0.104', '-0.076', '-0.051', '-0.05', '-0.018', '-0.007', '0.012', '0.03', '0.043', '0.07', '0.088', '0.08', '0.132', '0.111', '0.137', '0.149', '0.158', '0.224', '0.27', '0.159', '0.167', '0.143', '0.168', '0.15', '0.121', '0.142', '0.094', '0.115', '0.085', '0.064', '0.056', '0.028', '0.018', '-0.004', '-0.021', '-0.035', '-0.061', '-0.074', '-0.087', '-0.102', '-0.125', '-0.121', '-0.137', '-0.171', '-0.138', '-0.154', '-0.156', '-0.191', '-0.03', '0.759', '0.485', '0.531', '-0.415', '-0.793', '-0.639', '1.506', '-0.131', '-1.808', '-0.331', '1.903', '-0.32', '-1.827', '-0.149', '1.558', '-0.601', '-0.926', '-0.333', 'null', '-0.086', '-0.353', '-1.081', '-24.5', '-0.97', '-1.466', 'null', '-0.212', '-0.195', '-0.204', '-0.19', '-0.19', '-0.081', '-0.078', '-0.142', '-0.137', '-0.125', '-0.095', '-0.067', '-0.06', '-0.015', '-0.011', '-0.009', '0.015', '0.037', '0.058', '0.087', '0.107', '0.109', '0.156', '0.143', '0.172', '0.189', '0.198', '0.195', '0.104', '0.23', '0.097', '0.193', '0.21', '0.195', '0.197', '0.186', '0.168', '0.163', '0.138', '0.127', '0.11', '0.084', '0.067', '0.024', '0.016', '0.02', '-0.004', '-0.025', '-0.048', '-0.075', '-0.088', '-0.115', '-0.135', '-0.148', '-0.156', '-0.173', '-0.203', '-0.188', '-0.194', '-0.141', '-0.075', '-0.216', '-0.018', '-0.249', '-0.247', '-0.247', '-0.225', '-0.227', '-0.109', '-0.088', '-0.179', '-0.16', '-0.149', '-0.113', '-0.057', '-0.033', '-0.039', '-0.026', '-0.023', '-0.012', '-0.011', '0.018', '0.047', '0.07', '0.102', '0.13', '0.138', '0.179', '0.186', '0.201', '0.228', '0.23', '0.14', '0.109', '0.14', '0.252', '0.128', '0.23', '0.257', '0.236', '0.24', '0.227', '0.201', '0.195', '0.174', '0.147', '0.136', '0.061', '0.043', '0.077', '0.032', '0.017', '0.018', '0.007', '-0.004', '-0.031', '-0.058', '-0.09', '-0.109', '-0.139', '-0.161', '-0.178', '-0.192', '-0.211', '-0.241', '-0.231', '-0.153', '-0.095', '-0.155', '-0.094', '-0.26', '0.018', '0.017', '-0.167', '-0.158', '-0.154', '-0.158', '-0.15', '-0.117', '-0.12', '-0.107', '-0.104', '-0.076', '-0.051', '-0.05', '-0.018', '-0.007', '0.012', '0.03', '0.043', '0.07', '0.088', '0.08', '0.132', '0.111', '0.137', '0.149', '0.158', '0.224', '0.27', '0.159', '0.167', '0.143', '0.168', '0.15', '0.121', '0.142', '0.094', '0.115', '0.085', '0.064', '0.056', '0.028', '0.018', '-0.004', '-0.021', '-0.035', '-0.061', '-0.074', '-0.087', '-0.102', '-0.125', '-0.121', '-0.137', '-0.171', '-0.138', '-0.154', '-0.156', '-0.191', '-0.03', '0.759', '0.436', '0.57', '-0.415', '-0.754', '-0.651', '1.491', '-0.127', '-1.801', '-0.334', '1.904', '-0.318', '-1.833', '-0.153', '1.572', '-0.591', '-0.96', '-0.334', 'null', '0', '-0.086', '0.52', '0.457', '0.666', '0.63', '0.499', '0.315', '0.712', '1.084', '24.78', '0.792', '0.926', 'null', 'null', '-0.197', '-0.196', '-0.188', '-0.175', '-0.167', '-0.141', '-0.139', '-0.105', '-0.097', '-0.07', '-0.051', '-0.023', '-0.004', '0.019', '0.03', '0.083', '0.078', '0.112', '0.13', '0.137', '0.16', '0.177', '0.186', '0.183', '0.211', '0.206', '0.188', '0.181', '0.209', '0.245', '0.193', '0.181', '0.172', '0.156', '0.143', '0.119', '0.105', '0.08', '0.058', '0.039', '0.014', '-0.009', '-0.032', '-0.053', '-0.078', '-0.088', '-0.122', '-0.135', '-0.157', '-0.163', '-0.176', '-0.189', '-0.202', '-0.21', '-0.208', '-0.143', '-0.277', '-0.063', '-0.249', '-0.236', '-0.227', '-0.215', '-0.202', '-0.172', '-0.161', '-0.135', '-0.114', '-0.084', '-0.062', '-0.029', '-0.004', '0.023', '0.037', '0.099', '0.096', '0.136', '0.153', '0.167', '0.195', '0.214', '0.223', '0.234', '0.241', '0.257', '0.223', '0.22', '0.259', '0.292', '0.233', '0.224', '0.203', '0.191', '0.171', '0.148', '0.122', '0.1', '0.071', '0.046', '0.018', '-0.011', '-0.038', '-0.064', '-0.093', '-0.113', '-0.146', '-0.162', '-0.185', '-0.204', '-0.211', '-0.232', '-0.241', '-0.251', '-0.252', '-0.188', '-0.315', '0.075', '0.057', '-0.162', '-0.146', '-0.155', '-0.131', '-0.145', '-0.099', '-0.117', '-0.079', '-0.085', '-0.048', '-0.042', '-0.019', '-0.004', '0.016', '0.019', '0.07', '0.064', '0.083', '0.114', '0.102', '0.128', '0.142', '0.145', '0.15', '0.157', '0.166', '0.157', '0.135', '0.174', '0.198', '0.141', '0.149', '0.142', '0.115', '0.116', '0.094', '0.09', '0.056', '0.05', '0.031', '0.01', '-0.008', '-0.025', '-0.039', '-0.065', '-0.071', '-0.093', '-0.112', '-0.122', '-0.13', '-0.136', '-0.156', '-0.157', '-0.167', '-0.171', '-0.099', '-0.231', '-0.032', '-0.694', '-0.41', '-0.069', '-0.304', '0.439', '1.263', '0.501', '-1.697', '0.191', '1.88', '0.285', '-1.884', '0.37', '1.709', '0.07', '-1.284', '0.018', 'null', '0.004', '-1.668', '-1.04', '-24.47', '-1.01', '-1.399', 'null', '-0.21', '-0.208', '-0.143', '-0.277', '-0.197', '-0.196', '-0.188', '-0.175', '-0.167', '-0.141', '-0.139', '-0.105', '-0.097', '-0.07', '-0.051', '-0.023', '-0.004', '0.019', '0.03', '0.083', '0.078', '0.112', '0.13', '0.137', '0.16', '0.177', '0.186', '0.183', '0.211', '0.206', '0.188', '0.181', '0.209', '0.245', '0.193', '0.181', '0.172', '0.156', '0.143', '0.119', '0.105', '0.08', '0.058', '0.039', '0.014', '-0.009', '-0.032', '-0.053', '-0.078', '-0.088', '-0.122', '-0.135', '-0.157', '-0.163', '-0.176', '-0.189', '-0.202', '0.105', '-0.251', '-0.252', '-0.188', '-0.315', '-0.249', '-0.236', '-0.227', '-0.215', '-0.202', '-0.172', '-0.161', '-0.135', '-0.114', '-0.084', '-0.062', '-0.029', '-0.004', '0.023', '0.037', '0.099', '0.096', '0.136', '0.153', '0.167', '0.195', '0.214', '0.223', '0.234', '0.241', '0.257', '0.223', '0.22', '0.259', '0.292', '0.233', '0.224', '0.203', '0.191', '0.171', '0.148', '0.122', '0.1', '0.071', '0.046', '0.018', '-0.011', '-0.038', '-0.064', '-0.093', '-0.113', '-0.146', '-0.162', '-0.185', '-0.204', '-0.211', '-0.232', '-0.241', '-0.114', '-0.092', '-0.167', '-0.171', '-0.099', '-0.231', '-0.162', '-0.146', '-0.155', '-0.131', '-0.145', '-0.099', '-0.117', '-0.079', '-0.085', '-0.048', '-0.042', '-0.019', '-0.004', '0.016', '0.019', '0.07', '0.064', '0.083', '0.114', '0.102', '0.128', '0.142', '0.145', '0.15', '0.157', '0.166', '0.157', '0.135', '0.174', '0.198', '0.141', '0.149', '0.142', '0.115', '0.116', '0.094', '0.09', '0.056', '0.05', '0.031', '0.01', '-0.008', '-0.025', '-0.039', '-0.065', '-0.071', '-0.093', '-0.112', '-0.122', '-0.13', '-0.136', '-0.156', '-0.157', '0.088', '-0.799', '-0.522', '-0.433', '-0.259', '-0.253', '0.44', '1.283', '0.495', '-1.706', '0.194', '1.883', '0.282', '-1.881', '0.372', '1.702', '0.063', '-1.265', '0.018', '0', '0.004', '0.825', '0.427', '0.275', '0.101', '-0.085', '-0.261', '-0.234', '-0.872', 'null', '-0.203', '-0.145', '-0.134', '-0.127', '-0.229', '-0.119', '-0.187', '-0.191', '-0.163', '-0.104', '-0.14', '-0.074', '-0.12', '-0.09', '-0.069', '-0.047', '-0.026', '-0.004', '0.021', '0.026', '0.062', '0.08', '0.102', '0.123', '0.085', '0.096', '0.156', '0.188', '0.166', '0.205', '0.202', '0.209', '0.168', '0.192', '0.2', '0.202', '0.198', '0.177', '0.184', '0.156', '0.097', '0.084', '0.123', '0.102', '0.08', '0.062', '0.033', '0.015', '-0.009', '-0.019', '-0.048', '-0.069', '-0.09', '-0.114', '-0.082', '-0.095', '-0.143', '-0.167', '-0.186', '-0.189', '-0.192', '-0.219', '0.064', '-0.249', '-0.183', '-0.155', '-0.16', '-0.264', '-0.157', '-0.23', '-0.22', '-0.201', '-0.128', '-0.162', '-0.105', '-0.134', '-0.112', '-0.082', '-0.059', '-0.031', '-0.004', '0.024', '0.034', '0.076', '0.092', '0.125', '0.149', '0.106', '0.113', '0.194', '0.217', '0.216', '0.24', '0.238', '0.257', '0.217', '0.214', '0.257', '0.238', '0.24', '0.213', '0.22', '0.194', '0.114', '0.105', '0.149', '0.125', '0.092', '0.077', '0.041', '0.018', '-0.011', '-0.022', '-0.061', '-0.082', '-0.112', '-0.132', '-0.103', '-0.113', '-0.176', '-0.206', '-0.22', '-0.226', '-0.24', '-0.255', '-0.065', '-0.062', '-0.157', '-0.121', '-0.082', '-0.114', '-0.193', '-0.094', '-0.127', '-0.171', '-0.133', '-0.069', '-0.125', '-0.04', '-0.113', '-0.06', '-0.058', '-0.036', '-0.022', '-0.004', '0.015', '0.022', '0.05', '0.063', '0.081', '0.101', '0.058', '0.08', '0.134', '0.14', '0.137', '0.159', '0.159', '0.169', '0.135', '0.145', '0.173', '0.155', '0.149', '0.14', '0.152', '0.126', '0.081', '0.057', '0.101', '0.078', '0.064', '0.054', '0.021', '0.013', '-0.007', '-0.01', '-0.042', '-0.055', '-0.07', '-0.09', '-0.065', '-0.083', '-0.099', '-0.142', '-0.149', '-0.145', '-0.148', '-0.188', '0.026', '0.727', '0.253', '0.447', '-0.414', '-0.756', '-0.65', '1.489', '-0.125', '-1.803', '-0.333', '1.905', '-0.317', '-1.835', '-0.149', '1.569', '-0.589', '-0.96', '-0.336', 'null', '-0.086', '0.451', '0.553', '0.714', '0.537', '0.509', '0.341', '0.688', '1.084', '24.636', '0.865', '1.013', 'null', '-0.229', '-0.119', '-0.187', '-0.191', '-0.163', '-0.104', '-0.14', '-0.074', '-0.12', '-0.09', '-0.069', '-0.047', '-0.026', '-0.004', '0.021', '0.026', '0.062', '0.08', '0.102', '0.123', '0.085', '0.096', '0.156', '0.188', '0.166', '0.205', '0.202', '0.209', '0.168', '0.192', '0.2', '0.202', '0.198', '0.177', '0.184', '0.156', '0.097', '0.084', '0.123', '0.102', '0.08', '0.062', '0.033', '0.015', '-0.009', '-0.019', '-0.048', '-0.069', '-0.09', '-0.114', '-0.082', '-0.095', '-0.143', '-0.167', '-0.186', '-0.189', '-0.192', '-0.219', '-0.203', '-0.145', '-0.134', '-0.127', '-0.074', '-0.264', '-0.157', '-0.23', '-0.22', '-0.201', '-0.128', '-0.162', '-0.105', '-0.134', '-0.112', '-0.082', '-0.059', '-0.031', '-0.004', '0.024', '0.034', '0.076', '0.092', '0.125', '0.149', '0.106', '0.113', '0.194', '0.217', '0.216', '0.24', '0.238', '0.257', '0.217', '0.214', '0.257', '0.238', '0.24', '0.213', '0.22', '0.194', '0.114', '0.105', '0.149', '0.125', '0.092', '0.077', '0.041', '0.018', '-0.011', '-0.022', '-0.061', '-0.082', '-0.112', '-0.132', '-0.103', '-0.113', '-0.176', '-0.206', '-0.22', '-0.226', '-0.24', '-0.255', '-0.249', '-0.183', '-0.155', '-0.16', '0.082', '0.064', '-0.193', '-0.094', '-0.127', '-0.171', '-0.133', '-0.069', '-0.125', '-0.04', '-0.113', '-0.06', '-0.058', '-0.036', '-0.022', '-0.004', '0.015', '0.022', '0.05', '0.063', '0.081', '0.101', '0.058', '0.08', '0.134', '0.14', '0.137', '0.159', '0.159', '0.169', '0.135', '0.145', '0.173', '0.155', '0.149', '0.14', '0.152', '0.126', '0.081', '0.057', '0.101', '0.078', '0.064', '0.054', '0.021', '0.013', '-0.007', '-0.01', '-0.042', '-0.055', '-0.07', '-0.09', '-0.065', '-0.083', '-0.099', '-0.142', '-0.149', '-0.145', '-0.148', '-0.188', '-0.157', '-0.121', '-0.082', '-0.114', '-0.065', '0.778', '0.514', '0.253', '0.457', '-0.415', '-0.794', '-0.639', '1.506', '-0.131', '-1.809', '-0.331', '1.906', '-0.32', '-1.829', '-0.145', '1.554', '-0.598', '-0.926', '-0.335', '0', '-0.086', '0.018', '0.187', '0.324', '0.92', 'null', '-0.211', '-0.208', '-0.182', '-0.18', '-0.179', '-0.095', '-0.141', '-0.123', '-0.079', '-0.085', '-0.068', '-0.051', '-0.024', '-0.005', '0.015', '0.033', '0.06', '0.08', '0.103', '0.118', '0.091', '0.151', '0.105', '0.181', '0.191', '0.184', '0.205', '0.221', '0.154', '0.177', '0.211', '0.205', '0.184', '0.193', '0.178', '0.161', '0.091', '0.096', '0.118', '0.102', '0.08', '0.061', '0.033', '0.016', '-0.004', '-0.024', '-0.051', '-0.068', '-0.084', '-0.124', '-0.073', '-0.149', '-0.093', '-0.179', '-0.18', '-0.182', '-0.208', '-0.212', '-0.197', '-0.142', '-0.197', '-0.062', '-0.25', '-0.252', '-0.22', '-0.221', '-0.208', '-0.122', '-0.172', '-0.147', '-0.095', '-0.105', '-0.083', '-0.059', '-0.03', '-0.005', '0.017', '0.041', '0.074', '0.095', '0.125', '0.139', '0.114', '0.184', '0.13', '0.215', '0.223', '0.237', '0.246', '0.251', '0.209', '0.206', '0.251', '0.246', '0.237', '0.223', '0.215', '0.199', '0.109', '0.12', '0.139', '0.125', '0.093', '0.076', '0.041', '0.018', '-0.004', '-0.03', '-0.059', '-0.083', '-0.106', '-0.141', '-0.102', '-0.171', '-0.121', '-0.208', '-0.221', '-0.22', '-0.252', '-0.25', '-0.247', '-0.168', '-0.246', '0.063', '0.058', '-0.174', '-0.162', '-0.139', '-0.151', '-0.15', '-0.06', '-0.125', '-0.088', '-0.066', '-0.067', '-0.053', '-0.04', '-0.022', '-0.002', '0.014', '0.021', '0.05', '0.071', '0.074', '0.096', '0.071', '0.119', '0.079', '0.147', '0.162', '0.136', '0.162', '0.177', '0.124', '0.142', '0.168', '0.162', '0.132', '0.179', '0.122', '0.151', '0.05', '0.079', '0.095', '0.081', '0.063', '0.052', '0.022', '0.016', '-0.002', '-0.022', '-0.04', '-0.05', '-0.071', '-0.103', '-0.046', '-0.13', '-0.059', '-0.147', '-0.154', '-0.139', '-0.162', '-0.175', '-0.153', '-0.114', '-0.151', '0.13', '-1.267', '0.066', '1.699', '0.374', '-1.882', '0.282', '1.886', '0.194', '-1.709', '0.497', '1.282', '0.348', 'null', '0.093', '-0.19', '-0.391', '-0.576', '-0.692', '-0.561', '-0.52', '-0.93', '-1.083', '-24.629', '-0.872', '-1.072', 'null', '-0.197', '-0.142', '-0.197', '-0.211', '-0.208', '-0.182', '-0.18', '-0.179', '-0.095', '-0.141', '-0.123', '-0.079', '-0.085', '-0.068', '-0.051', '-0.024', '-0.005', '0.015', '0.033', '0.06', '0.08', '0.103', '0.118', '0.091', '0.151', '0.105', '0.181', '0.191', '0.184', '0.205', '0.221', '0.154', '0.177', '0.211', '0.205', '0.184', '0.193', '0.178', '0.161', '0.091', '0.096', '0.118', '0.102', '0.08', '0.061', '0.033', '0.016', '-0.004', '-0.024', '-0.051', '-0.068', '-0.084', '-0.124', '-0.073', '-0.149', '-0.093', '-0.179', '-0.18', '-0.182', '-0.208', '-0.212', '0.063', '-0.247', '-0.168', '-0.246', '-0.25', '-0.252', '-0.22', '-0.221', '-0.208', '-0.122', '-0.172', '-0.147', '-0.095', '-0.105', '-0.083', '-0.059', '-0.03', '-0.005', '0.017', '0.041', '0.074', '0.095', '0.125', '0.139', '0.114', '0.184', '0.13', '0.215', '0.223', '0.237', '0.246', '0.251', '0.209', '0.206', '0.251', '0.246', '0.237', '0.223', '0.215', '0.199', '0.109', '0.12', '0.139', '0.125', '0.093', '0.076', '0.041', '0.018', '-0.004', '-0.03', '-0.059', '-0.083', '-0.106', '-0.141', '-0.102', '-0.171', '-0.121', '-0.208', '-0.221', '-0.22', '-0.252', '-0.25', '-0.063', '-0.059', '-0.153', '-0.114', '-0.151', '-0.174', '-0.162', '-0.139', '-0.151', '-0.15', '-0.06', '-0.125', '-0.088', '-0.066', '-0.067', '-0.053', '-0.04', '-0.022', '-0.002', '0.014', '0.021', '0.05', '0.071', '0.074', '0.096', '0.071', '0.119', '0.079', '0.147', '0.162', '0.136', '0.162', '0.177', '0.124', '0.142', '0.168', '0.162', '0.132', '0.179', '0.122', '0.151', '0.05', '0.079', '0.095', '0.081', '0.063', '0.052', '0.022', '0.016', '-0.002', '-0.022', '-0.04', '-0.05', '-0.071', '-0.103', '-0.046', '-0.13', '-0.059', '-0.147', '-0.154', '-0.139', '-0.162', '-0.175', '-0.268', '-1.288', '0.072', '1.707', '0.372', '-1.885', '0.285', '1.884', '0.19', '-1.701', '0.502', '1.263', '0.347', 'null', '0', '0.093', '0.294', '1.085', '24.627', '0.873', '1.078', 'null', 'null', '-0.218', '-0.195', '-0.192', '-0.181', '-0.172', '-0.152', '-0.086', '-0.136', '-0.099', '-0.083', '-0.068', '-0.027', '-0.024', '-0.005', '0.014', '0.033', '0.058', '0.082', '0.102', '0.119', '0.082', '0.215', '0.169', '0.118', '0.198', '0.191', '0.197', '0.216', '0.277', '0.202', '0.205', '0.193', '0.183', '0.177', '0.162', '0.139', '0.136', '0.103', '0.091', '0.065', '0.035', '0.028', '0.005', '-0.024', '-0.046', '-0.073', '-0.083', '-0.124', '-0.075', '-0.145', '-0.157', '-0.183', '-0.113', '-0.207', '-0.105', '-0.133', '-0.157', '-0.218', '-0.119', '-0.195', '-0.063', '-0.25', '-0.244', '-0.236', '-0.209', '-0.213', '-0.18', '-0.118', '-0.15', '-0.128', '-0.099', '-0.078', '-0.036', '-0.029', '-0.005', '0.016', '0.041', '0.071', '0.098', '0.117', '0.151', '0.11', '0.243', '0.21', '0.146', '0.231', '0.239', '0.245', '0.254', '0.331', '0.245', '0.251', '0.236', '0.222', '0.211', '0.197', '0.173', '0.157', '0.13', '0.109', '0.078', '0.045', '0.032', '0.006', '-0.03', '-0.056', '-0.086', '-0.102', '-0.143', '-0.105', '-0.168', '-0.195', '-0.209', '-0.147', '-0.242', '-0.14', '-0.163', '-0.188', '-0.245', '-0.154', '-0.247', '0.063', '0.059', '-0.179', '-0.149', '-0.164', '-0.15', '-0.118', '-0.127', '-0.068', '-0.109', '-0.078', '-0.064', '-0.055', '-0.021', '-0.022', '-0.002', '0.013', '0.021', '0.048', '0.074', '0.068', '0.105', '0.053', '0.18', '0.137', '0.083', '0.162', '0.158', '0.142', '0.18', '0.229', '0.151', '0.164', '0.148', '0.149', '0.141', '0.131', '0.109', '0.11', '0.077', '0.08', '0.046', '0.031', '0.019', '0.005', '-0.02', '-0.033', '-0.06', '-0.066', '-0.104', '-0.053', '-0.117', '-0.127', '-0.139', '-0.1', '-0.154', '-0.082', '-0.12', '-0.115', '-0.171', '-0.098', '-0.149', '0.664', '0.797', '0.075', '-1.508', '-0.432', '1.807', '-0.234', '-1.904', '-0.245', '1.829', '-0.419', '-1.555', '0.032', '0.929', '-0.074', 'null', '-0.018', '-1.08', '-0.953', '-24.566', '-1.024', '-1.648', 'null', '-0.218', '-0.119', '-0.195', '-0.218', '-0.195', '-0.192', '-0.181', '-0.172', '-0.152', '-0.086', '-0.136', '-0.099', '-0.083', '-0.068', '-0.027', '-0.024', '-0.005', '0.014', '0.033', '0.058', '0.082', '0.102', '0.119', '0.082', '0.215', '0.169', '0.118', '0.198', '0.191', '0.197', '0.216', '0.277', '0.202', '0.205', '0.193', '0.183', '0.177', '0.162', '0.139', '0.136', '0.103', '0.091', '0.065', '0.035', '0.028', '0.005', '-0.024', '-0.046', '-0.073', '-0.083', '-0.124', '-0.075', '-0.145', '-0.157', '-0.183', '-0.113', '-0.207', '-0.105', '-0.133', '-0.157', '0.051', '-0.245', '-0.154', '-0.247', '-0.25', '-0.244', '-0.236', '-0.209', '-0.213', '-0.18', '-0.118', '-0.15', '-0.128', '-0.099', '-0.078', '-0.036', '-0.029', '-0.005', '0.016', '0.041', '0.071', '0.098', '0.117', '0.151', '0.11', '0.243', '0.21', '0.146', '0.231', '0.239', '0.245', '0.254', '0.331', '0.245', '0.251', '0.236', '0.222', '0.211', '0.197', '0.173', '0.157', '0.13', '0.109', '0.078', '0.045', '0.032', '0.006', '-0.03', '-0.056', '-0.086', '-0.102', '-0.143', '-0.105', '-0.168', '-0.195', '-0.209', '-0.147', '-0.242', '-0.14', '-0.163', '-0.188', '-0.06', '-0.046', '-0.171', '-0.098', '-0.149', '-0.179', '-0.149', '-0.164', '-0.15', '-0.118', '-0.127', '-0.068', '-0.109', '-0.078', '-0.064', '-0.055', '-0.021', '-0.022', '-0.002', '0.013', '0.021', '0.048', '0.074', '0.068', '0.105', '0.053', '0.18', '0.137', '0.083', '0.162', '0.158', '0.142', '0.18', '0.229', '0.151', '0.164', '0.148', '0.149', '0.141', '0.131', '0.109', '0.11', '0.077', '0.08', '0.046', '0.031', '0.019', '0.005', '-0.02', '-0.033', '-0.06', '-0.066', '-0.104', '-0.053', '-0.117', '-0.127', '-0.139', '-0.1', '-0.154', '-0.082', '-0.12', '-0.115', '0.281', '0.753', '0.087', '-1.494', '-0.435', '1.799', '-0.23', '-1.904', '-0.247', '1.834', '-0.414', '-1.571', '0.024', '0.96', '-0.073', 'null', '0', '-0.018', '0.957', '0.411', '1.064', '1.056', '24.669', '0.94', '1.269', 'null', 'null', '-0.203', '-0.196', '-0.204', '-0.192', '-0.18', '-0.174', '-0.145', '-0.14', '-0.124', '-0.066', '-0.085', '-0.066', '-0.039', '-0.018', '0.012', '0.033', '0.059', '0.076', '0.099', '0.122', '0.15', '0.136', '0.184', '0.176', '0.189', '0.142', '0.197', '0.219', '0.27', '0.201', '0.2', '0.2', '0.187', '0.176', '0.157', '0.144', '0.131', '0.111', '0.083', '0.076', '0.031', '0.027', '0.006', '-0.023', '-0.048', '-0.065', '-0.094', '-0.102', '-0.136', '-0.151', '-0.151', '-0.13', '-0.189', '-0.185', '-0.207', '-0.2', '-0.281', '-0.008', '-0.245', '-0.246', '-0.246', '-0.234', '-0.213', '-0.212', '-0.178', '-0.168', '-0.148', '-0.087', '-0.1', '-0.079', '-0.047', '-0.022', '0.015', '0.04', '0.069', '0.095', '0.124', '0.144', '0.175', '0.173', '0.215', '0.216', '0.231', '0.175', '0.246', '0.254', '0.323', '0.248', '0.247', '0.233', '0.232', '0.212', '0.189', '0.178', '0.157', '0.134', '0.103', '0.086', '0.041', '0.034', '0.006', '-0.029', '-0.056', '-0.081', '-0.112', '-0.129', '-0.158', '-0.181', '-0.185', '-0.162', '-0.222', '-0.231', '-0.253', '-0.239', '-0.332', '0.008', '0.002', '-0.15', '-0.15', '-0.163', '-0.161', '-0.135', '-0.146', '-0.11', '-0.115', '-0.096', '-0.049', '-0.07', '-0.053', '-0.029', '-0.015', '0.01', '0.022', '0.048', '0.059', '0.086', '0.089', '0.123', '0.107', '0.152', '0.136', '0.14', '0.122', '0.15', '0.179', '0.222', '0.152', '0.158', '0.156', '0.157', '0.136', '0.126', '0.106', '0.112', '0.085', '0.068', '0.06', '0.027', '0.018', '0.006', '-0.019', '-0.035', '-0.054', '-0.073', '-0.081', '-0.114', '-0.115', '-0.122', '-0.1', '-0.149', '-0.145', '-0.173', '-0.149', '-0.241', '-0.024', '-0.86', '-0.413', '-0.177', '-0.242', '0.439', '1.263', '0.498', '-1.702', '0.194', '1.883', '0.283', '-1.882', '0.368', '1.71', '0.067', '-1.278', '0.007', 'null', '0.001', '-1.553', '-1.011', '-24.557', '-1.023', '-0.969', '-1.024', 'null', '-0.203', '-0.196', '-0.204', '-0.192', '-0.18', '-0.174', '-0.145', '-0.14', '-0.124', '-0.066', '-0.085', '-0.066', '-0.039', '-0.018', '0.012', '0.033', '0.059', '0.076', '0.099', '0.122', '0.15', '0.136', '0.184', '0.176', '0.189', '0.142', '0.197', '0.219', '0.27', '0.201', '0.2', '0.2', '0.187', '0.176', '0.157', '0.144', '0.131', '0.111', '0.083', '0.076', '0.031', '0.027', '0.006', '-0.023', '-0.048', '-0.065', '-0.094', '-0.102', '-0.136', '-0.151', '-0.151', '-0.13', '-0.189', '-0.185', '-0.207', '-0.2', '-0.281', '-0.008', '-0.245', '-0.246', '-0.246', '-0.234', '-0.213', '-0.212', '-0.178', '-0.168', '-0.148', '-0.087', '-0.1', '-0.079', '-0.047', '-0.022', '0.015', '0.04', '0.069', '0.095', '0.124', '0.144', '0.175', '0.173', '0.215', '0.216', '0.231', '0.175', '0.246', '0.254', '0.323', '0.248', '0.247', '0.233', '0.232', '0.212', '0.189', '0.178', '0.157', '0.134', '0.103', '0.086', '0.041', '0.034', '0.006', '-0.029', '-0.056', '-0.081', '-0.112', '-0.129', '-0.158', '-0.181', '-0.185', '-0.162', '-0.222', '-0.231', '-0.253', '-0.239', '-0.332', '0.008', '0.002', '-0.15', '-0.15', '-0.163', '-0.161', '-0.135', '-0.146', '-0.11', '-0.115', '-0.096', '-0.049', '-0.07', '-0.053', '-0.029', '-0.015', '0.01', '0.022', '0.048', '0.059', '0.086', '0.089', '0.123', '0.107', '0.152', '0.136', '0.14', '0.122', '0.15', '0.179', '0.222', '0.152', '0.158', '0.156', '0.157', '0.136', '0.126', '0.106', '0.112', '0.085', '0.068', '0.06', '0.027', '0.018', '0.006', '-0.019', '-0.035', '-0.054', '-0.073', '-0.081', '-0.114', '-0.115', '-0.122', '-0.1', '-0.149', '-0.145', '-0.173', '-0.149', '-0.241', '-0.024', '-0.86', '-0.413', '-0.253', '-0.168', '0.441', '1.281', '0.494', '-1.711', '0.198', '1.884', '0.281', '-1.88', '0.371', '1.702', '0.062', '-1.26', '0.007', 'null', '0', '0.001', '1.479', '1.035', '24.419', '1.034', '0.938', '0.945', 'null', 'null', '-0.204', '-0.188', '-0.213', '-0.185', '-0.191', '-0.118', '-0.169', '-0.14', '-0.122', '-0.101', '-0.086', '-0.076', '-0.025', '-0.019', '0.01', '0.036', '0.055', '0.077', '0.106', '0.111', '0.105', '0.192', '0.162', '0.198', '0.119', '0.215', '0.191', '0.218', '0.265', '0.195', '0.214', '0.186', '0.185', '0.186', '0.153', '0.119', '0.132', '0.108', '0.099', '0.071', '0.055', '0.026', '0.005', '-0.024', '-0.044', '-0.065', '-0.094', '-0.106', '-0.127', '-0.149', '-0.123', '-0.167', '-0.233', '-0.197', '-0.149', '-0.201', '-0.278', '-0.006', '-0.246', '-0.244', '-0.251', '-0.227', '-0.216', '-0.159', '-0.195', '-0.174', '-0.145', '-0.126', '-0.103', '-0.09', '-0.034', '-0.021', '0.013', '0.041', '0.068', '0.094', '0.123', '0.141', '0.125', '0.233', '0.198', '0.226', '0.167', '0.243', '0.245', '0.255', '0.316', '0.247', '0.25', '0.228', '0.233', '0.216', '0.188', '0.143', '0.159', '0.132', '0.122', '0.085', '0.064', '0.034', '0.005', '-0.028', '-0.053', '-0.083', '-0.109', '-0.129', '-0.159', '-0.171', '-0.158', '-0.202', '-0.277', '-0.235', '-0.192', '-0.242', '-0.325', '0.007', '-0.002', '-0.148', '-0.139', '-0.187', '-0.136', '-0.151', '-0.101', '-0.137', '-0.107', '-0.091', '-0.083', '-0.069', '-0.063', '-0.017', '-0.015', '0.008', '0.024', '0.049', '0.059', '0.082', '0.092', '0.077', '0.157', '0.14', '0.141', '0.098', '0.176', '0.14', '0.182', '0.218', '0.144', '0.173', '0.146', '0.144', '0.156', '0.127', '0.078', '0.108', '0.089', '0.081', '0.054', '0.046', '0.018', '0.005', '-0.021', '-0.032', '-0.052', '-0.078', '-0.08', '-0.096', '-0.123', '-0.106', '-0.124', '-0.188', '-0.154', '-0.118', '-0.156', '-0.24', '0.531', '0.793', '0.072', '-1.509', '-0.431', '1.807', '-0.232', '-1.906', '-0.244', '1.829', '-0.419', '-1.558', '0.036', '0.926', '-0.113', 'null', '-0.027', '-1.027', '-0.968', '-24.545', '-1.024', '-0.996', '-0.994', 'null', '-0.204', '-0.188', '-0.213', '-0.185', '-0.191', '-0.118', '-0.169', '-0.14', '-0.122', '-0.101', '-0.086', '-0.076', '-0.025', '-0.019', '0.01', '0.036', '0.055', '0.077', '0.106', '0.111', '0.105', '0.192', '0.162', '0.198', '0.119', '0.215', '0.191', '0.218', '0.265', '0.195', '0.214', '0.186', '0.185', '0.186', '0.153', '0.119', '0.132', '0.108', '0.099', '0.071', '0.055', '0.026', '0.005', '-0.024', '-0.044', '-0.065', '-0.094', '-0.106', '-0.127', '-0.149', '-0.123', '-0.167', '-0.233', '-0.197', '-0.149', '-0.201', '-0.278', '-0.006', '-0.246', '-0.244', '-0.251', '-0.227', '-0.216', '-0.159', '-0.195', '-0.174', '-0.145', '-0.126', '-0.103', '-0.09', '-0.034', '-0.021', '0.013', '0.041', '0.068', '0.094', '0.123', '0.141', '0.125', '0.233', '0.198', '0.226', '0.167', '0.243', '0.245', '0.255', '0.316', '0.247', '0.25', '0.228', '0.233', '0.216', '0.188', '0.143', '0.159', '0.132', '0.122', '0.085', '0.064', '0.034', '0.005', '-0.028', '-0.053', '-0.083', '-0.109', '-0.129', '-0.159', '-0.171', '-0.158', '-0.202', '-0.277', '-0.235', '-0.192', '-0.242', '-0.325', '0.007', '-0.002', '-0.148', '-0.139', '-0.187', '-0.136', '-0.151', '-0.101', '-0.137', '-0.107', '-0.091', '-0.083', '-0.069', '-0.063', '-0.017', '-0.015', '0.008', '0.024', '0.049', '0.059', '0.082', '0.092', '0.077', '0.157', '0.14', '0.141', '0.098', '0.176', '0.14', '0.182', '0.218', '0.144', '0.173', '0.146', '0.144', '0.156', '0.127', '0.078', '0.108', '0.089', '0.081', '0.054', '0.046', '0.018', '0.005', '-0.021', '-0.032', '-0.052', '-0.078', '-0.08', '-0.096', '-0.123', '-0.106', '-0.124', '-0.188', '-0.154', '-0.118', '-0.156', '-0.24', '0.562', '0.754', '0.083', '-1.494', '-0.436', '1.801', '-0.229', '-1.906', '-0.246', '1.835', '-0.416', '-1.572', '0.027', '0.958', '-0.075', 'null', '0', '-0.018', '0.755', '0.481', '1.18', '1.049', '24.762', '0.933', '1.023', 'null', 'null', '-0.202', '-0.207', '-0.188', '-0.181', '-0.172', '-0.154', '-0.137', '-0.122', '-0.098', '-0.066', '-0.074', '-0.027', '-0.018', '0.01', '0.03', '0.058', '0.08', '0.098', '0.117', '0.137', '0.149', '0.173', '0.181', '0.193', '0.201', '0.2', '0.159', '0.266', '0.194', '0.213', '0.195', '0.182', '0.178', '0.165', '0.14', '0.137', '0.101', '0.094', '0.071', '0.047', '0.019', '0.005', '-0.022', '-0.043', '-0.07', '-0.082', '-0.119', '-0.119', '-0.148', '-0.167', '-0.167', '-0.192', '-0.183', '-0.218', '-0.198', '-0.22', '-0.199', '-0.054', '-0.247', '-0.246', '-0.227', '-0.222', '-0.207', '-0.189', '-0.162', '-0.147', '-0.124', '-0.076', '-0.089', '-0.036', '-0.021', '0.012', '0.037', '0.071', '0.097', '0.117', '0.144', '0.163', '0.187', '0.203', '0.222', '0.228', '0.246', '0.245', '0.197', '0.312', '0.247', '0.249', '0.233', '0.226', '0.215', '0.197', '0.177', '0.157', '0.13', '0.111', '0.084', '0.056', '0.026', '0.006', '-0.027', '-0.053', '-0.084', '-0.103', '-0.138', '-0.148', '-0.179', '-0.197', '-0.21', '-0.224', '-0.236', '-0.25', '-0.247', '-0.26', '-0.246', '0.058', '0.051', '-0.16', '-0.17', '-0.142', '-0.155', '-0.125', '-0.132', '-0.102', '-0.101', '-0.08', '-0.046', '-0.063', '-0.019', '-0.014', '0.007', '0.022', '0.047', '0.068', '0.07', '0.093', '0.118', '0.108', '0.143', '0.143', '0.155', '0.164', '0.152', '0.121', '0.224', '0.14', '0.178', '0.156', '0.139', '0.144', '0.141', '0.102', '0.1', '0.089', '0.077', '0.054', '0.038', '0.013', '0.005', '-0.017', '-0.034', '-0.057', '-0.066', '-0.092', '-0.091', '-0.122', '-0.14', '-0.115', '-0.165', '-0.141', '-0.18', '-0.147', '-0.193', '-0.142', '-0.054', '-0.844', '-0.378', '-0.308', '0.439', '1.263', '0.498', '-1.7', '0.192', '1.882', '0.284', '-1.883', '0.372', '1.706', '0.069', '-1.28', '0.005', 'null', '0.001', '-1.568', '-1.005', '-24.536', '-1.026', '-1.004', '-0.981', 'null', '-0.199', '-0.202', '-0.207', '-0.188', '-0.181', '-0.172', '-0.154', '-0.137', '-0.122', '-0.098', '-0.066', '-0.074', '-0.027', '-0.018', '0.01', '0.03', '0.058', '0.08', '0.098', '0.117', '0.137', '0.149', '0.173', '0.181', '0.193', '0.201', '0.2', '0.159', '0.266', '0.194', '0.213', '0.195', '0.182', '0.178', '0.165', '0.14', '0.137', '0.101', '0.094', '0.071', '0.047', '0.019', '0.005', '-0.022', '-0.043', '-0.07', '-0.082', '-0.119', '-0.119', '-0.148', '-0.167', '-0.167', '-0.192', '-0.183', '-0.218', '-0.198', '-0.22', '-0.007', '-0.246', '-0.247', '-0.246', '-0.227', '-0.222', '-0.207', '-0.189', '-0.162', '-0.147', '-0.124', '-0.076', '-0.089', '-0.036', '-0.021', '0.012', '0.037', '0.071', '0.097', '0.117', '0.144', '0.163', '0.187', '0.203', '0.222', '0.228', '0.246', '0.245', '0.197', '0.312', '0.247', '0.249', '0.233', '0.226', '0.215', '0.197', '0.177', '0.157', '0.13', '0.111', '0.084', '0.056', '0.026', '0.006', '-0.027', '-0.053', '-0.084', '-0.103', '-0.138', '-0.148', '-0.179', '-0.197', '-0.21', '-0.224', '-0.236', '-0.25', '-0.247', '-0.26', '0.008', '-0.003', '-0.142', '-0.16', '-0.17', '-0.142', '-0.155', '-0.125', '-0.132', '-0.102', '-0.101', '-0.08', '-0.046', '-0.063', '-0.019', '-0.014', '0.007', '0.022', '0.047', '0.068', '0.07', '0.093', '0.118', '0.108', '0.143', '0.143', '0.155', '0.164', '0.152', '0.121', '0.224', '0.14', '0.178', '0.156', '0.139', '0.144', '0.141', '0.102', '0.1', '0.089', '0.077', '0.054', '0.038', '0.013', '0.005', '-0.017', '-0.034', '-0.057', '-0.066', '-0.092', '-0.091', '-0.122', '-0.14', '-0.115', '-0.165', '-0.141', '-0.18', '-0.147', '-0.193', '-0.022', '-0.866', '-0.412', '-0.148', '-0.279', '0.44', '1.283', '0.492', '-1.709', '0.195', '1.884', '0.282', '-1.88', '0.375', '1.697', '0.064', '-1.262', '0.005', 'null', '0', '0.001', '1.48', '1.026', '24.441', '1.088', '0.316', '1.515', 'null', 'null', '-0.194', '-0.172', '-0.208', '-0.221', '-0.151', '-0.167', '-0.194', '-0.115', '-0.116', '-0.109', '-0.095', '-0.049', '-0.046', '-0.012', '0.009', '0.031', '0.058', '0.062', '0.094', '0.111', '0.16', '0.128', '0.155', '0.232', '0.137', '0.206', '0.194', '0.227', '0.089', '0.144', '0.212', '0.211', '0.14', '0.201', '0.174', '0.203', '0.143', '0.103', '0.136', '0.076', '0.072', '0.051', '0.031', '0.004', '-0.022', '-0.032', '-0.068', '-0.101', '-0.073', '-0.166', '-0.136', '-0.133', '-0.163', '-0.201', '-0.18', '-0.244', '-0.163', '-0.263', '-0.004', '-0.243', '-0.204', '-0.254', '-0.267', '-0.187', '-0.201', '-0.229', '-0.142', '-0.146', '-0.128', '-0.113', '-0.063', '-0.053', '-0.016', '0.011', '0.039', '0.069', '0.074', '0.119', '0.129', '0.199', '0.147', '0.201', '0.262', '0.179', '0.243', '0.245', '0.258', '0.122', '0.177', '0.249', '0.246', '0.19', '0.235', '0.213', '0.234', '0.183', '0.124', '0.165', '0.091', '0.088', '0.062', '0.037', '0.004', '-0.026', '-0.041', '-0.078', '-0.123', '-0.098', '-0.189', '-0.17', '-0.16', '-0.206', '-0.225', '-0.235', '-0.29', '-0.198', '-0.31', '0.006', '-0.006', '-0.125', '-0.152', '-0.168', '-0.18', '-0.114', '-0.125', '-0.16', '-0.097', '-0.089', '-0.081', '-0.08', '-0.036', '-0.038', '-0.01', '0.007', '0.026', '0.047', '0.045', '0.078', '0.082', '0.138', '0.09', '0.129', '0.177', '0.121', '0.164', '0.144', '0.25', '0.128', '0.159', '0.162', '0.115', '0.17', '0.127', '0.173', '0.101', '0.084', '0.108', '0.066', '0.056', '0.036', '0.027', '0.004', '-0.018', '-0.025', '-0.056', '-0.075', '-0.06', '-0.137', '-0.102', '-0.11', '-0.123', '-0.162', '-0.144', '-0.203', '-0.108', '-0.236', '0.518', '0.793', '0.07', '-1.502', '-0.435', '1.811', '-0.236', '-1.901', '-0.248', '1.829', '-0.416', '-1.557', '0.032', '0.927', '-0.111', 'null', '-0.027', '-0.989', '-1.054', '-24.471', '-1.036', '-1.094', '-0.899', 'null', '-0.194', '-0.172', '-0.208', '-0.221', '-0.151', '-0.167', '-0.194', '-0.115', '-0.116', '-0.109', '-0.095', '-0.049', '-0.046', '-0.012', '0.009', '0.031', '0.058', '0.062', '0.094', '0.111', '0.16', '0.128', '0.155', '0.232', '0.137', '0.206', '0.194', '0.227', '0.089', '0.144', '0.212', '0.211', '0.14', '0.201', '0.174', '0.203', '0.143', '0.103', '0.136', '0.076', '0.072', '0.051', '0.031', '0.004', '-0.022', '-0.032', '-0.068', '-0.101', '-0.073', '-0.166', '-0.136', '-0.133', '-0.163', '-0.201', '-0.18', '-0.244', '-0.163', '-0.263', '-0.004', '-0.243', '-0.204', '-0.254', '-0.267', '-0.187', '-0.201', '-0.229', '-0.142', '-0.146', '-0.128', '-0.113', '-0.063', '-0.053', '-0.016', '0.011', '0.039', '0.069', '0.074', '0.119', '0.129', '0.199', '0.147', '0.201', '0.262', '0.179', '0.243', '0.245', '0.258', '0.122', '0.177', '0.249', '0.246', '0.19', '0.235', '0.213', '0.234', '0.183', '0.124', '0.165', '0.091', '0.088', '0.062', '0.037', '0.004', '-0.026', '-0.041', '-0.078', '-0.123', '-0.098', '-0.189', '-0.17', '-0.16', '-0.206', '-0.225', '-0.235', '-0.29', '-0.198', '-0.31', '0.006', '-0.006', '-0.125', '-0.152', '-0.168', '-0.18', '-0.114', '-0.125', '-0.16', '-0.097', '-0.089', '-0.081', '-0.08', '-0.036', '-0.038', '-0.01', '0.007', '0.026', '0.047', '0.045', '0.078', '0.082', '0.138', '0.09', '0.129', '0.177', '0.121', '0.164', '0.144', '0.25', '0.128', '0.159', '0.162', '0.115', '0.17', '0.127', '0.173', '0.101', '0.084', '0.108', '0.066', '0.056', '0.036', '0.027', '0.004', '-0.018', '-0.025', '-0.056', '-0.075', '-0.06', '-0.137', '-0.102', '-0.11', '-0.123', '-0.162', '-0.144', '-0.203', '-0.108', '-0.236', '0.55', '0.75', '0.084', '-1.488', '-0.439', '1.804', '-0.231', '-1.902', '-0.25', '1.834', '-0.413', '-1.569', '0.022', '0.959', '-0.077', 'null', '0', '-0.019', '0.754', '0.535', '1.132', '1.049', '24.72', '0.979', '1.226', 'null', 'null', '-0.197', '-0.205', '-0.206', '-0.182', '-0.189', '-0.168', '-0.158', '-0.14', '-0.124', '-0.097', '-0.078', '-0.062', '-0.034', '-0.015', '0.009', '0.031', '0.055', '0.074', '0.097', '0.122', '0.14', '0.138', '0.174', '0.189', '0.172', '0.208', '0.192', '0.151', '0.29', '0.202', '0.196', '0.201', '0.184', '0.179', '0.166', '0.139', '0.136', '0.118', '0.075', '0.078', '0.048', '0.026', '0.004', '-0.02', '-0.043', '-0.067', '-0.093', '-0.098', '-0.128', '-0.149', '-0.161', '-0.176', '-0.17', '-0.216', '-0.12', '-0.251', '-0.247', '-0.003', '-0.24', '-0.256', '-0.243', '-0.231', '-0.223', '-0.2', '-0.194', '-0.168', '-0.148', '-0.121', '-0.094', '-0.075', '-0.042', '-0.018', '0.011', '0.037', '0.069', '0.09', '0.118', '0.145', '0.166', '0.175', '0.21', '0.219', '0.223', '0.241', '0.176', '0.072', '0.18', '0.337', '0.245', '0.244', '0.241', '0.226', '0.211', '0.203', '0.176', '0.152', '0.147', '0.071', '0.03', '0.086', '0.058', '0.032', '0.004', '-0.024', '-0.054', '-0.079', '-0.109', '-0.127', '-0.15', '-0.18', '-0.192', '-0.211', '-0.22', '-0.242', '-0.16', '-0.263', '-0.062', '-0.269', '0.005', '-0.007', '-0.131', '-0.172', '-0.167', '-0.143', '-0.152', '-0.135', '-0.122', '-0.113', '-0.1', '-0.074', '-0.06', '-0.053', '-0.023', '-0.013', '0.007', '0.023', '0.04', '0.067', '0.069', '0.105', '0.105', '0.109', '0.14', '0.153', '0.133', '0.165', '0.149', '0.126', '0.241', '0.14', '0.169', '0.152', '0.148', '0.147', '0.122', '0.122', '0.104', '0.088', '0.064', '0.062', '0.036', '0.022', '0.004', '-0.015', '-0.034', '-0.054', '-0.075', '-0.079', '-0.098', '-0.117', '-0.135', '-0.134', '-0.137', '-0.179', '-0.087', '-0.193', '-0.217', '-0.023', '-0.86', '-0.425', '-0.152', '-0.275', '0.441', '1.263', '0.499', '-1.703', '0.194', '1.88', '0.286', '-1.883', '0.37', '1.708', '0.07', '-1.281', '-0.002', 'null', '0.001', '-1.565', '-1.014', '-24.517', '-1.03', '-0.985', '-0.992', 'null', '-0.197', '-0.205', '-0.206', '-0.182', '-0.189', '-0.168', '-0.158', '-0.14', '-0.124', '-0.097', '-0.078', '-0.062', '-0.034', '-0.015', '0.009', '0.031', '0.055', '0.074', '0.097', '0.122', '0.14', '0.138', '0.174', '0.189', '0.172', '0.208', '0.192', '0.151', '0.29', '0.202', '0.196', '0.201', '0.184', '0.179', '0.166', '0.139', '0.136', '0.118', '0.075', '0.078', '0.048', '0.026', '0.004', '-0.02', '-0.043', '-0.067', '-0.093', '-0.098', '-0.128', '-0.149', '-0.161', '-0.176', '-0.17', '-0.216', '-0.12', '-0.251', '-0.247', '-0.003', '-0.24', '-0.256', '-0.243', '-0.231', '-0.223', '-0.2', '-0.194', '-0.168', '-0.148', '-0.121', '-0.094', '-0.075', '-0.042', '-0.018', '0.011', '0.037', '0.069', '0.09', '0.118', '0.145', '0.166', '0.175', '0.21', '0.219', '0.223', '0.241', '0.176', '0.072', '0.18', '0.337', '0.245', '0.244', '0.241', '0.226', '0.211', '0.203', '0.176', '0.152', '0.147', '0.071', '0.03', '0.086', '0.058', '0.032', '0.004', '-0.024', '-0.054', '-0.079', '-0.109', '-0.127', '-0.15', '-0.18', '-0.192', '-0.211', '-0.22', '-0.242', '-0.16', '-0.263', '-0.062', '-0.269', '0.005', '-0.007', '-0.131', '-0.172', '-0.167', '-0.143', '-0.152', '-0.135', '-0.122', '-0.113', '-0.1', '-0.074', '-0.06', '-0.053', '-0.023', '-0.013', '0.007', '0.023', '0.04', '0.067', '0.069', '0.105', '0.105', '0.109', '0.14', '0.153', '0.133', '0.165', '0.149', '0.126', '0.241', '0.14', '0.169', '0.152', '0.148', '0.147', '0.122', '0.122', '0.104', '0.088', '0.064', '0.062', '0.036', '0.022', '0.004', '-0.015', '-0.034', '-0.054', '-0.075', '-0.079', '-0.098', '-0.117', '-0.135', '-0.134', '-0.137', '-0.179', '-0.087', '-0.193', '-0.217', '-0.023', '-0.86', '-0.425', '-0.152', '-0.276', '0.442', '1.282', '0.493', '-1.71', '0.196', '1.884', '0.282', '-1.881', '0.374', '1.699', '0.065', '-1.264', '-0.002', 'null', '0', '0.001', '1.476', '0.959', '24.435', '1.096', '0.29', '1.435', 'null', 'null', '-0.214', '-0.197', '-0.193', '-0.181', '-0.171', '-0.156', '-0.139', '-0.12', '-0.103', '-0.082', '-0.058', '-0.039', '-0.014', '0.009', '0.032', '0.053', '0.074', '0.098', '0.119', '0.132', '0.159', '0.16', '0.18', '0.195', '0.184', '0.222', '0.156', '0.101', '0.156', '0.203', '0.21', '0.186', '0.203', '0.164', '0.167', '0.148', '0.133', '0.109', '0.095', '0.069', '0.048', '0.025', '0.005', '-0.019', '-0.044', '-0.064', '-0.086', '-0.115', '-0.115', '-0.15', '-0.16', '-0.172', '-0.19', '-0.195', '-0.188', '-0.215', '-0.214', '-0.201', '-0.055', '-0.247', '-0.247', '-0.231', '-0.217', '-0.211', '-0.187', '-0.167', '-0.149', '-0.124', '-0.096', '-0.074', '-0.045', '-0.018', '0.011', '0.038', '0.065', '0.092', '0.117', '0.144', '0.162', '0.185', '0.201', '0.217', '0.232', '0.236', '0.254', '0.188', '0.125', '0.194', '0.24', '0.258', '0.23', '0.235', '0.212', '0.195', '0.181', '0.157', '0.136', '0.111', '0.085', '0.059', '0.031', '0.006', '-0.025', '-0.052', '-0.078', '-0.104', '-0.134', '-0.149', '-0.176', '-0.192', '-0.214', '-0.222', '-0.24', '-0.23', '-0.263', '-0.248', '-0.257', '0.053', '0.046', '-0.168', '-0.161', '-0.143', '-0.147', '-0.142', '-0.122', '-0.104', '-0.098', '-0.082', '-0.064', '-0.046', '-0.033', '-0.01', '0.008', '0.025', '0.04', '0.063', '0.071', '0.101', '0.1', '0.132', '0.13', '0.131', '0.163', '0.137', '0.185', '0.203', '0.113', '0.174', '0.165', '0.154', '0.153', '0.131', '0.129', '0.116', '0.116', '0.079', '0.078', '0.055', '0.036', '0.021', '0.005', '-0.015', '-0.035', '-0.049', '-0.071', '-0.093', '-0.086', '-0.124', '-0.13', '-0.136', '-0.139', '-0.16', '-0.147', '-0.181', '-0.162', '-0.166', '0.655', '0.794', '0.069', '-1.506', '-0.431', '1.806', '-0.234', '-1.904', '-0.242', '1.828', '-0.421', '-1.552', '0.028', '0.929', '-0.106', 'null', '-0.025', '-1.013', '-1.011', '-24.508', '-1.031', '-1.351', 'null', '-0.188', '-0.215', '-0.214', '-0.201', '-0.214', '-0.197', '-0.193', '-0.181', '-0.171', '-0.156', '-0.139', '-0.12', '-0.103', '-0.082', '-0.058', '-0.039', '-0.014', '0.009', '0.032', '0.053', '0.074', '0.098', '0.119', '0.132', '0.159', '0.16', '0.18', '0.195', '0.184', '0.222', '0.156', '0.101', '0.156', '0.203', '0.21', '0.186', '0.203', '0.164', '0.167', '0.148', '0.133', '0.109', '0.095', '0.069', '0.048', '0.025', '0.005', '-0.019', '-0.044', '-0.064', '-0.086', '-0.115', '-0.115', '-0.15', '-0.16', '-0.172', '-0.19', '-0.195', '0.125', '-0.23', '-0.263', '-0.248', '-0.257', '-0.247', '-0.247', '-0.231', '-0.217', '-0.211', '-0.187', '-0.167', '-0.149', '-0.124', '-0.096', '-0.074', '-0.045', '-0.018', '0.011', '0.038', '0.065', '0.092', '0.117', '0.144', '0.162', '0.185', '0.201', '0.217', '0.232', '0.236', '0.254', '0.188', '0.125', '0.194', '0.24', '0.258', '0.23', '0.235', '0.212', '0.195', '0.181', '0.157', '0.136', '0.111', '0.085', '0.059', '0.031', '0.006', '-0.025', '-0.052', '-0.078', '-0.104', '-0.134', '-0.149', '-0.176', '-0.192', '-0.214', '-0.222', '-0.24', '-0.136', '-0.107', '-0.147', '-0.181', '-0.162', '-0.166', '-0.168', '-0.161', '-0.143', '-0.147', '-0.142', '-0.122', '-0.104', '-0.098', '-0.082', '-0.064', '-0.046', '-0.033', '-0.01', '0.008', '0.025', '0.04', '0.063', '0.071', '0.101', '0.1', '0.132', '0.13', '0.131', '0.163', '0.137', '0.185', '0.203', '0.113', '0.174', '0.165', '0.154', '0.153', '0.131', '0.129', '0.116', '0.116', '0.079', '0.078', '0.055', '0.036', '0.021', '0.005', '-0.015', '-0.035', '-0.049', '-0.071', '-0.093', '-0.086', '-0.124', '-0.13', '-0.136', '-0.139', '-0.16', '0.031', '0.75', '0.083', '-1.49', '-0.437', '1.801', '-0.231', '-1.903', '-0.246', '1.834', '-0.417', '-1.565', '0.018', '0.959', '-0.071', 'null', '0', '-0.018', '0.924', '0.411', '1.088', '1.055', '24.717', '0.939', '1.072', 'null', 'null', '-0.212', '-0.195', '-0.195', '-0.186', '-0.165', '-0.157', '-0.136', '-0.131', '-0.1', '-0.08', '-0.059', '-0.041', '-0.014', '0.008', '0.031', '0.052', '0.074', '0.103', '0.108', '0.144', '0.142', '0.168', '0.183', '0.189', '0.203', '0.198', '0.178', '0.098', '0.139', '0.217', '0.2', '0.191', '0.199', '0.17', '0.159', '0.151', '0.136', '0.11', '0.094', '0.07', '0.05', '0.025', '0.006', '-0.018', '-0.045', '-0.063', '-0.085', '-0.113', '-0.114', '-0.158', '-0.149', '-0.175', '-0.186', '-0.188', '-0.208', '-0.206', '-0.217', '-0.2', '-0.053', '-0.248', '-0.239', '-0.239', '-0.218', '-0.21', '-0.186', '-0.164', '-0.155', '-0.125', '-0.098', '-0.071', '-0.048', '-0.018', '0.01', '0.037', '0.064', '0.09', '0.122', '0.136', '0.165', '0.185', '0.194', '0.224', '0.232', '0.238', '0.248', '0.206', '0.123', '0.171', '0.257', '0.252', '0.23', '0.23', '0.216', '0.195', '0.178', '0.162', '0.137', '0.111', '0.087', '0.061', '0.03', '0.006', '-0.023', '-0.052', '-0.078', '-0.102', '-0.131', '-0.151', '-0.177', '-0.189', '-0.214', '-0.223', '-0.233', '-0.241', '-0.257', '-0.251', '-0.256', '0.053', '0.045', '-0.176', '-0.135', '-0.166', '-0.153', '-0.124', '-0.133', '-0.096', '-0.11', '-0.079', '-0.065', '-0.043', '-0.036', '-0.009', '0.007', '0.024', '0.041', '0.057', '0.084', '0.083', '0.125', '0.093', '0.145', '0.146', '0.151', '0.162', '0.15', '0.152', '0.072', '0.1', '0.189', '0.161', '0.137', '0.167', '0.13', '0.133', '0.111', '0.112', '0.091', '0.069', '0.056', '0.043', '0.019', '0.005', '-0.014', '-0.037', '-0.049', '-0.066', '-0.089', '-0.094', '-0.124', '-0.125', '-0.134', '-0.142', '-0.149', '-0.172', '-0.157', '-0.178', '-0.16', '0.101', '-1.264', '0.063', '1.703', '0.374', '-1.883', '0.284', '1.882', '0.197', '-1.708', '0.492', '1.284', '0.35', 'null', '0.091', '-0.279', '-0.359', '-0.482', '-0.682', '-0.614', '-0.497', '-0.2', '-0.751', '-1.079', '-24.658', '-0.919', '-1.074', 'null', '-0.217', '-0.2', '-0.212', '-0.195', '-0.195', '-0.186', '-0.165', '-0.157', '-0.136', '-0.131', '-0.1', '-0.08', '-0.059', '-0.041', '-0.014', '0.008', '0.031', '0.052', '0.074', '0.103', '0.108', '0.144', '0.142', '0.168', '0.183', '0.189', '0.203', '0.198', '0.178', '0.098', '0.139', '0.217', '0.2', '0.191', '0.199', '0.17', '0.159', '0.151', '0.136', '0.11', '0.094', '0.07', '0.05', '0.025', '0.006', '-0.018', '-0.045', '-0.063', '-0.085', '-0.113', '-0.114', '-0.158', '-0.149', '-0.175', '-0.186', '-0.188', '-0.208', '-0.206', '0.037', '-0.251', '-0.256', '-0.248', '-0.239', '-0.239', '-0.218', '-0.21', '-0.186', '-0.164', '-0.155', '-0.125', '-0.098', '-0.071', '-0.048', '-0.018', '0.01', '0.037', '0.064', '0.09', '0.122', '0.136', '0.165', '0.185', '0.194', '0.224', '0.232', '0.238', '0.248', '0.206', '0.123', '0.171', '0.257', '0.252', '0.23', '0.23', '0.216', '0.195', '0.178', '0.162', '0.137', '0.111', '0.087', '0.061', '0.03', '0.006', '-0.023', '-0.052', '-0.078', '-0.102', '-0.131', '-0.151', '-0.177', '-0.189', '-0.214', '-0.223', '-0.233', '-0.241', '-0.257', '-0.045', '-0.026', '-0.178', '-0.16', '-0.176', '-0.135', '-0.166', '-0.153', '-0.124', '-0.133', '-0.096', '-0.11', '-0.079', '-0.065', '-0.043', '-0.036', '-0.009', '0.007', '0.024', '0.041', '0.057', '0.084', '0.083', '0.125', '0.093', '0.145', '0.146', '0.151', '0.162', '0.15', '0.152', '0.072', '0.1', '0.189', '0.161', '0.137', '0.167', '0.13', '0.133', '0.111', '0.112', '0.091', '0.069', '0.056', '0.043', '0.019', '0.005', '-0.014', '-0.037', '-0.049', '-0.066', '-0.089', '-0.094', '-0.124', '-0.125', '-0.134', '-0.142', '-0.149', '-0.172', '-0.157', '-0.219', '-1.282', '0.068', '1.712', '0.371', '-1.886', '0.286', '1.88', '0.193', '-1.699', '0.499', '1.265', '0.349', '0', '0.091', '-0.249', '-0.352', '-0.963', 'null', '-0.199', '-0.224', '-0.198', '-0.194', '-0.203', '-0.193', '-0.156', '-0.17', '-0.141', '-0.12', '-0.112', '-0.083', '-0.065', '-0.041', '-0.019', '0.006', '0.026', '0.048', '0.074', '0.093', '0.111', '0.136', '0.142', '0.171', '0.171', '0.191', '0.197', '0.208', '0.206', '0.111', '0.091', '0.207', '0.215', '0.189', '0.203', '0.17', '0.169', '0.144', '0.144', '0.112', '0.094', '0.081', '0.048', '0.03', '0.008', '-0.015', '-0.038', '-0.06', '-0.086', '-0.099', '-0.128', '-0.139', '-0.151', '-0.169', '-0.193', '-0.19', '-0.197', '-0.213', '0.053', '-0.256', '-0.257', '-0.243', '-0.244', '-0.236', '-0.235', '-0.191', '-0.204', '-0.172', '-0.15', '-0.128', '-0.105', '-0.077', '-0.05', '-0.023', '0.006', '0.031', '0.06', '0.09', '0.112', '0.136', '0.157', '0.183', '0.202', '0.207', '0.227', '0.247', '0.242', '0.258', '0.124', '0.123', '0.25', '0.25', '0.242', '0.231', '0.218', '0.196', '0.185', '0.165', '0.138', '0.114', '0.097', '0.06', '0.036', '0.01', '-0.018', '-0.048', '-0.073', '-0.101', '-0.126', '-0.148', '-0.167', '-0.193', '-0.201', '-0.224', '-0.242', '-0.234', '-0.251', '-0.051', '-0.044', '-0.162', '-0.183', '-0.152', '-0.15', '-0.169', '-0.144', '-0.13', '-0.137', '-0.106', '-0.099', '-0.087', '-0.07', '-0.048', '-0.034', '-0.015', '0.006', '0.018', '0.041', '0.057', '0.074', '0.087', '0.12', '0.097', '0.135', '0.15', '0.144', '0.156', '0.158', '0.268', '0.062', '0.16', '0.181', '0.139', '0.172', '0.132', '0.132', '0.119', '0.115', '0.077', '0.087', '0.059', '0.04', '0.022', '0.008', '-0.01', '-0.034', '-0.042', '-0.077', '-0.073', '-0.103', '-0.114', '-0.112', '-0.14', '-0.15', '-0.157', '-0.147', '-0.171', '0.323', '0.745', '0.091', '-1.493', '-0.436', '1.801', '-0.231', '-1.904', '-0.246', '1.831', '-0.414', '-1.569', '0.022', '0.959', '-0.078', 'null', '-0.018', '0.903', '0.414', '1.105', '1.048', '24.78', '0.933', '1.053', 'null', '-0.198', '-0.194', '-0.203', '-0.193', '-0.156', '-0.17', '-0.141', '-0.12', '-0.112', '-0.083', '-0.065', '-0.041', '-0.019', '0.006', '0.026', '0.048', '0.074', '0.093', '0.111', '0.136', '0.142', '0.171', '0.171', '0.191', '0.197', '0.208', '0.206', '0.111', '0.091', '0.207', '0.215', '0.189', '0.203', '0.17', '0.169', '0.144', '0.144', '0.112', '0.094', '0.081', '0.048', '0.03', '0.008', '-0.015', '-0.038', '-0.06', '-0.086', '-0.099', '-0.128', '-0.139', '-0.151', '-0.169', '-0.193', '-0.19', '-0.197', '-0.213', '-0.199', '-0.224', '-0.037', '-0.243', '-0.244', '-0.236', '-0.235', '-0.191', '-0.204', '-0.172', '-0.15', '-0.128', '-0.105', '-0.077', '-0.05', '-0.023', '0.006', '0.031', '0.06', '0.09', '0.112', '0.136', '0.157', '0.183', '0.202', '0.207', '0.227', '0.247', '0.242', '0.258', '0.124', '0.123', '0.25', '0.25', '0.242', '0.231', '0.218', '0.196', '0.185', '0.165', '0.138', '0.114', '0.097', '0.06', '0.036', '0.01', '-0.018', '-0.048', '-0.073', '-0.101', '-0.126', '-0.148', '-0.167', '-0.193', '-0.201', '-0.224', '-0.242', '-0.234', '-0.251', '-0.256', '-0.257', '0.044', '0.029', '-0.152', '-0.15', '-0.169', '-0.144', '-0.13', '-0.137', '-0.106', '-0.099', '-0.087', '-0.07', '-0.048', '-0.034', '-0.015', '0.006', '0.018', '0.041', '0.057', '0.074', '0.087', '0.12', '0.097', '0.135', '0.15', '0.144', '0.156', '0.158', '0.268', '0.062', '0.16', '0.181', '0.139', '0.172', '0.132', '0.132', '0.119', '0.115', '0.077', '0.087', '0.059', '0.04', '0.022', '0.008', '-0.01', '-0.034', '-0.042', '-0.077', '-0.073', '-0.103', '-0.114', '-0.112', '-0.14', '-0.15', '-0.157', '-0.147', '-0.171', '-0.162', '-0.183', '0.636', '0.79', '0.075', '-1.507', '-0.432', '1.806', '-0.234', '-1.904', '-0.242', '1.826', '-0.418', '-1.557', '0.031', '0.929', '-0.079', '0', '-0.019', '-0.687', '-0.348', '-0.198', '-0.011', '0.173', '0.34', '0.999', 'null', '-0.212', '-0.198', '-0.195', '-0.18', '-0.177', '-0.161', '-0.136', '-0.127', '-0.107', '-0.082', '-0.067', '-0.041', '-0.017', '0.005', '0.028', '0.05', '0.074', '0.091', '0.117', '0.13', '0.144', '0.171', '0.179', '0.184', '0.199', '0.206', '0.207', '0.106', '0.097', '0.216', '0.203', '0.197', '0.187', '0.19', '0.148', '0.153', '0.145', '0.109', '0.097', '0.072', '0.055', '0.029', '0.007', '-0.016', '-0.037', '-0.064', '-0.08', '-0.106', '-0.126', '-0.14', '-0.153', '-0.176', '-0.184', '-0.195', '-0.192', '-0.208', '-0.216', '-0.203', '-0.048', '-0.245', '-0.248', '-0.233', '-0.219', '-0.213', '-0.194', '-0.166', '-0.154', '-0.129', '-0.101', '-0.081', '-0.047', '-0.022', '0.006', '0.032', '0.063', '0.087', '0.112', '0.138', '0.163', '0.179', '0.196', '0.218', '0.23', '0.239', '0.244', '0.258', '0.123', '0.124', '0.256', '0.244', '0.244', '0.222', '0.226', '0.193', '0.184', '0.165', '0.138', '0.115', '0.089', '0.065', '0.035', '0.009', '-0.019', '-0.048', '-0.074', '-0.101', '-0.125', '-0.151', '-0.174', '-0.182', '-0.214', '-0.22', '-0.238', '-0.235', '-0.25', '-0.258', '-0.256', '0.046', '0.037', '-0.166', '-0.15', '-0.165', '-0.131', '-0.149', '-0.127', '-0.105', '-0.103', '-0.082', '-0.067', '-0.056', '-0.031', '-0.013', '0.005', '0.022', '0.039', '0.059', '0.076', '0.085', '0.112', '0.103', '0.143', '0.153', '0.134', '0.159', '0.157', '0.257', '0.072', '0.179', '0.159', '0.154', '0.144', '0.166', '0.1', '0.134', '0.109', '0.084', '0.082', '0.055', '0.046', '0.021', '0.007', '-0.011', '-0.031', '-0.048', '-0.069', '-0.081', '-0.103', '-0.111', '-0.12', '-0.137', '-0.143', '-0.164', '-0.159', '-0.14', '-0.19', '-0.164', '0.081', '-1.265', '0.066', '1.702', '0.372', '-1.882', '0.284', '1.883', '0.196', '-1.71', '0.494', '1.285', '0.35', 'null', '0.091', '-0.295', '-0.497', '-0.535', '-0.556', '-0.56', '-0.489', '-0.1', '-0.831', '-1.078', '-24.625', '-0.934', '-1.063', 'null', '-0.216', '-0.203', '-0.212', '-0.198', '-0.195', '-0.18', '-0.177', '-0.161', '-0.136', '-0.127', '-0.107', '-0.082', '-0.067', '-0.041', '-0.017', '0.005', '0.028', '0.05', '0.074', '0.091', '0.117', '0.13', '0.144', '0.171', '0.179', '0.184', '0.199', '0.206', '0.207', '0.106', '0.097', '0.216', '0.203', '0.197', '0.187', '0.19', '0.148', '0.153', '0.145', '0.109', '0.097', '0.072', '0.055', '0.029', '0.007', '-0.016', '-0.037', '-0.064', '-0.08', '-0.106', '-0.126', '-0.14', '-0.153', '-0.176', '-0.184', '-0.195', '-0.192', '-0.208', '0.047', '-0.258', '-0.256', '-0.245', '-0.248', '-0.233', '-0.219', '-0.213', '-0.194', '-0.166', '-0.154', '-0.129', '-0.101', '-0.081', '-0.047', '-0.022', '0.006', '0.032', '0.063', '0.087', '0.112', '0.138', '0.163', '0.179', '0.196', '0.218', '0.23', '0.239', '0.244', '0.258', '0.123', '0.124', '0.256', '0.244', '0.244', '0.222', '0.226', '0.193', '0.184', '0.165', '0.138', '0.115', '0.089', '0.065', '0.035', '0.009', '-0.019', '-0.048', '-0.074', '-0.101', '-0.125', '-0.151', '-0.174', '-0.182', '-0.214', '-0.22', '-0.238', '-0.235', '-0.25', '-0.05', '-0.027', '-0.19', '-0.164', '-0.166', '-0.15', '-0.165', '-0.131', '-0.149', '-0.127', '-0.105', '-0.103', '-0.082', '-0.067', '-0.056', '-0.031', '-0.013', '0.005', '0.022', '0.039', '0.059', '0.076', '0.085', '0.112', '0.103', '0.143', '0.153', '0.134', '0.159', '0.157', '0.257', '0.072', '0.179', '0.159', '0.154', '0.144', '0.166', '0.1', '0.134', '0.109', '0.084', '0.082', '0.055', '0.046', '0.021', '0.007', '-0.011', '-0.031', '-0.048', '-0.069', '-0.081', '-0.103', '-0.111', '-0.12', '-0.137', '-0.143', '-0.164', '-0.159', '-0.14', '-0.255', '-1.283', '0.072', '1.71', '0.369', '-1.884', '0.285', '1.881', '0.193', '-1.702', '0.502', '1.264', '0.349', '0', '0.092', '-0.238', '-0.34', '-0.996', 'null', '-0.208', '-0.208', '-0.204', '-0.208', '-0.192', '-0.179', '-0.178', '-0.152', '-0.145', '-0.124', '-0.104', '-0.088', '-0.06', '-0.04', '-0.018', '0.006', '0.027', '0.052', '0.075', '0.093', '0.106', '0.14', '0.156', '0.157', '0.179', '0.18', '0.217', '0.182', '0.235', '0.089', '0.097', '0.224', '0.192', '0.207', '0.18', '0.191', '0.152', '0.155', '0.137', '0.112', '0.093', '0.074', '0.055', '0.027', '0.006', '-0.017', '-0.038', '-0.065', '-0.084', '-0.1', '-0.121', '-0.14', '-0.176', '-0.146', '-0.206', '-0.182', '-0.204', '-0.209', '0.052', '-0.259', '-0.257', '-0.24', '-0.256', '-0.225', '-0.229', '-0.205', '-0.189', '-0.175', '-0.152', '-0.124', '-0.103', '-0.078', '-0.047', '-0.022', '0.008', '0.032', '0.064', '0.087', '0.117', '0.13', '0.168', '0.184', '0.193', '0.217', '0.228', '0.244', '0.241', '0.261', '0.121', '0.124', '0.256', '0.246', '0.243', '0.224', '0.221', '0.194', '0.182', '0.169', '0.135', '0.112', '0.091', '0.064', '0.034', '0.008', '-0.02', '-0.048', '-0.076', '-0.103', '-0.122', '-0.15', '-0.166', '-0.204', '-0.197', '-0.232', '-0.227', '-0.253', '-0.239', '-0.049', '-0.034', '-0.177', '-0.173', '-0.152', '-0.174', '-0.148', '-0.129', '-0.162', '-0.111', '-0.121', '-0.096', '-0.076', '-0.077', '-0.045', '-0.033', '-0.013', '0.006', '0.019', '0.044', '0.056', '0.075', '0.09', '0.103', '0.13', '0.125', '0.14', '0.145', '0.176', '0.129', '0.264', '0.078', '0.187', '0.142', '0.158', '0.164', '0.136', '0.12', '0.139', '0.093', '0.099', '0.069', '0.057', '0.047', '0.019', '0.006', '-0.011', '-0.035', '-0.05', '-0.068', '-0.082', '-0.087', '-0.118', '-0.142', '-0.099', '-0.183', '-0.135', '-0.174', '-0.145', '0.318', '0.751', '0.089', '-1.492', '-0.439', '1.803', '-0.231', '-1.906', '-0.246', '1.835', '-0.415', '-1.57', '0.023', '0.96', '-0.077', 'null', '-0.017', '0.9', '0.427', '1.09', '1.051', '24.764', '0.93', '0.863', 'null', '-0.208', '-0.192', '-0.179', '-0.178', '-0.152', '-0.145', '-0.124', '-0.104', '-0.088', '-0.06', '-0.04', '-0.018', '0.006', '0.027', '0.052', '0.075', '0.093', '0.106', '0.14', '0.156', '0.157', '0.179', '0.18', '0.217', '0.182', '0.235', '0.089', '0.097', '0.224', '0.192', '0.207', '0.18', '0.191', '0.152', '0.155', '0.137', '0.112', '0.093', '0.074', '0.055', '0.027', '0.006', '-0.017', '-0.038', '-0.065', '-0.084', '-0.1', '-0.121', '-0.14', '-0.176', '-0.146', '-0.206', '-0.182', '-0.204', '-0.209', '-0.208', '-0.208', '-0.204', '-0.084', '-0.256', '-0.225', '-0.229', '-0.205', '-0.189', '-0.175', '-0.152', '-0.124', '-0.103', '-0.078', '-0.047', '-0.022', '0.008', '0.032', '0.064', '0.087', '0.117', '0.13', '0.168', '0.184', '0.193', '0.217', '0.228', '0.244', '0.241', '0.261', '0.121', '0.124', '0.256', '0.246', '0.243', '0.224', '0.221', '0.194', '0.182', '0.169', '0.135', '0.112', '0.091', '0.064', '0.034', '0.008', '-0.02', '-0.048', '-0.076', '-0.103', '-0.122', '-0.15', '-0.166', '-0.204', '-0.197', '-0.232', '-0.227', '-0.253', '-0.239', '-0.259', '-0.257', '-0.24', '0.095', '0.076', '-0.174', '-0.148', '-0.129', '-0.162', '-0.111', '-0.121', '-0.096', '-0.076', '-0.077', '-0.045', '-0.033', '-0.013', '0.006', '0.019', '0.044', '0.056', '0.075', '0.09', '0.103', '0.13', '0.125', '0.14', '0.145', '0.176', '0.129', '0.264', '0.078', '0.187', '0.142', '0.158', '0.164', '0.136', '0.12', '0.139', '0.093', '0.099', '0.069', '0.057', '0.047', '0.019', '0.006', '-0.011', '-0.035', '-0.05', '-0.068', '-0.082', '-0.087', '-0.118', '-0.142', '-0.099', '-0.183', '-0.135', '-0.174', '-0.145', '-0.177', '-0.173', '-0.152', '0.788', '0.796', '0.073', '-1.507', '-0.434', '1.809', '-0.235', '-1.906', '-0.243', '1.83', '-0.417', '-1.559', '0.033', '0.929', '-0.114'];
                relative_pos_y = ['null', '0.015', '-0.003', '-0.019', '-0.04', '-0.04', '-0.066', '-0.088', '-0.098', '-0.109', '-0.131', '-0.136', '-0.154', '-0.14', '-0.207', '-0.114', '-0.219', '-0.155', '-0.167', '-0.154', '-0.164', '-0.09', '-0.172', '-0.115', '-0.11', '-0.089', '-0.087', '-0.05', '-0.047', '-0.023', '-0.006', '0.009', '0.032', '0.048', '0.037', '0.112', '0.058', '0.115', '0.109', '0.173', '0.153', '0.144', '0.109', '0.177', '0.149', '0.214', '0.177', '0.139', '0.158', '0.149', '0.136', '0.131', '0.112', '0.072', '0.091', '0.089', '0.048', '0.037', '0.396', '0.019', '-0.003', '-0.026', '-0.047', '-0.052', '-0.087', '-0.107', '-0.131', '-0.134', '-0.164', '-0.177', '-0.184', '-0.191', '-0.255', '-0.154', '-0.264', '-0.204', '-0.211', '-0.193', '-0.202', '-0.124', '-0.213', '-0.153', '-0.133', '-0.117', '-0.102', '-0.072', '-0.054', '-0.032', '-0.008', '0.013', '0.037', '0.062', '0.054', '0.128', '0.09', '0.133', '0.151', '0.211', '0.189', '0.189', '0.139', '0.217', '0.203', '0.262', '0.213', '0.195', '0.195', '0.184', '0.177', '0.164', '0.135', '0.102', '0.112', '0.111', '0.063', '0.046', '-0.434', '-0.348', '0.011', '-0.003', '-0.014', '-0.029', '-0.028', '-0.052', '-0.066', '-0.064', '-0.088', '-0.1', '-0.093', '-0.121', '-0.091', '-0.173', '-0.066', '-0.174', '-0.115', '-0.117', '-0.104', '-0.197', '-0.123', '-0.09', '-0.082', '-0.064', '-0.071', '-0.03', '-0.036', '-0.016', '-0.006', '0.007', '0.027', '0.035', '0.017', '0.094', '0.041', '0.082', '0.075', '0.127', '0.124', '0.109', '0.074', '0.124', '0.111', '0.165', '0.143', '0.084', '0.12', '0.114', '0.097', '0.105', '0.076', '0.057', '0.062', '0.072', '0.031', '0.029', '0.28', '-0.2', '-0.372', '-0.46', '-0.491', '0.045', '1.041', '-0.148', '-1.311', '-0.279', '1.305', '-0.423', '-1.025', '-0.349', 'null', '-0.092', '0.148', '0.678', '-0.156', '1.857', '-0.29', '0.621', 'null', '-0.04', '-0.04', '-0.066', '-0.088', '-0.098', '-0.109', '-0.131', '-0.136', '-0.154', '-0.14', '-0.207', '-0.114', '-0.219', '-0.155', '-0.167', '-0.154', '-0.164', '-0.09', '-0.172', '-0.115', '-0.11', '-0.089', '-0.087', '-0.05', '-0.047', '-0.023', '-0.006', '0.009', '0.032', '0.048', '0.037', '0.112', '0.058', '0.115', '0.109', '0.173', '0.153', '0.144', '0.109', '0.177', '0.149', '0.214', '0.177', '0.139', '0.158', '0.149', '0.136', '0.131', '0.112', '0.072', '0.091', '0.089', '0.048', '0.037', '0.015', '-0.003', '-0.019', '0.393', '-0.047', '-0.052', '-0.087', '-0.107', '-0.131', '-0.134', '-0.164', '-0.177', '-0.184', '-0.191', '-0.255', '-0.154', '-0.264', '-0.204', '-0.211', '-0.193', '-0.202', '-0.124', '-0.213', '-0.153', '-0.133', '-0.117', '-0.102', '-0.072', '-0.054', '-0.032', '-0.008', '0.013', '0.037', '0.062', '0.054', '0.128', '0.09', '0.133', '0.151', '0.211', '0.189', '0.189', '0.139', '0.217', '0.203', '0.262', '0.213', '0.195', '0.195', '0.184', '0.177', '0.164', '0.135', '0.102', '0.112', '0.111', '0.063', '0.046', '0.019', '-0.003', '-0.026', '-0.432', '-0.346', '-0.029', '-0.028', '-0.052', '-0.066', '-0.064', '-0.088', '-0.1', '-0.093', '-0.121', '-0.091', '-0.173', '-0.066', '-0.174', '-0.115', '-0.117', '-0.104', '-0.197', '-0.123', '-0.09', '-0.082', '-0.064', '-0.071', '-0.03', '-0.036', '-0.016', '-0.006', '0.007', '0.027', '0.035', '0.017', '0.094', '0.041', '0.082', '0.075', '0.127', '0.124', '0.109', '0.074', '0.124', '0.111', '0.165', '0.143', '0.084', '0.12', '0.114', '0.097', '0.105', '0.076', '0.057', '0.062', '0.072', '0.031', '0.029', '0.011', '-0.003', '-0.014', '0.278', '-0.354', '-0.429', '-0.716', '0.045', '1.028', '-0.144', '-1.307', '-0.282', '1.308', '-0.418', '-1.04', '-0.345', '0', '-0.09', '0.316', '0.439', '0.56', '0.598', '0.27', '0.767', '0.101', 'null', '-0.037', '-0.065', '-0.077', '-0.095', '-0.129', '-0.112', '-0.158', '-0.15', '-0.17', '-0.177', '-0.182', '-0.175', '-0.198', '-0.186', '-0.178', '-0.189', '-0.161', '-0.161', '-0.163', '-0.13', '-0.123', '-0.107', '-0.09', '-0.068', '-0.052', '-0.031', '-0.01', '0.01', '0.031', '0.052', '0.068', '0.09', '0.107', '0.123', '0.13', '0.163', '0.161', '0.161', '0.189', '0.178', '0.186', '0.198', '0.175', '0.182', '0.177', '0.17', '0.15', '0.158', '0.112', '0.129', '0.095', '0.077', '0.062', '0.041', '0.02', '0', '-0.021', '0.396', '-0.049', '-0.076', '-0.1', '-0.118', '-0.15', '-0.149', '-0.189', '-0.187', '-0.215', '-0.206', '-0.234', '-0.222', '-0.239', '-0.226', '-0.222', '-0.23', '-0.203', '-0.203', '-0.194', '-0.163', '-0.154', '-0.13', '-0.111', '-0.086', '-0.065', '-0.036', '-0.013', '0.013', '0.036', '0.065', '0.086', '0.111', '0.13', '0.154', '0.163', '0.194', '0.203', '0.203', '0.23', '0.222', '0.226', '0.239', '0.222', '0.234', '0.206', '0.215', '0.187', '0.189', '0.149', '0.15', '0.118', '0.1', '0.076', '0.049', '0.025', '0', '-0.025', '-0.434', '-0.347', '-0.029', '-0.046', '-0.067', '-0.069', '-0.1', '-0.086', '-0.119', '-0.121', '-0.128', '-0.134', '-0.149', '-0.117', '-0.175', '-0.121', '-0.15', '-0.152', '-0.106', '-0.131', '-0.132', '-0.097', '-0.091', '-0.084', '-0.072', '-0.049', '-0.044', '-0.02', '-0.008', '0.008', '0.02', '0.044', '0.049', '0.072', '0.084', '0.091', '0.097', '0.132', '0.131', '0.106', '0.152', '0.15', '0.121', '0.175', '0.117', '0.149', '0.134', '0.128', '0.121', '0.119', '0.086', '0.1', '0.069', '0.068', '0.045', '0.029', '0.016', '0', '-0.016', '0.277', '-0.151', '-0.374', '-0.348', '-0.66', '-0.015', '1.126', '-0.092', '-1.508', '-0.34', '1.623', '-0.328', '-1.532', '-0.113', '1.191', '0.013', 'null', '0.002', '0.1', '0.031', '0.933', '-0.38', '0.931', 'null', '0.02', '0', '-0.021', '-0.037', '-0.065', '-0.077', '-0.095', '-0.129', '-0.112', '-0.158', '-0.15', '-0.17', '-0.177', '-0.182', '-0.175', '-0.198', '-0.186', '-0.178', '-0.189', '-0.161', '-0.161', '-0.163', '-0.13', '-0.123', '-0.107', '-0.09', '-0.068', '-0.052', '-0.031', '-0.01', '0.01', '0.031', '0.052', '0.068', '0.09', '0.107', '0.123', '0.13', '0.163', '0.161', '0.161', '0.189', '0.178', '0.186', '0.198', '0.175', '0.182', '0.177', '0.17', '0.15', '0.158', '0.112', '0.129', '0.095', '0.077', '0.062', '0.041', '0.395', '0.025', '0', '-0.025', '-0.049', '-0.076', '-0.1', '-0.118', '-0.15', '-0.149', '-0.189', '-0.187', '-0.215', '-0.206', '-0.234', '-0.222', '-0.239', '-0.226', '-0.222', '-0.23', '-0.203', '-0.203', '-0.194', '-0.163', '-0.154', '-0.13', '-0.111', '-0.086', '-0.065', '-0.036', '-0.013', '0.013', '0.036', '0.065', '0.086', '0.111', '0.13', '0.154', '0.163', '0.194', '0.203', '0.203', '0.23', '0.222', '0.226', '0.239', '0.222', '0.234', '0.206', '0.215', '0.187', '0.189', '0.149', '0.15', '0.118', '0.1', '0.076', '0.049', '-0.434', '-0.347', '0.016', '0', '-0.016', '-0.029', '-0.046', '-0.067', '-0.069', '-0.1', '-0.086', '-0.119', '-0.121', '-0.128', '-0.134', '-0.149', '-0.117', '-0.175', '-0.121', '-0.15', '-0.152', '-0.106', '-0.131', '-0.132', '-0.097', '-0.091', '-0.084', '-0.072', '-0.049', '-0.044', '-0.02', '-0.008', '0.008', '0.02', '0.044', '0.049', '0.072', '0.084', '0.091', '0.097', '0.132', '0.131', '0.106', '0.152', '0.15', '0.121', '0.175', '0.117', '0.149', '0.134', '0.128', '0.121', '0.119', '0.086', '0.1', '0.069', '0.068', '0.045', '0.029', '0.273', '-0.419', '-0.43', '-0.661', '-0.015', '1.107', '-0.087', '-1.501', '-0.342', '1.622', '-0.326', '-1.537', '-0.118', '1.207', '0.013', '0', '0.002', '0.69', '0.49', '0.517', '0.097', 'null', '0.024', '0', '-0.024', '-0.044', '-0.066', '-0.094', '-0.103', '-0.134', '-0.15', '-0.159', '-0.161', '-0.208', '-0.182', '-0.216', '-0.189', '-0.222', '-0.207', '-0.198', '-0.21', '-0.192', '-0.175', '-0.164', '-0.158', '-0.14', '-0.115', '-0.106', '-0.074', '-0.058', '-0.035', '-0.011', '0.011', '0.035', '0.058', '0.074', '0.106', '0.115', '0.14', '0.158', '0.164', '0.175', '0.192', '0.21', '0.198', '0.207', '0.222', '0.189', '0.216', '0.182', '0.208', '0.161', '0.159', '0.15', '0.134', '0.103', '0.094', '0.066', '0.044', '0.396', '0.028', '0', '-0.028', '-0.055', '-0.082', '-0.109', '-0.13', '-0.159', '-0.179', '-0.193', '-0.204', '-0.243', '-0.224', '-0.251', '-0.247', '-0.261', '-0.247', '-0.244', '-0.251', '-0.227', '-0.221', '-0.198', '-0.189', '-0.173', '-0.139', '-0.122', '-0.094', '-0.071', '-0.04', '-0.014', '0.014', '0.04', '0.071', '0.094', '0.122', '0.139', '0.173', '0.189', '0.198', '0.221', '0.227', '0.251', '0.244', '0.247', '0.261', '0.247', '0.251', '0.224', '0.243', '0.204', '0.193', '0.179', '0.159', '0.13', '0.109', '0.082', '0.055', '-0.434', '-0.348', '0.02', '0', '-0.02', '-0.031', '-0.055', '-0.074', '-0.083', '-0.11', '-0.114', '-0.124', '-0.14', '-0.157', '-0.142', '-0.18', '-0.133', '-0.199', '-0.154', '-0.148', '-0.179', '-0.149', '-0.134', '-0.142', '-0.11', '-0.119', '-0.09', '-0.09', '-0.052', '-0.052', '-0.023', '-0.009', '0.009', '0.023', '0.052', '0.052', '0.09', '0.09', '0.119', '0.11', '0.142', '0.134', '0.149', '0.179', '0.148', '0.154', '0.199', '0.133', '0.18', '0.142', '0.157', '0.14', '0.124', '0.114', '0.11', '0.083', '0.074', '0.055', '0.031', '0.272', '-0.095', '-0.239', '-0.407', '-0.279', '-0.663', '-0.014', '1.283', '-0.071', '-1.708', '-0.372', '1.884', '-0.281', '-1.883', '-0.194', '1.703', '-0.5', '-1.265', '-0.349', 'null', '-0.09', '0.301', '-0.531', '3.222', '-0.383', '1.045', 'null', '-0.044', '-0.066', '-0.094', '-0.103', '-0.134', '-0.15', '-0.159', '-0.161', '-0.208', '-0.182', '-0.216', '-0.189', '-0.222', '-0.207', '-0.198', '-0.21', '-0.192', '-0.175', '-0.164', '-0.158', '-0.14', '-0.115', '-0.106', '-0.074', '-0.058', '-0.035', '-0.011', '0.011', '0.035', '0.058', '0.074', '0.106', '0.115', '0.14', '0.158', '0.164', '0.175', '0.192', '0.21', '0.198', '0.207', '0.222', '0.189', '0.216', '0.182', '0.208', '0.161', '0.159', '0.15', '0.134', '0.103', '0.094', '0.066', '0.044', '0.024', '0', '-0.024', '0.396', '-0.055', '-0.082', '-0.109', '-0.13', '-0.159', '-0.179', '-0.193', '-0.204', '-0.243', '-0.224', '-0.251', '-0.247', '-0.261', '-0.247', '-0.244', '-0.251', '-0.227', '-0.221', '-0.198', '-0.189', '-0.173', '-0.139', '-0.122', '-0.094', '-0.071', '-0.04', '-0.014', '0.014', '0.04', '0.071', '0.094', '0.122', '0.139', '0.173', '0.189', '0.198', '0.221', '0.227', '0.251', '0.244', '0.247', '0.261', '0.247', '0.251', '0.224', '0.243', '0.204', '0.193', '0.179', '0.159', '0.13', '0.109', '0.082', '0.055', '0.028', '0', '-0.028', '-0.434', '-0.348', '-0.031', '-0.055', '-0.074', '-0.083', '-0.11', '-0.114', '-0.124', '-0.14', '-0.157', '-0.142', '-0.18', '-0.133', '-0.199', '-0.154', '-0.148', '-0.179', '-0.149', '-0.134', '-0.142', '-0.11', '-0.119', '-0.09', '-0.09', '-0.052', '-0.052', '-0.023', '-0.009', '0.009', '0.023', '0.052', '0.052', '0.09', '0.09', '0.119', '0.11', '0.142', '0.134', '0.149', '0.179', '0.148', '0.154', '0.199', '0.133', '0.18', '0.142', '0.157', '0.14', '0.124', '0.114', '0.11', '0.083', '0.074', '0.055', '0.031', '0.02', '0', '-0.02', '0.271', '-0.454', '-0.384', '-0.826', '-0.014', '1.265', '-0.065', '-1.7', '-0.375', '1.882', '-0.279', '-1.887', '-0.196', '1.711', '-0.493', '-1.285', '-0.35', '0', '-0.09', '0.213', '0.33', '0.452', '0.552', '0.553', '0.559', '0.427', '0.594', 'null', '-0.023', '-0.045', '-0.066', '-0.087', '-0.109', '-0.131', '-0.146', '-0.156', '-0.176', '-0.198', '-0.184', '-0.21', '-0.197', '-0.223', '-0.194', '-0.218', '-0.191', '-0.191', '-0.181', '-0.176', '-0.155', '-0.13', '-0.125', '-0.097', '-0.084', '-0.054', '-0.035', '-0.013', '0.01', '0.031', '0.059', '0.079', '0.095', '0.117', '0.148', '0.143', '0.172', '0.184', '0.188', '0.205', '0.198', '0.199', '0.216', '0.212', '0.197', '0.208', '0.179', '0.173', '0.171', '0.139', '0.13', '0.109', '0.095', '0.068', '0.041', '0.026', '0.003', '0.4', '-0.027', '-0.054', '-0.081', '-0.106', '-0.136', '-0.15', '-0.184', '-0.187', '-0.215', '-0.231', '-0.229', '-0.253', '-0.132', '-0.12', '-0.253', '-0.236', '-0.265', '-0.239', '-0.229', '-0.215', '-0.211', '-0.189', '-0.162', '-0.149', '-0.119', '-0.098', '-0.067', '-0.043', '-0.016', '0.012', '0.039', '0.07', '0.097', '0.117', '0.141', '0.176', '0.174', '0.207', '0.222', '0.234', '0.236', '0.249', '0.247', '0.263', '0.244', '0.244', '0.248', '0.219', '0.214', '0.199', '0.175', '0.155', '0.135', '0.109', '0.084', '0.054', '0.029', '0.003', '-0.439', '-0.351', '-0.019', '-0.035', '-0.054', '-0.065', '-0.085', '-0.119', '-0.102', '-0.12', '-0.14', '-0.18', '-0.122', '-0.18', '-0.153', '-0.189', '-0.12', '-0.21', '-0.138', '-0.149', '-0.145', '-0.141', '-0.118', '-0.105', '-0.101', '-0.078', '-0.065', '-0.044', '-0.025', '-0.011', '0.007', '0.023', '0.048', '0.058', '0.08', '0.096', '0.115', '0.109', '0.141', '0.138', '0.16', '0.167', '0.148', '0.154', '0.187', '0.158', '0.152', '0.174', '0.141', '0.133', '0.134', '0.114', '0.104', '0.084', '0.082', '0.051', '0.03', '0.022', '0.003', '0.277', '-0.18', '-0.277', '-0.707', '-0.152', '0.794', '0.074', '-1.509', '-0.431', '1.808', '-0.234', '-1.905', '-0.246', '1.828', '-0.419', '-1.557', '0.035', '0.928', '-0.105', 'null', '-0.026', '0.665', '0.039', '1.927', '-0.572', '0.265', 'null', '0.041', '0.026', '0.003', '-0.023', '-0.045', '-0.066', '-0.087', '-0.109', '-0.131', '-0.146', '-0.156', '-0.176', '-0.198', '-0.184', '-0.21', '-0.197', '-0.223', '-0.194', '-0.218', '-0.191', '-0.191', '-0.181', '-0.176', '-0.155', '-0.13', '-0.125', '-0.097', '-0.084', '-0.054', '-0.035', '-0.013', '0.01', '0.031', '0.059', '0.079', '0.095', '0.117', '0.148', '0.143', '0.172', '0.184', '0.188', '0.205', '0.198', '0.199', '0.216', '0.212', '0.197', '0.208', '0.179', '0.173', '0.171', '0.139', '0.13', '0.109', '0.095', '0.068', '0.384', '0.054', '0.029', '0.003', '-0.027', '-0.054', '-0.081', '-0.106', '-0.136', '-0.15', '-0.184', '-0.187', '-0.215', '-0.231', '-0.229', '-0.253', '-0.132', '-0.12', '-0.253', '-0.236', '-0.265', '-0.239', '-0.229', '-0.215', '-0.211', '-0.189', '-0.162', '-0.149', '-0.119', '-0.098', '-0.067', '-0.043', '-0.016', '0.012', '0.039', '0.07', '0.097', '0.117', '0.141', '0.176', '0.174', '0.207', '0.222', '0.234', '0.236', '0.249', '0.247', '0.263', '0.244', '0.244', '0.248', '0.219', '0.214', '0.199', '0.175', '0.155', '0.135', '0.109', '0.084', '-0.422', '-0.337', '0.03', '0.022', '0.003', '-0.019', '-0.035', '-0.054', '-0.065', '-0.085', '-0.119', '-0.102', '-0.12', '-0.14', '-0.18', '-0.122', '-0.18', '-0.153', '-0.189', '-0.12', '-0.21', '-0.138', '-0.149', '-0.145', '-0.141', '-0.118', '-0.105', '-0.101', '-0.078', '-0.065', '-0.044', '-0.025', '-0.011', '0.007', '0.023', '0.048', '0.058', '0.08', '0.096', '0.115', '0.109', '0.141', '0.138', '0.16', '0.167', '0.148', '0.154', '0.187', '0.158', '0.152', '0.174', '0.141', '0.133', '0.134', '0.114', '0.104', '0.084', '0.082', '0.051', '0.274', '-0.387', '-0.69', '-0.152', '0.753', '0.087', '-1.493', '-0.436', '1.802', '-0.232', '-1.904', '-0.249', '1.833', '-0.415', '-1.57', '0.026', '0.961', '-0.105', 'null', '0', '-0.026', '-0.759', '-0.327', '-0.157', '0.023', '0.212', '0.334', '1.317', '0.141', '1.839', '-0.577', '0.302', 'null', 'null', '-0.048', '-0.064', '-0.088', '-0.113', '-0.118', '-0.148', '-0.158', '-0.185', '-0.181', '-0.206', '-0.188', '-0.207', '-0.227', '-0.185', '-0.221', '-0.189', '-0.198', '-0.186', '-0.159', '-0.166', '-0.127', '-0.125', '-0.101', '-0.081', '-0.055', '-0.039', '-0.012', '0.01', '0.032', '0.052', '0.086', '0.09', '0.121', '0.132', '0.163', '0.161', '0.177', '0.197', '0.203', '0.188', '0.222', '0.212', '0.201', '0.197', '0.213', '0.174', '0.178', '0.171', '0.139', '0.129', '0.118', '0.082', '0.074', '0.046', '0.024', '0.003', '-0.02', '0.395', '-0.055', '-0.083', '-0.101', '-0.137', '-0.148', '-0.179', '-0.193', '-0.218', '-0.217', '-0.251', '-0.231', '-0.252', '-0.261', '-0.235', '-0.266', '-0.234', '-0.236', '-0.222', '-0.199', '-0.195', '-0.161', '-0.149', '-0.122', '-0.097', '-0.068', '-0.045', '-0.016', '0.012', '0.039', '0.065', '0.101', '0.112', '0.146', '0.163', '0.188', '0.202', '0.22', '0.232', '0.239', '0.242', '0.145', '0.12', '0.252', '0.242', '0.248', '0.243', '0.221', '0.215', '0.199', '0.176', '0.156', '0.139', '0.104', '0.086', '0.056', '0.03', '0.003', '-0.025', '-0.434', '-0.346', '-0.039', '-0.054', '-0.062', '-0.096', '-0.09', '-0.122', '-0.12', '-0.156', '-0.135', '-0.174', '-0.146', '-0.154', '-0.186', '-0.159', '-0.165', '-0.155', '-0.149', '-0.15', '-0.127', '-0.137', '-0.095', '-0.095', '-0.086', '-0.064', '-0.042', '-0.032', '-0.009', '0.007', '0.029', '0.035', '0.069', '0.076', '0.094', '0.104', '0.131', '0.127', '0.137', '0.165', '0.161', '0.14', '0.177', '0.176', '0.156', '0.143', '0.191', '0.124', '0.148', '0.146', '0.092', '0.107', '0.1', '0.062', '0.06', '0.034', '0.02', '0.003', '-0.015', '0.278', '-0.342', '-0.393', '-0.294', '-0.645', '-0.016', '1.266', '-0.068', '-1.701', '-0.373', '1.882', '-0.282', '-1.884', '-0.195', '1.708', '-0.493', '-1.284', '-0.35', 'null', '-0.089', '0.3', '-0.513', '3.198', '-0.373', '1.041', 'null', '0.024', '0.003', '-0.02', '-0.048', '-0.064', '-0.088', '-0.113', '-0.118', '-0.148', '-0.158', '-0.185', '-0.181', '-0.206', '-0.188', '-0.207', '-0.227', '-0.185', '-0.221', '-0.189', '-0.198', '-0.186', '-0.159', '-0.166', '-0.127', '-0.125', '-0.101', '-0.081', '-0.055', '-0.039', '-0.012', '0.01', '0.032', '0.052', '0.086', '0.09', '0.121', '0.132', '0.163', '0.161', '0.177', '0.197', '0.203', '0.188', '0.222', '0.212', '0.201', '0.197', '0.213', '0.174', '0.178', '0.171', '0.139', '0.129', '0.118', '0.082', '0.074', '0.046', '0.394', '0.03', '0.003', '-0.025', '-0.055', '-0.083', '-0.101', '-0.137', '-0.148', '-0.179', '-0.193', '-0.218', '-0.217', '-0.251', '-0.231', '-0.252', '-0.261', '-0.235', '-0.266', '-0.234', '-0.236', '-0.222', '-0.199', '-0.195', '-0.161', '-0.149', '-0.122', '-0.097', '-0.068', '-0.045', '-0.016', '0.012', '0.039', '0.065', '0.101', '0.112', '0.146', '0.163', '0.188', '0.202', '0.22', '0.232', '0.239', '0.242', '0.145', '0.12', '0.252', '0.242', '0.248', '0.243', '0.221', '0.215', '0.199', '0.176', '0.156', '0.139', '0.104', '0.086', '0.056', '-0.433', '-0.347', '0.02', '0.003', '-0.015', '-0.039', '-0.054', '-0.062', '-0.096', '-0.09', '-0.122', '-0.12', '-0.156', '-0.135', '-0.174', '-0.146', '-0.154', '-0.186', '-0.159', '-0.165', '-0.155', '-0.149', '-0.15', '-0.127', '-0.137', '-0.095', '-0.095', '-0.086', '-0.064', '-0.042', '-0.032', '-0.009', '0.007', '0.029', '0.035', '0.069', '0.076', '0.094', '0.104', '0.131', '0.127', '0.137', '0.165', '0.161', '0.14', '0.177', '0.176', '0.156', '0.143', '0.191', '0.124', '0.148', '0.146', '0.092', '0.107', '0.1', '0.062', '0.06', '0.034', '0.272', '-0.091', '-0.237', '-0.393', '-0.294', '-0.663', '-0.016', '1.283', '-0.072', '-1.711', '-0.369', '1.885', '-0.284', '-1.881', '-0.193', '1.699', '-0.498', '-1.264', '-0.35', 'null', '0', '-0.089', '0.444', '-0.41', '2.998', '-0.39', '0.187', '0.85', 'null', 'null', '-0.022', '-0.041', '-0.068', '-0.087', '-0.115', '-0.059', '-0.064', '-0.137', '-0.162', '-0.188', '-0.186', '-0.174', '-0.225', '-0.093', '-0.104', '-0.202', '-0.217', '-0.202', '-0.191', '-0.205', '-0.187', '-0.151', '-0.173', '-0.127', '-0.122', '-0.104', '-0.084', '-0.055', '-0.021', '-0.026', '-0.004', '0.009', '0.034', '0.053', '0.078', '0.098', '0.114', '0.14', '0.146', '0.168', '0.186', '0.187', '0.209', '0.105', '0.094', '0.203', '0.218', '0.203', '0.196', '0.208', '0.175', '0.183', '0.166', '0.147', '0.124', '0.11', '0.099', '0.067', '0.045', '0.021', '0.006', '0.004', '0.401', '-0.026', '-0.052', '-0.083', '-0.103', '-0.137', '-0.08', '-0.072', '-0.172', '-0.19', '-0.223', '-0.221', '-0.139', '-0.096', '-0.136', '-0.111', '-0.135', '-0.113', '-0.239', '-0.266', '-0.252', '-0.232', '-0.238', '-0.229', '-0.191', '-0.198', '-0.166', '-0.142', '-0.125', '-0.098', '-0.043', '-0.028', '-0.028', '-0.028', '-0.006', '0.011', '0.041', '0.064', '0.096', '0.119', '0.137', '0.167', '0.185', '0.194', '0.229', '0.129', '0.104', '0.239', '0.139', '0.102', '0.15', '0.113', '0.253', '0.247', '0.239', '0.247', '0.219', '0.219', '0.199', '0.177', '0.153', '0.134', '0.117', '0.082', '0.039', '0.018', '0.023', '0.008', '0.005', '-0.439', '-0.352', '-0.018', '-0.033', '-0.051', '-0.073', '-0.09', '-0.09', '-0.115', '-0.127', '-0.157', '-0.149', '-0.131', '-0.189', '-0.145', '-0.16', '-0.18', '-0.162', '-0.143', '-0.163', '-0.154', '-0.111', '-0.146', '-0.098', '-0.098', '-0.081', '-0.068', '-0.058', '-0.026', '0.008', '0.027', '0.039', '0.067', '0.079', '0.083', '0.12', '0.1', '0.151', '0.144', '0.143', '0.174', '0.135', '0.179', '0.168', '0.173', '0.147', '0.167', '0.147', '0.139', '0.125', '0.124', '0.096', '0.088', '0.082', '0.05', '0.035', '0.022', '0.004', '0.277', '-0.187', '-0.303', '-0.677', '-0.148', '0.793', '0.073', '-1.505', '-0.435', '1.807', '-0.234', '-1.903', '-0.246', '1.827', '-0.417', '-1.558', '0.036', '0.926', '-0.101', 'null', '-0.027', '0.682', '0.069', '1.864', '-0.563', '0.34', 'null', '-0.022', '-0.041', '-0.068', '-0.087', '-0.115', '-0.059', '-0.064', '-0.137', '-0.162', '-0.188', '-0.186', '-0.174', '-0.225', '-0.093', '-0.104', '-0.202', '-0.217', '-0.202', '-0.191', '-0.205', '-0.187', '-0.151', '-0.173', '-0.127', '-0.122', '-0.104', '-0.084', '-0.055', '-0.021', '-0.026', '-0.004', '0.009', '0.034', '0.053', '0.078', '0.098', '0.114', '0.14', '0.146', '0.168', '0.186', '0.187', '0.209', '0.105', '0.094', '0.203', '0.218', '0.203', '0.196', '0.208', '0.175', '0.183', '0.166', '0.147', '0.124', '0.11', '0.099', '0.067', '0.045', '0.021', '0.006', '0.004', '0.401', '-0.026', '-0.052', '-0.083', '-0.103', '-0.137', '-0.08', '-0.072', '-0.172', '-0.19', '-0.223', '-0.221', '-0.139', '-0.096', '-0.136', '-0.111', '-0.135', '-0.113', '-0.239', '-0.266', '-0.252', '-0.232', '-0.238', '-0.229', '-0.191', '-0.198', '-0.166', '-0.142', '-0.125', '-0.098', '-0.043', '-0.028', '-0.028', '-0.028', '-0.006', '0.011', '0.041', '0.064', '0.096', '0.119', '0.137', '0.167', '0.185', '0.194', '0.229', '0.129', '0.104', '0.239', '0.139', '0.102', '0.15', '0.113', '0.253', '0.247', '0.239', '0.247', '0.219', '0.219', '0.199', '0.177', '0.153', '0.134', '0.117', '0.082', '0.039', '0.018', '0.023', '0.008', '0.005', '-0.439', '-0.352', '-0.018', '-0.033', '-0.051', '-0.073', '-0.09', '-0.09', '-0.115', '-0.127', '-0.157', '-0.149', '-0.131', '-0.189', '-0.145', '-0.16', '-0.18', '-0.162', '-0.143', '-0.163', '-0.154', '-0.111', '-0.146', '-0.098', '-0.098', '-0.081', '-0.068', '-0.058', '-0.026', '0.008', '0.027', '0.039', '0.067', '0.079', '0.083', '0.12', '0.1', '0.151', '0.144', '0.143', '0.174', '0.135', '0.179', '0.168', '0.173', '0.147', '0.167', '0.147', '0.139', '0.125', '0.124', '0.096', '0.088', '0.082', '0.05', '0.035', '0.022', '0.004', '0.277', '-0.187', '-0.272', '-0.68', '-0.148', '0.755', '0.085', '-1.491', '-0.438', '1.8', '-0.231', '-1.904', '-0.248', '1.833', '-0.412', '-1.573', '0.026', '0.96', '-0.101', 'null', '0', '-0.026', '-0.77', '-0.318', '-0.168', '0.085', '0.264', '0.334', '1.202', '0.015', '2.225', '-0.754', '0.22', 'null', 'null', '-0.047', '-0.07', '-0.091', '-0.112', '-0.133', '-0.141', '-0.173', '-0.165', '-0.199', '-0.191', '-0.213', '-0.194', '-0.217', '-0.201', '-0.156', '-0.263', '-0.174', '-0.185', '-0.172', '-0.147', '-0.136', '-0.118', '-0.098', '-0.072', '-0.056', '-0.033', '-0.009', '0.008', '0.033', '0.07', '0.081', '0.1', '0.124', '0.139', '0.16', '0.167', '0.185', '0.189', '0.193', '0.218', '0.193', '0.218', '0.212', '0.201', '0.202', '0.166', '0.182', '0.16', '0.148', '0.124', '0.106', '0.086', '0.067', '0.043', '0.021', '0.001', '-0.031', '0.396', '-0.059', '-0.085', '-0.11', '-0.137', '-0.161', '-0.172', '-0.2', '-0.212', '-0.234', '-0.231', '-0.26', '-0.237', '-0.258', '-0.244', '-0.196', '-0.312', '-0.213', '-0.227', '-0.202', '-0.178', '-0.166', '-0.144', '-0.117', '-0.092', '-0.064', '-0.041', '-0.011', '0.01', '0.041', '0.083', '0.098', '0.124', '0.146', '0.171', '0.191', '0.206', '0.217', '0.236', '0.237', '0.258', '0.243', '0.256', '0.256', '0.241', '0.239', '0.216', '0.217', '0.192', '0.175', '0.154', '0.127', '0.106', '0.08', '0.052', '0.025', '0.001', '-0.035', '-0.433', '-0.348', '-0.039', '-0.052', '-0.075', '-0.084', '-0.115', '-0.099', '-0.146', '-0.122', '-0.176', '-0.133', '-0.176', '-0.162', '-0.171', '-0.163', '-0.101', '-0.221', '-0.144', '-0.137', '-0.15', '-0.109', '-0.109', '-0.096', '-0.076', '-0.058', '-0.043', '-0.025', '-0.009', '0.006', '0.028', '0.056', '0.06', '0.082', '0.103', '0.103', '0.129', '0.132', '0.157', '0.132', '0.168', '0.174', '0.142', '0.179', '0.175', '0.146', '0.167', '0.134', '0.14', '0.134', '0.114', '0.098', '0.083', '0.071', '0.052', '0.034', '0.017', '0.001', '-0.026', '0.277', '-0.352', '-0.411', '-0.141', '-0.767', '-0.009', '1.263', '-0.065', '-1.697', '-0.375', '1.88', '-0.28', '-1.885', '-0.195', '1.709', '-0.495', '-1.285', '-0.35', 'null', '-0.089', '0.442', '-0.422', '3.018', '-0.392', '0.972', 'null', '0.043', '0.021', '0.001', '-0.031', '-0.047', '-0.07', '-0.091', '-0.112', '-0.133', '-0.141', '-0.173', '-0.165', '-0.199', '-0.191', '-0.213', '-0.194', '-0.217', '-0.201', '-0.156', '-0.263', '-0.174', '-0.185', '-0.172', '-0.147', '-0.136', '-0.118', '-0.098', '-0.072', '-0.056', '-0.033', '-0.009', '0.008', '0.033', '0.07', '0.081', '0.1', '0.124', '0.139', '0.16', '0.167', '0.185', '0.189', '0.193', '0.218', '0.193', '0.218', '0.212', '0.201', '0.202', '0.166', '0.182', '0.16', '0.148', '0.124', '0.106', '0.086', '0.067', '0.387', '0.052', '0.025', '0.001', '-0.035', '-0.059', '-0.085', '-0.11', '-0.137', '-0.161', '-0.172', '-0.2', '-0.212', '-0.234', '-0.231', '-0.26', '-0.237', '-0.258', '-0.244', '-0.196', '-0.312', '-0.213', '-0.227', '-0.202', '-0.178', '-0.166', '-0.144', '-0.117', '-0.092', '-0.064', '-0.041', '-0.011', '0.01', '0.041', '0.083', '0.098', '0.124', '0.146', '0.171', '0.191', '0.206', '0.217', '0.236', '0.237', '0.258', '0.243', '0.256', '0.256', '0.241', '0.239', '0.216', '0.217', '0.192', '0.175', '0.154', '0.127', '0.106', '0.08', '-0.424', '-0.34', '0.034', '0.017', '0.001', '-0.026', '-0.039', '-0.052', '-0.075', '-0.084', '-0.115', '-0.099', '-0.146', '-0.122', '-0.176', '-0.133', '-0.176', '-0.162', '-0.171', '-0.163', '-0.101', '-0.221', '-0.144', '-0.137', '-0.15', '-0.109', '-0.109', '-0.096', '-0.076', '-0.058', '-0.043', '-0.025', '-0.009', '0.006', '0.028', '0.056', '0.06', '0.082', '0.103', '0.103', '0.129', '0.132', '0.157', '0.132', '0.168', '0.174', '0.142', '0.179', '0.175', '0.146', '0.167', '0.134', '0.14', '0.134', '0.114', '0.098', '0.083', '0.071', '0.052', '0.266', '-0.024', '-0.188', '-0.343', '-0.405', '-0.693', '-0.009', '1.283', '-0.071', '-1.705', '-0.372', '1.882', '-0.283', '-1.881', '-0.194', '1.702', '-0.502', '-1.265', '-0.349', '0', '-0.089', '0.324', '0.386', '0.489', '0.544', '0.579', '0.498', '0.224', '0.618', 'null', '0.019', '0.001', '-0.011', '-0.019', '-0.054', '-0.041', '-0.084', '-0.114', '-0.123', '-0.094', '-0.152', '-0.096', '-0.192', '-0.183', '-0.195', '-0.2', '-0.216', '-0.209', '-0.206', '-0.141', '-0.208', '-0.189', '-0.185', '-0.172', '-0.099', '-0.097', '-0.131', '-0.126', '-0.088', '-0.079', '-0.053', '-0.032', '-0.009', '0.009', '0.031', '0.053', '0.077', '0.092', '0.124', '0.131', '0.098', '0.098', '0.172', '0.185', '0.189', '0.207', '0.191', '0.218', '0.219', '0.141', '0.204', '0.195', '0.183', '0.182', '0.107', '0.107', '0.135', '0.126', '0.111', '0.085', '0.062', '0.046', '0.395', '0.024', '0.001', '-0.013', '-0.023', '-0.063', '-0.054', '-0.103', '-0.131', '-0.152', '-0.116', '-0.176', '-0.137', '-0.213', '-0.229', '-0.23', '-0.252', '-0.256', '-0.25', '-0.245', '-0.183', '-0.254', '-0.218', '-0.226', '-0.208', '-0.124', '-0.114', '-0.163', '-0.146', '-0.113', '-0.093', '-0.063', '-0.039', '-0.011', '0.01', '0.039', '0.063', '0.093', '0.111', '0.148', '0.163', '0.115', '0.123', '0.208', '0.226', '0.218', '0.257', '0.236', '0.265', '0.256', '0.166', '0.26', '0.23', '0.229', '0.21', '0.135', '0.127', '0.166', '0.156', '0.131', '0.102', '0.077', '0.053', '-0.435', '-0.346', '0.015', '0.001', '-0.007', '-0.017', '-0.046', '-0.032', '-0.056', '-0.103', '-0.1', '-0.062', '-0.136', '-0.053', '-0.18', '-0.123', '-0.163', '-0.153', '-0.188', '-0.159', '-0.151', '-0.121', '-0.168', '-0.148', '-0.146', '-0.142', '-0.068', '-0.081', '-0.112', '-0.093', '-0.073', '-0.061', '-0.042', '-0.025', '-0.008', '0.006', '0.028', '0.041', '0.057', '0.073', '0.103', '0.106', '0.081', '0.067', '0.142', '0.14', '0.149', '0.178', '0.122', '0.202', '0.185', '0.08', '0.178', '0.156', '0.143', '0.143', '0.086', '0.093', '0.093', '0.108', '0.089', '0.066', '0.047', '0.039', '0.279', '-0.338', '-0.249', '-0.538', '-0.149', '0.756', '0.084', '-1.489', '-0.441', '1.804', '-0.233', '-1.906', '-0.248', '1.834', '-0.416', '-1.568', '0.022', '0.96', '-0.097', 'null', '-0.026', '-0.701', '-0.403', '-0.158', '0.083', '0.266', '0.369', '1.229', '0.047', '1.998', '-0.679', '0.284', 'null', '-0.054', '-0.041', '-0.084', '-0.114', '-0.123', '-0.094', '-0.152', '-0.096', '-0.192', '-0.183', '-0.195', '-0.2', '-0.216', '-0.209', '-0.206', '-0.141', '-0.208', '-0.189', '-0.185', '-0.172', '-0.099', '-0.097', '-0.131', '-0.126', '-0.088', '-0.079', '-0.053', '-0.032', '-0.009', '0.009', '0.031', '0.053', '0.077', '0.092', '0.124', '0.131', '0.098', '0.098', '0.172', '0.185', '0.189', '0.207', '0.191', '0.218', '0.219', '0.141', '0.204', '0.195', '0.183', '0.182', '0.107', '0.107', '0.135', '0.126', '0.111', '0.085', '0.062', '0.046', '0.019', '0.001', '-0.011', '-0.019', '0.394', '-0.063', '-0.054', '-0.103', '-0.131', '-0.152', '-0.116', '-0.176', '-0.137', '-0.213', '-0.229', '-0.23', '-0.252', '-0.256', '-0.25', '-0.245', '-0.183', '-0.254', '-0.218', '-0.226', '-0.208', '-0.124', '-0.114', '-0.163', '-0.146', '-0.113', '-0.093', '-0.063', '-0.039', '-0.011', '0.01', '0.039', '0.063', '0.093', '0.111', '0.148', '0.163', '0.115', '0.123', '0.208', '0.226', '0.218', '0.257', '0.236', '0.265', '0.256', '0.166', '0.26', '0.23', '0.229', '0.21', '0.135', '0.127', '0.166', '0.156', '0.131', '0.102', '0.077', '0.053', '0.024', '0.001', '-0.013', '-0.023', '-0.432', '-0.346', '-0.046', '-0.032', '-0.056', '-0.103', '-0.1', '-0.062', '-0.136', '-0.053', '-0.18', '-0.123', '-0.163', '-0.153', '-0.188', '-0.159', '-0.151', '-0.121', '-0.168', '-0.148', '-0.146', '-0.142', '-0.068', '-0.081', '-0.112', '-0.093', '-0.073', '-0.061', '-0.042', '-0.025', '-0.008', '0.006', '0.028', '0.041', '0.057', '0.073', '0.103', '0.106', '0.081', '0.067', '0.142', '0.14', '0.149', '0.178', '0.122', '0.202', '0.185', '0.08', '0.178', '0.156', '0.143', '0.143', '0.086', '0.093', '0.093', '0.108', '0.089', '0.066', '0.047', '0.039', '0.015', '0.001', '-0.007', '-0.017', '0.272', '-0.09', '-0.233', '-0.249', '-0.566', '-0.149', '0.794', '0.073', '-1.506', '-0.434', '1.809', '-0.235', '-1.906', '-0.246', '1.829', '-0.421', '-1.554', '0.033', '0.926', '-0.097', '0', '-0.026', '0.801', '0.526', '0.394', '0.651', 'null', '-0.043', '-0.067', '-0.081', '-0.107', '-0.134', '-0.085', '-0.154', '-0.168', '-0.13', '-0.178', '-0.192', '-0.219', '-0.205', '-0.124', '-0.224', '-0.197', '-0.202', '-0.193', '-0.187', '-0.167', '-0.108', '-0.145', '-0.086', '-0.12', '-0.099', '-0.07', '-0.054', '-0.032', '-0.008', '0.008', '0.031', '0.054', '0.07', '0.1', '0.119', '0.135', '0.091', '0.113', '0.167', '0.184', '0.194', '0.204', '0.196', '0.23', '0.119', '0.205', '0.219', '0.191', '0.177', '0.197', '0.096', '0.163', '0.083', '0.134', '0.107', '0.081', '0.067', '0.043', '0.018', '0.001', '-0.018', '0.396', '-0.051', '-0.081', '-0.099', '-0.131', '-0.155', '-0.11', '-0.187', '-0.201', '-0.156', '-0.221', '-0.233', '-0.254', '-0.255', '-0.151', '-0.267', '-0.242', '-0.249', '-0.231', '-0.226', '-0.197', '-0.134', '-0.177', '-0.107', '-0.143', '-0.115', '-0.091', '-0.064', '-0.037', '-0.011', '0.01', '0.037', '0.064', '0.091', '0.115', '0.144', '0.167', '0.109', '0.141', '0.197', '0.226', '0.225', '0.255', '0.242', '0.268', '0.15', '0.255', '0.254', '0.233', '0.222', '0.224', '0.133', '0.187', '0.109', '0.155', '0.131', '0.099', '0.081', '0.051', '0.022', '0.001', '-0.022', '-0.435', '-0.347', '-0.036', '-0.052', '-0.062', '-0.089', '-0.112', '-0.054', '-0.137', '-0.12', '-0.11', '-0.14', '-0.153', '-0.17', '-0.187', '-0.068', '-0.21', '-0.125', '-0.166', '-0.172', '-0.133', '-0.136', '-0.084', '-0.114', '-0.065', '-0.097', '-0.083', '-0.052', '-0.043', '-0.025', '-0.007', '0.007', '0.024', '0.043', '0.05', '0.093', '0.081', '0.127', '0.05', '0.093', '0.134', '0.147', '0.152', '0.174', '0.128', '0.217', '0.059', '0.188', '0.174', '0.139', '0.151', '0.162', '0.062', '0.143', '0.052', '0.11', '0.091', '0.062', '0.052', '0.036', '0.014', '0.001', '-0.014', '-0.15', '-1.266', '-0.5', '1.698', '-0.191', '-1.882', '-0.283', '1.886', '-0.372', '-1.709', '-0.069', '1.282', '-0.026', 'null', '-0.006', '0.757', '0.578', '0.369', '0.117', '-0.116', '-0.333', '-1.16', '0.032', '2.113', '-0.672', '0.288', 'null', '0.018', '0.001', '-0.018', '-0.043', '-0.067', '-0.081', '-0.107', '-0.134', '-0.085', '-0.154', '-0.168', '-0.13', '-0.178', '-0.192', '-0.219', '-0.205', '-0.124', '-0.224', '-0.197', '-0.202', '-0.193', '-0.187', '-0.167', '-0.108', '-0.145', '-0.086', '-0.12', '-0.099', '-0.07', '-0.054', '-0.032', '-0.008', '0.008', '0.031', '0.054', '0.07', '0.1', '0.119', '0.135', '0.091', '0.113', '0.167', '0.184', '0.194', '0.204', '0.196', '0.23', '0.119', '0.205', '0.219', '0.191', '0.177', '0.197', '0.096', '0.163', '0.083', '0.134', '0.107', '0.081', '0.067', '0.043', '0.396', '0.022', '0.001', '-0.022', '-0.051', '-0.081', '-0.099', '-0.131', '-0.155', '-0.11', '-0.187', '-0.201', '-0.156', '-0.221', '-0.233', '-0.254', '-0.255', '-0.151', '-0.267', '-0.242', '-0.249', '-0.231', '-0.226', '-0.197', '-0.134', '-0.177', '-0.107', '-0.143', '-0.115', '-0.091', '-0.064', '-0.037', '-0.011', '0.01', '0.037', '0.064', '0.091', '0.115', '0.144', '0.167', '0.109', '0.141', '0.197', '0.226', '0.225', '0.255', '0.242', '0.268', '0.15', '0.255', '0.254', '0.233', '0.222', '0.224', '0.133', '0.187', '0.109', '0.155', '0.131', '0.099', '0.081', '0.051', '-0.435', '-0.347', '0.014', '0.001', '-0.014', '-0.036', '-0.052', '-0.062', '-0.089', '-0.112', '-0.054', '-0.137', '-0.12', '-0.11', '-0.14', '-0.153', '-0.17', '-0.187', '-0.068', '-0.21', '-0.125', '-0.166', '-0.172', '-0.133', '-0.136', '-0.084', '-0.114', '-0.065', '-0.097', '-0.083', '-0.052', '-0.043', '-0.025', '-0.007', '0.007', '0.024', '0.043', '0.05', '0.093', '0.081', '0.127', '0.05', '0.093', '0.134', '0.147', '0.152', '0.174', '0.128', '0.217', '0.059', '0.188', '0.174', '0.139', '0.151', '0.162', '0.062', '0.143', '0.052', '0.11', '0.091', '0.062', '0.052', '0.036', '-0.147', '-1.288', '-0.494', '1.708', '-0.195', '-1.884', '-0.281', '1.884', '-0.376', '-1.7', '-0.064', '1.263', '-0.026', 'null', '0', '-0.006', '0.236', '0.022', '2.118', '-0.671', '0.289', 'null', 'null', '-0.044', '-0.061', '-0.086', '-0.106', '-0.128', '-0.141', '-0.097', '-0.185', '-0.17', '-0.192', '-0.217', '-0.127', '-0.212', '-0.122', '-0.218', '-0.197', '-0.2', '-0.198', '-0.186', '-0.17', '-0.096', '-0.202', '-0.123', '-0.071', '-0.093', '-0.066', '-0.044', '-0.024', '0.005', '0.028', '0.054', '0.072', '0.095', '0.117', '0.135', '0.144', '0.177', '0.169', '0.197', '0.189', '0.147', '0.208', '0.271', '0.206', '0.203', '0.208', '0.174', '0.199', '0.098', '0.159', '0.136', '0.127', '0.063', '0.093', '0.036', '0.034', '0.031', '0.018', '0.001', '-0.018', '0.396', '-0.051', '-0.077', '-0.105', '-0.123', '-0.158', '-0.167', '-0.134', '-0.203', '-0.221', '-0.227', '-0.248', '-0.17', '-0.258', '-0.142', '-0.263', '-0.242', '-0.246', '-0.237', '-0.213', '-0.217', '-0.128', '-0.228', '-0.153', '-0.087', '-0.109', '-0.082', '-0.055', '-0.028', '0.005', '0.035', '0.065', '0.089', '0.115', '0.139', '0.164', '0.18', '0.204', '0.213', '0.237', '0.227', '0.189', '0.241', '0.32', '0.263', '0.245', '0.246', '0.213', '0.23', '0.137', '0.184', '0.169', '0.145', '0.083', '0.108', '0.048', '0.042', '0.036', '0.021', '0.001', '-0.022', '-0.435', '-0.347', '-0.036', '-0.047', '-0.073', '-0.088', '-0.088', '-0.118', '-0.077', '-0.148', '-0.134', '-0.149', '-0.176', '-0.097', '-0.193', '-0.067', '-0.204', '-0.122', '-0.167', '-0.177', '-0.124', '-0.152', '-0.061', '-0.169', '-0.1', '-0.05', '-0.077', '-0.054', '-0.032', '-0.02', '0.005', '0.021', '0.042', '0.056', '0.077', '0.093', '0.11', '0.112', '0.144', '0.125', '0.174', '0.136', '0.129', '0.147', '0.221', '0.175', '0.144', '0.171', '0.14', '0.165', '0.07', '0.129', '0.109', '0.097', '0.056', '0.069', '0.028', '0.031', '0.023', '0.014', '0.001', '-0.014', '-0.228', '-0.797', '-0.64', '1.507', '-0.133', '-1.807', '-0.332', '1.904', '-0.321', '-1.829', '-0.146', '1.555', '-0.598', '-0.929', '-0.339', 'null', '-0.089', '0.327', '-0.551', '3.11', '-0.355', '1.076', 'null', '0.018', '0.001', '-0.018', '-0.044', '-0.061', '-0.086', '-0.106', '-0.128', '-0.141', '-0.097', '-0.185', '-0.17', '-0.192', '-0.217', '-0.127', '-0.212', '-0.122', '-0.218', '-0.197', '-0.2', '-0.198', '-0.186', '-0.17', '-0.096', '-0.202', '-0.123', '-0.071', '-0.093', '-0.066', '-0.044', '-0.024', '0.005', '0.028', '0.054', '0.072', '0.095', '0.117', '0.135', '0.144', '0.177', '0.169', '0.197', '0.189', '0.147', '0.208', '0.271', '0.206', '0.203', '0.208', '0.174', '0.199', '0.098', '0.159', '0.136', '0.127', '0.063', '0.093', '0.036', '0.034', '0.031', '0.397', '0.021', '0.001', '-0.022', '-0.051', '-0.077', '-0.105', '-0.123', '-0.158', '-0.167', '-0.134', '-0.203', '-0.221', '-0.227', '-0.248', '-0.17', '-0.258', '-0.142', '-0.263', '-0.242', '-0.246', '-0.237', '-0.213', '-0.217', '-0.128', '-0.228', '-0.153', '-0.087', '-0.109', '-0.082', '-0.055', '-0.028', '0.005', '0.035', '0.065', '0.089', '0.115', '0.139', '0.164', '0.18', '0.204', '0.213', '0.237', '0.227', '0.189', '0.241', '0.32', '0.263', '0.245', '0.246', '0.213', '0.23', '0.137', '0.184', '0.169', '0.145', '0.083', '0.108', '0.048', '0.042', '0.036', '-0.435', '-0.348', '0.014', '0.001', '-0.014', '-0.036', '-0.047', '-0.073', '-0.088', '-0.088', '-0.118', '-0.077', '-0.148', '-0.134', '-0.149', '-0.176', '-0.097', '-0.193', '-0.067', '-0.204', '-0.122', '-0.167', '-0.177', '-0.124', '-0.152', '-0.061', '-0.169', '-0.1', '-0.05', '-0.077', '-0.054', '-0.032', '-0.02', '0.005', '0.021', '0.042', '0.056', '0.077', '0.093', '0.11', '0.112', '0.144', '0.125', '0.174', '0.136', '0.129', '0.147', '0.221', '0.175', '0.144', '0.171', '0.14', '0.165', '0.07', '0.129', '0.109', '0.097', '0.056', '0.069', '0.028', '0.031', '0.023', '-0.244', '-0.752', '-0.653', '1.494', '-0.13', '-1.8', '-0.335', '1.903', '-0.319', '-1.833', '-0.151', '1.57', '-0.589', '-0.96', '-0.338', 'null', '0', '-0.09', '0.086', '0.211', '0.87', '-0.251', '3.015', '-0.604', '0.304', 'null', 'null', '-0.018', '-0.039', '-0.064', '-0.085', '-0.105', '-0.128', '-0.134', '-0.162', '-0.179', '-0.119', '-0.194', '-0.21', '-0.2', '-0.261', '-0.213', '-0.204', '-0.207', '-0.186', '-0.182', '-0.173', '-0.172', '-0.124', '-0.135', '-0.102', '-0.082', '-0.046', '-0.045', '-0.024', '0.004', '0.028', '0.05', '0.077', '0.094', '0.116', '0.129', '0.15', '0.169', '0.181', '0.18', '0.218', '0.13', '0.203', '0.282', '0.197', '0.21', '0.19', '0.199', '0.164', '0.174', '0.154', '0.125', '0.087', '0.102', '0.076', '0.058', '0.033', '0.013', '0.401', '-0.021', '-0.049', '-0.078', '-0.103', '-0.124', '-0.156', '-0.165', '-0.194', '-0.215', '-0.154', '-0.229', '-0.251', '-0.244', '-0.31', '-0.268', '-0.245', '-0.241', '-0.233', '-0.228', '-0.204', '-0.201', '-0.158', '-0.157', '-0.125', '-0.101', '-0.057', '-0.055', '-0.028', '0.004', '0.035', '0.062', '0.089', '0.117', '0.14', '0.156', '0.185', '0.202', '0.219', '0.222', '0.247', '0.173', '0.252', '0.323', '0.254', '0.245', '0.235', '0.238', '0.207', '0.203', '0.184', '0.153', '0.109', '0.12', '0.094', '0.071', '0.04', '0.015', '-0.439', '-0.352', '-0.014', '-0.03', '-0.051', '-0.072', '-0.078', '-0.108', '-0.102', '-0.132', '-0.14', '-0.088', '-0.159', '-0.168', '-0.149', '-0.223', '-0.186', '-0.133', '-0.17', '-0.144', '-0.157', '-0.125', '-0.142', '-0.097', '-0.112', '-0.079', '-0.06', '-0.04', '-0.034', '-0.02', '0.004', '0.02', '0.041', '0.06', '0.078', '0.09', '0.104', '0.11', '0.146', '0.137', '0.147', '0.174', '0.11', '0.141', '0.236', '0.161', '0.155', '0.159', '0.154', '0.13', '0.146', '0.117', '0.101', '0.067', '0.08', '0.06', '0.049', '0.024', '0.012', '0.277', '-0.341', '-0.381', '-0.364', '-0.588', '-0.028', '1.262', '-0.067', '-1.702', '-0.371', '1.882', '-0.283', '-1.881', '-0.198', '1.71', '-0.498', '-1.279', '-0.351', 'null', '-0.089', '0.324', '-0.491', '3.086', '-0.355', '0.634', '0.482', 'null', '-0.018', '-0.039', '-0.064', '-0.085', '-0.105', '-0.128', '-0.134', '-0.162', '-0.179', '-0.119', '-0.194', '-0.21', '-0.2', '-0.261', '-0.213', '-0.204', '-0.207', '-0.186', '-0.182', '-0.173', '-0.172', '-0.124', '-0.135', '-0.102', '-0.082', '-0.046', '-0.045', '-0.024', '0.004', '0.028', '0.05', '0.077', '0.094', '0.116', '0.129', '0.15', '0.169', '0.181', '0.18', '0.218', '0.13', '0.203', '0.282', '0.197', '0.21', '0.19', '0.199', '0.164', '0.174', '0.154', '0.125', '0.087', '0.102', '0.076', '0.058', '0.033', '0.013', '0.401', '-0.021', '-0.049', '-0.078', '-0.103', '-0.124', '-0.156', '-0.165', '-0.194', '-0.215', '-0.154', '-0.229', '-0.251', '-0.244', '-0.31', '-0.268', '-0.245', '-0.241', '-0.233', '-0.228', '-0.204', '-0.201', '-0.158', '-0.157', '-0.125', '-0.101', '-0.057', '-0.055', '-0.028', '0.004', '0.035', '0.062', '0.089', '0.117', '0.14', '0.156', '0.185', '0.202', '0.219', '0.222', '0.247', '0.173', '0.252', '0.323', '0.254', '0.245', '0.235', '0.238', '0.207', '0.203', '0.184', '0.153', '0.109', '0.12', '0.094', '0.071', '0.04', '0.015', '-0.439', '-0.352', '-0.014', '-0.03', '-0.051', '-0.072', '-0.078', '-0.108', '-0.102', '-0.132', '-0.14', '-0.088', '-0.159', '-0.168', '-0.149', '-0.223', '-0.186', '-0.133', '-0.17', '-0.144', '-0.157', '-0.125', '-0.142', '-0.097', '-0.112', '-0.079', '-0.06', '-0.04', '-0.034', '-0.02', '0.004', '0.02', '0.041', '0.06', '0.078', '0.09', '0.104', '0.11', '0.146', '0.137', '0.147', '0.174', '0.11', '0.141', '0.236', '0.161', '0.155', '0.159', '0.154', '0.13', '0.146', '0.117', '0.101', '0.067', '0.08', '0.06', '0.049', '0.024', '0.012', '0.277', '-0.341', '-0.381', '-0.52', '-0.451', '-0.028', '1.281', '-0.071', '-1.712', '-0.368', '1.884', '-0.284', '-1.88', '-0.194', '1.702', '-0.505', '-1.26', '-0.35', 'null', '0', '-0.089', '0.419', '-0.435', '2.862', '-0.326', '0.648', '0.512', 'null', 'null', '-0.017', '-0.037', '-0.066', '-0.081', '-0.111', '-0.083', '-0.147', '-0.152', '-0.167', '-0.175', '-0.195', '-0.257', '-0.138', '-0.278', '-0.199', '-0.212', '-0.196', '-0.19', '-0.196', '-0.161', '-0.124', '-0.183', '-0.118', '-0.115', '-0.054', '-0.074', '-0.043', '-0.024', '0.003', '0.027', '0.054', '0.07', '0.092', '0.122', '0.126', '0.119', '0.159', '0.164', '0.197', '0.19', '0.216', '0.192', '0.267', '0.212', '0.203', '0.188', '0.2', '0.172', '0.163', '0.154', '0.106', '0.115', '0.122', '0.074', '0.04', '0.033', '0.013', '0.401', '-0.02', '-0.048', '-0.078', '-0.099', '-0.126', '-0.111', '-0.171', '-0.189', '-0.198', '-0.218', '-0.234', '-0.303', '-0.185', '-0.319', '-0.255', '-0.248', '-0.24', '-0.233', '-0.227', '-0.204', '-0.148', '-0.221', '-0.145', '-0.131', '-0.077', '-0.083', '-0.055', '-0.028', '0.003', '0.034', '0.063', '0.086', '0.117', '0.141', '0.155', '0.142', '0.193', '0.201', '0.242', '0.228', '0.251', '0.248', '0.315', '0.256', '0.241', '0.241', '0.231', '0.211', '0.204', '0.176', '0.136', '0.14', '0.144', '0.088', '0.052', '0.04', '0.015', '-0.439', '-0.352', '-0.013', '-0.028', '-0.057', '-0.06', '-0.088', '-0.071', '-0.118', '-0.117', '-0.124', '-0.145', '-0.157', '-0.209', '-0.093', '-0.24', '-0.165', '-0.141', '-0.174', '-0.146', '-0.153', '-0.133', '-0.09', '-0.151', '-0.101', '-0.082', '-0.045', '-0.06', '-0.032', '-0.02', '0.003', '0.02', '0.043', '0.055', '0.071', '0.103', '0.105', '0.078', '0.13', '0.135', '0.161', '0.145', '0.178', '0.139', '0.22', '0.178', '0.15', '0.151', '0.164', '0.132', '0.122', '0.128', '0.091', '0.086', '0.097', '0.059', '0.031', '0.026', '0.012', '-0.248', '-0.793', '-0.638', '1.509', '-0.134', '-1.808', '-0.333', '1.906', '-0.322', '-1.829', '-0.147', '1.559', '-0.603', '-0.925', '-0.329', 'null', '-0.086', '0.309', '-0.532', '3.068', '-0.353', '0.648', '0.471', 'null', '-0.017', '-0.037', '-0.066', '-0.081', '-0.111', '-0.083', '-0.147', '-0.152', '-0.167', '-0.175', '-0.195', '-0.257', '-0.138', '-0.278', '-0.199', '-0.212', '-0.196', '-0.19', '-0.196', '-0.161', '-0.124', '-0.183', '-0.118', '-0.115', '-0.054', '-0.074', '-0.043', '-0.024', '0.003', '0.027', '0.054', '0.07', '0.092', '0.122', '0.126', '0.119', '0.159', '0.164', '0.197', '0.19', '0.216', '0.192', '0.267', '0.212', '0.203', '0.188', '0.2', '0.172', '0.163', '0.154', '0.106', '0.115', '0.122', '0.074', '0.04', '0.033', '0.013', '0.401', '-0.02', '-0.048', '-0.078', '-0.099', '-0.126', '-0.111', '-0.171', '-0.189', '-0.198', '-0.218', '-0.234', '-0.303', '-0.185', '-0.319', '-0.255', '-0.248', '-0.24', '-0.233', '-0.227', '-0.204', '-0.148', '-0.221', '-0.145', '-0.131', '-0.077', '-0.083', '-0.055', '-0.028', '0.003', '0.034', '0.063', '0.086', '0.117', '0.141', '0.155', '0.142', '0.193', '0.201', '0.242', '0.228', '0.251', '0.248', '0.315', '0.256', '0.241', '0.241', '0.231', '0.211', '0.204', '0.176', '0.136', '0.14', '0.144', '0.088', '0.052', '0.04', '0.015', '-0.439', '-0.352', '-0.013', '-0.028', '-0.057', '-0.06', '-0.088', '-0.071', '-0.118', '-0.117', '-0.124', '-0.145', '-0.157', '-0.209', '-0.093', '-0.24', '-0.165', '-0.141', '-0.174', '-0.146', '-0.153', '-0.133', '-0.09', '-0.151', '-0.101', '-0.082', '-0.045', '-0.06', '-0.032', '-0.02', '0.003', '0.02', '0.043', '0.055', '0.071', '0.103', '0.105', '0.078', '0.13', '0.135', '0.161', '0.145', '0.178', '0.139', '0.22', '0.178', '0.15', '0.151', '0.164', '0.132', '0.122', '0.128', '0.091', '0.086', '0.097', '0.059', '0.031', '0.026', '0.012', '-0.261', '-0.753', '-0.649', '1.494', '-0.13', '-1.801', '-0.336', '1.905', '-0.319', '-1.835', '-0.149', '1.571', '-0.592', '-0.958', '-0.338', 'null', '0', '-0.089', '0.034', '0.177', '0.892', '-0.268', '3.165', '-0.623', '0.238', 'null', 'null', '-0.04', '-0.063', '-0.082', '-0.103', '-0.126', '-0.14', '-0.155', '-0.174', '-0.18', '-0.155', '-0.247', '-0.149', '-0.263', '-0.218', '-0.185', '-0.209', '-0.199', '-0.183', '-0.17', '-0.159', '-0.139', '-0.128', '-0.106', '-0.085', '-0.064', '-0.04', '-0.016', '0.003', '0.026', '0.053', '0.072', '0.09', '0.116', '0.136', '0.142', '0.175', '0.162', '0.199', '0.203', '0.209', '0.142', '0.267', '0.209', '0.198', '0.202', '0.179', '0.192', '0.157', '0.151', '0.141', '0.109', '0.099', '0.069', '0.056', '0.028', '0.008', '-0.015', '0.397', '-0.048', '-0.075', '-0.099', '-0.127', '-0.151', '-0.173', '-0.183', '-0.21', '-0.228', '-0.177', '-0.298', '-0.193', '-0.312', '-0.255', '-0.233', '-0.253', '-0.241', '-0.219', '-0.209', '-0.189', '-0.175', '-0.15', '-0.129', '-0.101', '-0.078', '-0.049', '-0.02', '0.003', '0.034', '0.061', '0.087', '0.112', '0.139', '0.163', '0.18', '0.2', '0.208', '0.235', '0.241', '0.246', '0.193', '0.311', '0.254', '0.243', '0.243', '0.223', '0.224', '0.194', '0.184', '0.165', '0.138', '0.115', '0.089', '0.064', '0.035', '0.01', '-0.019', '-0.436', '-0.347', '-0.032', '-0.051', '-0.063', '-0.088', '-0.091', '-0.119', '-0.117', '-0.143', '-0.149', '-0.106', '-0.212', '-0.101', '-0.227', '-0.174', '-0.136', '-0.167', '-0.171', '-0.129', '-0.136', '-0.137', '-0.1', '-0.106', '-0.083', '-0.069', '-0.052', '-0.031', '-0.012', '0.003', '0.019', '0.044', '0.057', '0.069', '0.095', '0.115', '0.104', '0.128', '0.141', '0.164', '0.156', '0.171', '0.096', '0.226', '0.163', '0.153', '0.165', '0.146', '0.147', '0.12', '0.125', '0.118', '0.075', '0.086', '0.052', '0.047', '0.02', '0.008', '-0.011', '0.273', '-0.433', '-0.433', '-0.794', '-0.028', '1.264', '-0.068', '-1.7', '-0.374', '1.882', '-0.281', '-1.883', '-0.195', '1.707', '-0.497', '-1.28', '-0.351', 'null', '-0.088', '0.343', '-0.494', '3.049', '-0.349', '0.66', '0.471', 'null', '-0.015', '-0.04', '-0.063', '-0.082', '-0.103', '-0.126', '-0.14', '-0.155', '-0.174', '-0.18', '-0.155', '-0.247', '-0.149', '-0.263', '-0.218', '-0.185', '-0.209', '-0.199', '-0.183', '-0.17', '-0.159', '-0.139', '-0.128', '-0.106', '-0.085', '-0.064', '-0.04', '-0.016', '0.003', '0.026', '0.053', '0.072', '0.09', '0.116', '0.136', '0.142', '0.175', '0.162', '0.199', '0.203', '0.209', '0.142', '0.267', '0.209', '0.198', '0.202', '0.179', '0.192', '0.157', '0.151', '0.141', '0.109', '0.099', '0.069', '0.056', '0.028', '0.008', '0.401', '-0.019', '-0.048', '-0.075', '-0.099', '-0.127', '-0.151', '-0.173', '-0.183', '-0.21', '-0.228', '-0.177', '-0.298', '-0.193', '-0.312', '-0.255', '-0.233', '-0.253', '-0.241', '-0.219', '-0.209', '-0.189', '-0.175', '-0.15', '-0.129', '-0.101', '-0.078', '-0.049', '-0.02', '0.003', '0.034', '0.061', '0.087', '0.112', '0.139', '0.163', '0.18', '0.2', '0.208', '0.235', '0.241', '0.246', '0.193', '0.311', '0.254', '0.243', '0.243', '0.223', '0.224', '0.194', '0.184', '0.165', '0.138', '0.115', '0.089', '0.064', '0.035', '0.01', '-0.439', '-0.352', '-0.011', '-0.032', '-0.051', '-0.063', '-0.088', '-0.091', '-0.119', '-0.117', '-0.143', '-0.149', '-0.106', '-0.212', '-0.101', '-0.227', '-0.174', '-0.136', '-0.167', '-0.171', '-0.129', '-0.136', '-0.137', '-0.1', '-0.106', '-0.083', '-0.069', '-0.052', '-0.031', '-0.012', '0.003', '0.019', '0.044', '0.057', '0.069', '0.095', '0.115', '0.104', '0.128', '0.141', '0.164', '0.156', '0.171', '0.096', '0.226', '0.163', '0.153', '0.165', '0.146', '0.147', '0.12', '0.125', '0.118', '0.075', '0.086', '0.052', '0.047', '0.02', '0.008', '0.278', '-0.339', '-0.375', '-0.263', '-0.717', '-0.028', '1.282', '-0.073', '-1.708', '-0.372', '1.885', '-0.284', '-1.88', '-0.191', '1.697', '-0.502', '-1.261', '-0.35', 'null', '0', '-0.089', '0.416', '-0.448', '2.918', '-0.216', '0.186', '0.825', 'null', 'null', '-0.015', '-0.032', '-0.058', '-0.091', '-0.085', '-0.115', '-0.175', '-0.126', '-0.157', '-0.188', '-0.228', '-0.157', '-0.253', '-0.204', '-0.216', '-0.198', '-0.206', '-0.161', '-0.188', '-0.168', '-0.19', '-0.122', '-0.122', '-0.138', '-0.063', '-0.071', '-0.044', '-0.025', '-0.002', '0.005', '0.028', '0.052', '0.049', '0.095', '0.107', '0.163', '0.145', '0.126', '0.214', '0.155', '0.189', '0.202', '0.256', '0.205', '0.209', '0.157', '0.215', '0.224', '0.125', '0.222', '0.141', '0.115', '0.113', '0.108', '0.074', '0.064', '0.027', '0.013', '0.401', '-0.019', '-0.037', '-0.071', '-0.111', '-0.104', '-0.139', '-0.206', '-0.156', '-0.198', '-0.222', '-0.269', '-0.202', '-0.294', '-0.257', '-0.249', '-0.252', '-0.245', '-0.192', '-0.237', '-0.197', '-0.235', '-0.141', '-0.157', '-0.156', '-0.083', '-0.084', '-0.055', '-0.028', '-0.004', '0.007', '0.033', '0.06', '0.067', '0.111', '0.131', '0.188', '0.185', '0.152', '0.259', '0.185', '0.232', '0.245', '0.306', '0.249', '0.252', '0.2', '0.248', '0.272', '0.167', '0.252', '0.177', '0.138', '0.142', '0.122', '0.096', '0.076', '0.033', '0.015', '-0.439', '-0.352', '-0.011', '-0.028', '-0.047', '-0.073', '-0.065', '-0.087', '-0.144', '-0.106', '-0.121', '-0.139', '-0.193', '-0.113', '-0.207', '-0.167', '-0.166', '-0.161', '-0.167', '-0.119', '-0.155', '-0.124', '-0.164', '-0.086', '-0.102', '-0.105', '-0.056', '-0.056', '-0.033', '-0.023', '0.005', '0.02', '0.041', '0.04', '0.081', '0.077', '0.139', '0.103', '0.103', '0.168', '0.134', '0.148', '0.144', '0.228', '0.153', '0.167', '0.119', '0.177', '0.169', '0.102', '0.183', '0.106', '0.096', '0.085', '0.087', '0.059', '0.053', '0.018', '0.013', '-0.246', '-0.793', '-0.635', '1.501', '-0.13', '-1.811', '-0.33', '1.901', '-0.318', '-1.829', '-0.149', '1.556', '-0.597', '-0.927', '-0.331', 'null', '-0.085', '0.267', '-0.431', '2.94', '-0.326', '0.747', '0.416', 'null', '-0.015', '-0.032', '-0.058', '-0.091', '-0.085', '-0.115', '-0.175', '-0.126', '-0.157', '-0.188', '-0.228', '-0.157', '-0.253', '-0.204', '-0.216', '-0.198', '-0.206', '-0.161', '-0.188', '-0.168', '-0.19', '-0.122', '-0.122', '-0.138', '-0.063', '-0.071', '-0.044', '-0.025', '-0.002', '0.005', '0.028', '0.052', '0.049', '0.095', '0.107', '0.163', '0.145', '0.126', '0.214', '0.155', '0.189', '0.202', '0.256', '0.205', '0.209', '0.157', '0.215', '0.224', '0.125', '0.222', '0.141', '0.115', '0.113', '0.108', '0.074', '0.064', '0.027', '0.013', '0.401', '-0.019', '-0.037', '-0.071', '-0.111', '-0.104', '-0.139', '-0.206', '-0.156', '-0.198', '-0.222', '-0.269', '-0.202', '-0.294', '-0.257', '-0.249', '-0.252', '-0.245', '-0.192', '-0.237', '-0.197', '-0.235', '-0.141', '-0.157', '-0.156', '-0.083', '-0.084', '-0.055', '-0.028', '-0.004', '0.007', '0.033', '0.06', '0.067', '0.111', '0.131', '0.188', '0.185', '0.152', '0.259', '0.185', '0.232', '0.245', '0.306', '0.249', '0.252', '0.2', '0.248', '0.272', '0.167', '0.252', '0.177', '0.138', '0.142', '0.122', '0.096', '0.076', '0.033', '0.015', '-0.439', '-0.352', '-0.011', '-0.028', '-0.047', '-0.073', '-0.065', '-0.087', '-0.144', '-0.106', '-0.121', '-0.139', '-0.193', '-0.113', '-0.207', '-0.167', '-0.166', '-0.161', '-0.167', '-0.119', '-0.155', '-0.124', '-0.164', '-0.086', '-0.102', '-0.105', '-0.056', '-0.056', '-0.033', '-0.023', '0.005', '0.02', '0.041', '0.04', '0.081', '0.077', '0.139', '0.103', '0.103', '0.168', '0.134', '0.148', '0.144', '0.228', '0.153', '0.167', '0.119', '0.177', '0.169', '0.102', '0.183', '0.106', '0.096', '0.085', '0.087', '0.059', '0.053', '0.018', '0.013', '-0.259', '-0.751', '-0.649', '1.488', '-0.127', '-1.803', '-0.335', '1.902', '-0.316', '-1.834', '-0.153', '1.569', '-0.587', '-0.959', '-0.339', 'null', '0', '-0.089', '0.034', '0.223', '0.851', '-0.268', '3.121', '-0.578', '0.249', 'null', 'null', '-0.015', '-0.037', '-0.062', '-0.078', '-0.107', '-0.121', '-0.142', '-0.158', '-0.175', '-0.175', '-0.187', '-0.208', '-0.196', '-0.216', '-0.214', '-0.209', '-0.2', '-0.187', '-0.184', '-0.18', '-0.164', '-0.13', '-0.131', '-0.111', '-0.078', '-0.067', '-0.042', '-0.018', '-0.001', '0.026', '0.048', '0.072', '0.092', '0.113', '0.135', '0.14', '0.168', '0.188', '0.154', '0.216', '0.2', '0.221', '0.209', '0.199', '0.205', '0.2', '0.204', '0.162', '0.168', '0.156', '0.136', '0.118', '0.09', '0.083', '0.035', '0.043', '0.012', '0.401', '-0.018', '-0.047', '-0.073', '-0.098', '-0.127', '-0.144', '-0.175', '-0.189', '-0.208', '-0.219', '-0.226', '-0.25', '-0.239', '-0.265', '-0.25', '-0.251', '-0.249', '-0.229', '-0.224', '-0.213', '-0.195', '-0.165', '-0.158', '-0.129', '-0.101', '-0.078', '-0.041', '-0.011', '-0.021', '-0.001', '0.031', '0.06', '0.087', '0.112', '0.134', '0.164', '0.178', '0.189', '0.233', '0.141', '0.071', '0.238', '0.243', '0.266', '0.25', '0.244', '0.255', '0.238', '0.238', '0.21', '0.198', '0.188', '0.162', '0.142', '0.115', '0.094', '0.046', '0.048', '0.006', '0.013', '-0.439', '-0.352', '-0.011', '-0.031', '-0.05', '-0.061', '-0.086', '-0.098', '-0.109', '-0.128', '-0.142', '-0.133', '-0.145', '-0.177', '-0.134', '-0.193', '-0.17', '-0.163', '-0.145', '-0.169', '-0.131', '-0.154', '-0.123', '-0.102', '-0.106', '-0.09', '-0.061', '-0.053', '-0.032', '-0.015', '-0.001', '0.018', '0.041', '0.055', '0.074', '0.093', '0.099', '0.123', '0.128', '0.141', '0.13', '0.172', '0.151', '0.19', '0.161', '0.147', '0.166', '0.164', '0.164', '0.131', '0.127', '0.123', '0.113', '0.09', '0.073', '0.07', '0.025', '0.032', '0.012', '0.278', '-0.332', '-0.384', '-0.277', '-0.681', '-0.03', '1.263', '-0.067', '-1.703', '-0.371', '1.879', '-0.279', '-1.883', '-0.196', '1.708', '-0.496', '-1.281', '-0.35', 'null', '-0.091', '0.347', '-0.48', '3.019', '-0.341', '0.656', '0.482', 'null', '-0.015', '-0.037', '-0.062', '-0.078', '-0.107', '-0.121', '-0.142', '-0.158', '-0.175', '-0.175', '-0.187', '-0.208', '-0.196', '-0.216', '-0.214', '-0.209', '-0.2', '-0.187', '-0.184', '-0.18', '-0.164', '-0.13', '-0.131', '-0.111', '-0.078', '-0.067', '-0.042', '-0.018', '-0.001', '0.026', '0.048', '0.072', '0.092', '0.113', '0.135', '0.14', '0.168', '0.188', '0.154', '0.216', '0.2', '0.221', '0.209', '0.199', '0.205', '0.2', '0.204', '0.162', '0.168', '0.156', '0.136', '0.118', '0.09', '0.083', '0.035', '0.043', '0.012', '0.401', '-0.018', '-0.047', '-0.073', '-0.098', '-0.127', '-0.144', '-0.175', '-0.189', '-0.208', '-0.219', '-0.226', '-0.25', '-0.239', '-0.265', '-0.25', '-0.251', '-0.249', '-0.229', '-0.224', '-0.213', '-0.195', '-0.165', '-0.158', '-0.129', '-0.101', '-0.078', '-0.041', '-0.011', '-0.021', '-0.001', '0.031', '0.06', '0.087', '0.112', '0.134', '0.164', '0.178', '0.189', '0.233', '0.141', '0.071', '0.238', '0.243', '0.266', '0.25', '0.244', '0.255', '0.238', '0.238', '0.21', '0.198', '0.188', '0.162', '0.142', '0.115', '0.094', '0.046', '0.048', '0.006', '0.013', '-0.439', '-0.352', '-0.011', '-0.031', '-0.05', '-0.061', '-0.086', '-0.098', '-0.109', '-0.128', '-0.142', '-0.133', '-0.145', '-0.177', '-0.134', '-0.193', '-0.17', '-0.163', '-0.145', '-0.169', '-0.131', '-0.154', '-0.123', '-0.102', '-0.106', '-0.09', '-0.061', '-0.053', '-0.032', '-0.015', '-0.001', '0.018', '0.041', '0.055', '0.074', '0.093', '0.099', '0.123', '0.128', '0.141', '0.13', '0.172', '0.151', '0.19', '0.161', '0.147', '0.166', '0.164', '0.164', '0.131', '0.127', '0.123', '0.113', '0.09', '0.073', '0.07', '0.025', '0.032', '0.012', '0.278', '-0.332', '-0.384', '-0.277', '-0.7', '-0.03', '1.282', '-0.073', '-1.71', '-0.37', '1.884', '-0.283', '-1.881', '-0.192', '1.699', '-0.5', '-1.265', '-0.348', 'null', '0', '-0.091', '0.403', '-0.541', '2.756', '-0.132', '0.213', '0.97', 'null', 'null', '-0.039', '-0.059', '-0.081', '-0.102', '-0.122', '-0.139', '-0.156', '-0.168', '-0.186', '-0.194', '-0.195', '-0.216', '-0.196', '-0.214', '-0.217', '-0.194', '-0.189', '-0.187', '-0.177', '-0.154', '-0.153', '-0.121', '-0.107', '-0.089', '-0.06', '-0.046', '-0.018', '-0.004', '0.004', '0.025', '0.05', '0.067', '0.098', '0.105', '0.134', '0.149', '0.165', '0.172', '0.195', '0.19', '0.203', '0.213', '0.21', '0.197', '0.215', '0.193', '0.189', '0.192', '0.153', '0.158', '0.135', '0.116', '0.099', '0.077', '0.049', '0.034', '0.009', '-0.013', '0.397', '-0.045', '-0.074', '-0.097', '-0.122', '-0.151', '-0.166', '-0.188', '-0.208', '-0.223', '-0.228', '-0.248', '-0.253', '-0.244', '-0.255', '-0.255', '-0.242', '-0.234', '-0.223', '-0.215', '-0.189', '-0.177', '-0.152', '-0.129', '-0.106', '-0.077', '-0.053', '-0.021', '-0.005', '0.004', '0.03', '0.061', '0.083', '0.114', '0.135', '0.157', '0.182', '0.195', '0.215', '0.228', '0.235', '0.249', '0.256', '0.25', '0.249', '0.254', '0.236', '0.227', '0.225', '0.197', '0.186', '0.162', '0.144', '0.116', '0.095', '0.06', '0.041', '0.011', '-0.017', '-0.436', '-0.349', '-0.031', '-0.048', '-0.061', '-0.082', '-0.101', '-0.109', '-0.117', '-0.139', '-0.148', '-0.152', '-0.154', '-0.183', '-0.144', '-0.177', '-0.172', '-0.146', '-0.161', '-0.134', '-0.15', '-0.117', '-0.128', '-0.098', '-0.077', '-0.075', '-0.044', '-0.039', '-0.018', '0.004', '0.021', '0.039', '0.056', '0.074', '0.084', '0.103', '0.117', '0.143', '0.125', '0.161', '0.149', '0.156', '0.181', '0.165', '0.151', '0.172', '0.148', '0.154', '0.156', '0.114', '0.13', '0.11', '0.092', '0.073', '0.063', '0.038', '0.03', '0.006', '-0.01', '-0.236', '-0.794', '-0.634', '1.505', '-0.134', '-1.806', '-0.332', '1.904', '-0.324', '-1.828', '-0.144', '1.552', '-0.594', '-0.929', '-0.332', 'null', '-0.086', '0.289', '-0.484', '3.003', '-0.337', '1.05', 'null', '0.049', '0.034', '0.009', '-0.013', '-0.039', '-0.059', '-0.081', '-0.102', '-0.122', '-0.139', '-0.156', '-0.168', '-0.186', '-0.194', '-0.195', '-0.216', '-0.196', '-0.214', '-0.217', '-0.194', '-0.189', '-0.187', '-0.177', '-0.154', '-0.153', '-0.121', '-0.107', '-0.089', '-0.06', '-0.046', '-0.018', '-0.004', '0.004', '0.025', '0.05', '0.067', '0.098', '0.105', '0.134', '0.149', '0.165', '0.172', '0.195', '0.19', '0.203', '0.213', '0.21', '0.197', '0.215', '0.193', '0.189', '0.192', '0.153', '0.158', '0.135', '0.116', '0.099', '0.077', '0.381', '0.06', '0.041', '0.011', '-0.017', '-0.045', '-0.074', '-0.097', '-0.122', '-0.151', '-0.166', '-0.188', '-0.208', '-0.223', '-0.228', '-0.248', '-0.253', '-0.244', '-0.255', '-0.255', '-0.242', '-0.234', '-0.223', '-0.215', '-0.189', '-0.177', '-0.152', '-0.129', '-0.106', '-0.077', '-0.053', '-0.021', '-0.005', '0.004', '0.03', '0.061', '0.083', '0.114', '0.135', '0.157', '0.182', '0.195', '0.215', '0.228', '0.235', '0.249', '0.256', '0.25', '0.249', '0.254', '0.236', '0.227', '0.225', '0.197', '0.186', '0.162', '0.144', '0.116', '0.095', '-0.418', '-0.336', '0.038', '0.03', '0.006', '-0.01', '-0.031', '-0.048', '-0.061', '-0.082', '-0.101', '-0.109', '-0.117', '-0.139', '-0.148', '-0.152', '-0.154', '-0.183', '-0.144', '-0.177', '-0.172', '-0.146', '-0.161', '-0.134', '-0.15', '-0.117', '-0.128', '-0.098', '-0.077', '-0.075', '-0.044', '-0.039', '-0.018', '0.004', '0.021', '0.039', '0.056', '0.074', '0.084', '0.103', '0.117', '0.143', '0.125', '0.161', '0.149', '0.156', '0.181', '0.165', '0.151', '0.172', '0.148', '0.154', '0.156', '0.114', '0.13', '0.11', '0.092', '0.073', '0.063', '-0.185', '-0.75', '-0.649', '1.49', '-0.129', '-1.801', '-0.334', '1.902', '-0.319', '-1.834', '-0.149', '1.566', '-0.585', '-0.958', '-0.341', 'null', '0', '-0.089', '0.075', '0.199', '0.858', '-0.25', '3.089', '-0.615', '0.262', 'null', 'null', '-0.039', '-0.057', '-0.081', '-0.104', '-0.117', '-0.141', '-0.15', '-0.183', '-0.176', '-0.188', '-0.195', '-0.227', '-0.192', '-0.214', '-0.209', '-0.198', '-0.19', '-0.198', '-0.162', '-0.17', '-0.136', '-0.127', '-0.111', '-0.086', '-0.067', '-0.043', '-0.02', '-0.003', '0.003', '0.026', '0.047', '0.068', '0.096', '0.108', '0.127', '0.151', '0.167', '0.173', '0.191', '0.192', '0.21', '0.2', '0.218', '0.193', '0.216', '0.195', '0.189', '0.191', '0.151', '0.168', '0.127', '0.119', '0.097', '0.075', '0.055', '0.033', '0.01', '-0.012', '0.397', '-0.045', '-0.07', '-0.1', '-0.121', '-0.149', '-0.167', '-0.182', '-0.216', '-0.219', '-0.232', '-0.235', '-0.266', '-0.239', '-0.256', '-0.253', '-0.242', '-0.232', '-0.234', '-0.203', '-0.196', '-0.178', '-0.146', '-0.135', '-0.106', '-0.079', '-0.053', '-0.023', '-0.004', '0.003', '0.031', '0.059', '0.082', '0.112', '0.136', '0.156', '0.178', '0.199', '0.215', '0.227', '0.236', '0.257', '0.238', '0.259', '0.246', '0.252', '0.243', '0.226', '0.22', '0.202', '0.187', '0.161', '0.146', '0.117', '0.092', '0.064', '0.041', '0.012', '-0.016', '-0.436', '-0.349', '-0.034', '-0.039', '-0.069', '-0.085', '-0.088', '-0.119', '-0.107', '-0.154', '-0.138', '-0.152', '-0.144', '-0.197', '-0.141', '-0.174', '-0.169', '-0.153', '-0.147', '-0.163', '-0.123', '-0.149', '-0.088', '-0.111', '-0.087', '-0.069', '-0.054', '-0.032', '-0.017', '-0.003', '0.003', '0.022', '0.038', '0.048', '0.082', '0.082', '0.106', '0.111', '0.137', '0.143', '0.14', '0.153', '0.181', '0.153', '0.178', '0.142', '0.182', '0.152', '0.145', '0.15', '0.124', '0.133', '0.106', '0.091', '0.075', '0.059', '0.046', '0.024', '0.009', '-0.009', '-0.156', '-1.263', '-0.503', '1.703', '-0.192', '-1.883', '-0.281', '1.881', '-0.368', '-1.709', '-0.072', '1.284', '-0.013', 'null', '-0.001', '-0.771', '-0.446', '-0.303', '-0.133', '0.121', '0.299', '0.239', '1.111', '0.082', '2.167', '-0.64', '0.237', 'null', '0.01', '-0.012', '-0.039', '-0.057', '-0.081', '-0.104', '-0.117', '-0.141', '-0.15', '-0.183', '-0.176', '-0.188', '-0.195', '-0.227', '-0.192', '-0.214', '-0.209', '-0.198', '-0.19', '-0.198', '-0.162', '-0.17', '-0.136', '-0.127', '-0.111', '-0.086', '-0.067', '-0.043', '-0.02', '-0.003', '0.003', '0.026', '0.047', '0.068', '0.096', '0.108', '0.127', '0.151', '0.167', '0.173', '0.191', '0.192', '0.21', '0.2', '0.218', '0.193', '0.216', '0.195', '0.189', '0.191', '0.151', '0.168', '0.127', '0.119', '0.097', '0.075', '0.055', '0.033', '0.399', '0.012', '-0.016', '-0.045', '-0.07', '-0.1', '-0.121', '-0.149', '-0.167', '-0.182', '-0.216', '-0.219', '-0.232', '-0.235', '-0.266', '-0.239', '-0.256', '-0.253', '-0.242', '-0.232', '-0.234', '-0.203', '-0.196', '-0.178', '-0.146', '-0.135', '-0.106', '-0.079', '-0.053', '-0.023', '-0.004', '0.003', '0.031', '0.059', '0.082', '0.112', '0.136', '0.156', '0.178', '0.199', '0.215', '0.227', '0.236', '0.257', '0.238', '0.259', '0.246', '0.252', '0.243', '0.226', '0.22', '0.202', '0.187', '0.161', '0.146', '0.117', '0.092', '0.064', '0.041', '-0.437', '-0.352', '0.009', '-0.009', '-0.034', '-0.039', '-0.069', '-0.085', '-0.088', '-0.119', '-0.107', '-0.154', '-0.138', '-0.152', '-0.144', '-0.197', '-0.141', '-0.174', '-0.169', '-0.153', '-0.147', '-0.163', '-0.123', '-0.149', '-0.088', '-0.111', '-0.087', '-0.069', '-0.054', '-0.032', '-0.017', '-0.003', '0.003', '0.022', '0.038', '0.048', '0.082', '0.082', '0.106', '0.111', '0.137', '0.143', '0.14', '0.153', '0.181', '0.153', '0.178', '0.142', '0.182', '0.152', '0.145', '0.15', '0.124', '0.133', '0.106', '0.091', '0.075', '0.059', '0.046', '0.024', '-0.156', '-1.282', '-0.498', '1.712', '-0.195', '-1.886', '-0.279', '1.88', '-0.372', '-1.7', '-0.067', '1.265', '-0.013', '0', '-0.001', '0.888', '0.465', '0.627', 'null', '0.011', '-0.009', '-0.032', '-0.053', '-0.08', '-0.103', '-0.107', '-0.146', '-0.15', '-0.162', '-0.19', '-0.186', '-0.202', '-0.203', '-0.2', '-0.227', '-0.199', '-0.197', '-0.201', '-0.187', '-0.173', '-0.167', '-0.142', '-0.134', '-0.108', '-0.092', '-0.069', '-0.048', '-0.024', '-0.005', '0.002', '0.02', '0.048', '0.063', '0.093', '0.103', '0.129', '0.139', '0.172', '0.167', '0.182', '0.211', '0.184', '0.21', '0.219', '0.198', '0.212', '0.192', '0.201', '0.176', '0.176', '0.155', '0.133', '0.12', '0.106', '0.079', '0.057', '0.038', '0.397', '0.015', '-0.011', '-0.039', '-0.066', '-0.094', '-0.125', '-0.13', '-0.176', '-0.183', '-0.202', '-0.217', '-0.234', '-0.239', '-0.249', '-0.249', '-0.26', '-0.245', '-0.244', '-0.245', '-0.226', '-0.211', '-0.194', '-0.181', '-0.16', '-0.13', '-0.109', '-0.087', '-0.056', '-0.03', '-0.005', '0.002', '0.025', '0.055', '0.081', '0.106', '0.132', '0.15', '0.178', '0.197', '0.206', '0.223', '0.251', '0.232', '0.251', '0.259', '0.238', '0.263', '0.236', '0.236', '0.223', '0.204', '0.186', '0.17', '0.142', '0.123', '0.101', '0.067', '0.045', '-0.436', '-0.349', '0.009', '-0.008', '-0.024', '-0.042', '-0.067', '-0.076', '-0.09', '-0.117', '-0.113', '-0.134', '-0.149', '-0.156', '-0.15', '-0.166', '-0.152', '-0.196', '-0.138', '-0.169', '-0.154', '-0.15', '-0.134', '-0.148', '-0.097', '-0.105', '-0.095', '-0.069', '-0.056', '-0.036', '-0.025', '0.002', '0.015', '0.04', '0.047', '0.079', '0.08', '0.1', '0.115', '0.137', '0.116', '0.167', '0.156', '0.151', '0.159', '0.188', '0.134', '0.187', '0.136', '0.179', '0.132', '0.14', '0.128', '0.099', '0.099', '0.082', '0.065', '0.043', '0.031', '-0.251', '-0.746', '-0.656', '1.493', '-0.129', '-1.801', '-0.335', '1.904', '-0.32', '-1.831', '-0.152', '1.569', '-0.587', '-0.96', '-0.338', 'null', '-0.088', '0.067', '0.191', '0.847', '-0.276', '3.186', '-0.626', '0.229', 'null', '-0.032', '-0.053', '-0.08', '-0.103', '-0.107', '-0.146', '-0.15', '-0.162', '-0.19', '-0.186', '-0.202', '-0.203', '-0.2', '-0.227', '-0.199', '-0.197', '-0.201', '-0.187', '-0.173', '-0.167', '-0.142', '-0.134', '-0.108', '-0.092', '-0.069', '-0.048', '-0.024', '-0.005', '0.002', '0.02', '0.048', '0.063', '0.093', '0.103', '0.129', '0.139', '0.172', '0.167', '0.182', '0.211', '0.184', '0.21', '0.219', '0.198', '0.212', '0.192', '0.201', '0.176', '0.176', '0.155', '0.133', '0.12', '0.106', '0.079', '0.057', '0.038', '0.011', '-0.009', '0.399', '-0.039', '-0.066', '-0.094', '-0.125', '-0.13', '-0.176', '-0.183', '-0.202', '-0.217', '-0.234', '-0.239', '-0.249', '-0.249', '-0.26', '-0.245', '-0.244', '-0.245', '-0.226', '-0.211', '-0.194', '-0.181', '-0.16', '-0.13', '-0.109', '-0.087', '-0.056', '-0.03', '-0.005', '0.002', '0.025', '0.055', '0.081', '0.106', '0.132', '0.15', '0.178', '0.197', '0.206', '0.223', '0.251', '0.232', '0.251', '0.259', '0.238', '0.263', '0.236', '0.236', '0.223', '0.204', '0.186', '0.17', '0.142', '0.123', '0.101', '0.067', '0.045', '0.015', '-0.011', '-0.437', '-0.351', '-0.024', '-0.042', '-0.067', '-0.076', '-0.09', '-0.117', '-0.113', '-0.134', '-0.149', '-0.156', '-0.15', '-0.166', '-0.152', '-0.196', '-0.138', '-0.169', '-0.154', '-0.15', '-0.134', '-0.148', '-0.097', '-0.105', '-0.095', '-0.069', '-0.056', '-0.036', '-0.025', '0.002', '0.015', '0.04', '0.047', '0.079', '0.08', '0.1', '0.115', '0.137', '0.116', '0.167', '0.156', '0.151', '0.159', '0.188', '0.134', '0.187', '0.136', '0.179', '0.132', '0.14', '0.128', '0.099', '0.099', '0.082', '0.065', '0.043', '0.031', '0.009', '-0.008', '-0.239', '-0.79', '-0.641', '1.507', '-0.133', '-1.807', '-0.331', '1.904', '-0.323', '-1.827', '-0.148', '1.558', '-0.597', '-0.929', '-0.339', '0', '-0.087', '0.436', '0.433', '0.536', '0.564', '0.541', '0.457', '0.644', 'null', '-0.034', '-0.054', '-0.078', '-0.097', '-0.122', '-0.138', '-0.147', '-0.172', '-0.183', '-0.183', '-0.21', '-0.209', '-0.192', '-0.218', '-0.206', '-0.203', '-0.199', '-0.182', '-0.182', '-0.159', '-0.142', '-0.133', '-0.112', '-0.088', '-0.07', '-0.047', '-0.023', '-0.004', '0.003', '0.022', '0.044', '0.067', '0.087', '0.115', '0.114', '0.149', '0.173', '0.165', '0.188', '0.19', '0.211', '0.201', '0.218', '0.201', '0.205', '0.203', '0.187', '0.185', '0.174', '0.153', '0.135', '0.122', '0.102', '0.081', '0.054', '0.035', '0.014', '-0.011', '0.398', '-0.04', '-0.067', '-0.094', '-0.118', '-0.146', '-0.167', '-0.179', '-0.208', '-0.221', '-0.226', '-0.254', '-0.24', '-0.249', '-0.259', '-0.244', '-0.253', '-0.233', '-0.226', '-0.214', '-0.199', '-0.176', '-0.154', '-0.136', '-0.109', '-0.084', '-0.056', '-0.029', '-0.004', '0.003', '0.026', '0.053', '0.084', '0.103', '0.137', '0.148', '0.18', '0.197', '0.209', '0.224', '0.236', '0.251', '0.246', '0.259', '0.238', '0.262', '0.236', '0.236', '0.217', '0.208', '0.19', '0.161', '0.149', '0.122', '0.098', '0.066', '0.043', '0.016', '-0.013', '-0.437', '-0.35', '-0.027', '-0.041', '-0.066', '-0.07', '-0.103', '-0.109', '-0.114', '-0.14', '-0.141', '-0.15', '-0.174', '-0.157', '-0.153', '-0.179', '-0.16', '-0.158', '-0.158', '-0.152', '-0.131', '-0.138', '-0.102', '-0.111', '-0.095', '-0.065', '-0.055', '-0.036', '-0.023', '0.003', '0.018', '0.034', '0.052', '0.068', '0.1', '0.077', '0.131', '0.131', '0.126', '0.158', '0.145', '0.176', '0.153', '0.184', '0.137', '0.173', '0.155', '0.162', '0.142', '0.141', '0.121', '0.107', '0.094', '0.08', '0.068', '0.045', '0.023', '0.012', '-0.008', '-0.157', '-1.265', '-0.5', '1.702', '-0.193', '-1.883', '-0.281', '1.882', '-0.369', '-1.71', '-0.072', '1.285', '-0.013', 'null', '-0.002', '-0.799', '-0.539', '-0.252', '-0.057', '0.127', '0.304', '0.124', '1.242', '0.095', '2.091', '-0.623', '0.249', 'null', '0.014', '-0.011', '-0.034', '-0.054', '-0.078', '-0.097', '-0.122', '-0.138', '-0.147', '-0.172', '-0.183', '-0.183', '-0.21', '-0.209', '-0.192', '-0.218', '-0.206', '-0.203', '-0.199', '-0.182', '-0.182', '-0.159', '-0.142', '-0.133', '-0.112', '-0.088', '-0.07', '-0.047', '-0.023', '-0.004', '0.003', '0.022', '0.044', '0.067', '0.087', '0.115', '0.114', '0.149', '0.173', '0.165', '0.188', '0.19', '0.211', '0.201', '0.218', '0.201', '0.205', '0.203', '0.187', '0.185', '0.174', '0.153', '0.135', '0.122', '0.102', '0.081', '0.054', '0.035', '0.398', '0.016', '-0.013', '-0.04', '-0.067', '-0.094', '-0.118', '-0.146', '-0.167', '-0.179', '-0.208', '-0.221', '-0.226', '-0.254', '-0.24', '-0.249', '-0.259', '-0.244', '-0.253', '-0.233', '-0.226', '-0.214', '-0.199', '-0.176', '-0.154', '-0.136', '-0.109', '-0.084', '-0.056', '-0.029', '-0.004', '0.003', '0.026', '0.053', '0.084', '0.103', '0.137', '0.148', '0.18', '0.197', '0.209', '0.224', '0.236', '0.251', '0.246', '0.259', '0.238', '0.262', '0.236', '0.236', '0.217', '0.208', '0.19', '0.161', '0.149', '0.122', '0.098', '0.066', '0.043', '-0.437', '-0.351', '0.012', '-0.008', '-0.027', '-0.041', '-0.066', '-0.07', '-0.103', '-0.109', '-0.114', '-0.14', '-0.141', '-0.15', '-0.174', '-0.157', '-0.153', '-0.179', '-0.16', '-0.158', '-0.158', '-0.152', '-0.131', '-0.138', '-0.102', '-0.111', '-0.095', '-0.065', '-0.055', '-0.036', '-0.023', '0.003', '0.018', '0.034', '0.052', '0.068', '0.1', '0.077', '0.131', '0.131', '0.126', '0.158', '0.145', '0.176', '0.153', '0.184', '0.137', '0.173', '0.155', '0.162', '0.142', '0.141', '0.121', '0.107', '0.094', '0.08', '0.068', '0.045', '0.023', '-0.154', '-1.284', '-0.492', '1.709', '-0.196', '-1.885', '-0.28', '1.881', '-0.373', '-1.701', '-0.065', '1.265', '-0.013', '0', '-0.002', '0.866', '0.466', '0.65', 'null', '0.012', '-0.012', '-0.033', '-0.058', '-0.078', '-0.096', '-0.123', '-0.132', '-0.158', '-0.169', '-0.177', '-0.2', '-0.19', '-0.207', '-0.214', '-0.208', '-0.204', '-0.205', '-0.201', '-0.183', '-0.163', '-0.172', '-0.152', '-0.122', '-0.111', '-0.085', '-0.076', '-0.041', '-0.026', '-0.003', '0.004', '0.023', '0.043', '0.072', '0.083', '0.118', '0.117', '0.152', '0.164', '0.172', '0.184', '0.193', '0.215', '0.194', '0.211', '0.207', '0.205', '0.207', '0.194', '0.175', '0.165', '0.154', '0.155', '0.101', '0.112', '0.075', '0.057', '0.035', '0.397', '0.015', '-0.014', '-0.039', '-0.072', '-0.091', '-0.123', '-0.142', '-0.164', '-0.19', '-0.207', '-0.213', '-0.233', '-0.247', '-0.244', '-0.255', '-0.255', '-0.244', '-0.252', '-0.232', '-0.233', '-0.2', '-0.205', '-0.18', '-0.15', '-0.134', '-0.108', '-0.085', '-0.054', '-0.029', '-0.004', '0.004', '0.027', '0.055', '0.084', '0.104', '0.136', '0.15', '0.177', '0.204', '0.206', '0.221', '0.239', '0.25', '0.247', '0.252', '0.246', '0.256', '0.242', '0.238', '0.213', '0.205', '0.182', '0.179', '0.137', '0.126', '0.093', '0.071', '0.04', '-0.437', '-0.35', '0.01', '-0.009', '-0.025', '-0.049', '-0.06', '-0.069', '-0.112', '-0.095', '-0.134', '-0.131', '-0.131', '-0.174', '-0.144', '-0.174', '-0.156', '-0.182', '-0.143', '-0.172', '-0.153', '-0.145', '-0.138', '-0.126', '-0.127', '-0.097', '-0.087', '-0.068', '-0.061', '-0.03', '-0.025', '0.004', '0.019', '0.032', '0.055', '0.076', '0.084', '0.092', '0.136', '0.112', '0.151', '0.138', '0.149', '0.182', '0.142', '0.182', '0.137', '0.186', '0.16', '0.157', '0.143', '0.118', '0.131', '0.125', '0.069', '0.099', '0.056', '0.048', '0.024', '-0.247', '-0.75', '-0.655', '1.492', '-0.127', '-1.803', '-0.334', '1.906', '-0.32', '-1.835', '-0.151', '1.57', '-0.588', '-0.961', '-0.339', 'null', '-0.09', '0.07', '0.203', '0.833', '-0.267', '3.168', '-0.626', '0.208', 'null', '-0.058', '-0.078', '-0.096', '-0.123', '-0.132', '-0.158', '-0.169', '-0.177', '-0.2', '-0.19', '-0.207', '-0.214', '-0.208', '-0.204', '-0.205', '-0.201', '-0.183', '-0.163', '-0.172', '-0.152', '-0.122', '-0.111', '-0.085', '-0.076', '-0.041', '-0.026', '-0.003', '0.004', '0.023', '0.043', '0.072', '0.083', '0.118', '0.117', '0.152', '0.164', '0.172', '0.184', '0.193', '0.215', '0.194', '0.211', '0.207', '0.205', '0.207', '0.194', '0.175', '0.165', '0.154', '0.155', '0.101', '0.112', '0.075', '0.057', '0.035', '0.012', '-0.012', '-0.033', '0.392', '-0.072', '-0.091', '-0.123', '-0.142', '-0.164', '-0.19', '-0.207', '-0.213', '-0.233', '-0.247', '-0.244', '-0.255', '-0.255', '-0.244', '-0.252', '-0.232', '-0.233', '-0.2', '-0.205', '-0.18', '-0.15', '-0.134', '-0.108', '-0.085', '-0.054', '-0.029', '-0.004', '0.004', '0.027', '0.055', '0.084', '0.104', '0.136', '0.15', '0.177', '0.204', '0.206', '0.221', '0.239', '0.25', '0.247', '0.252', '0.246', '0.256', '0.242', '0.238', '0.213', '0.205', '0.182', '0.179', '0.137', '0.126', '0.093', '0.071', '0.04', '0.015', '-0.014', '-0.039', '-0.429', '-0.344', '-0.049', '-0.06', '-0.069', '-0.112', '-0.095', '-0.134', '-0.131', '-0.131', '-0.174', '-0.144', '-0.174', '-0.156', '-0.182', '-0.143', '-0.172', '-0.153', '-0.145', '-0.138', '-0.126', '-0.127', '-0.097', '-0.087', '-0.068', '-0.061', '-0.03', '-0.025', '0.004', '0.019', '0.032', '0.055', '0.076', '0.084', '0.092', '0.136', '0.112', '0.151', '0.138', '0.149', '0.182', '0.142', '0.182', '0.137', '0.186', '0.16', '0.157', '0.143', '0.118', '0.131', '0.125', '0.069', '0.099', '0.056', '0.048', '0.024', '0.01', '-0.009', '-0.025', '-0.209', '-0.796', '-0.639', '1.507', '-0.132', '-1.808', '-0.331', '1.906', '-0.323', '-1.83', '-0.148', '1.559', '-0.599', '-0.929', '-0.33'];
                relative_pos_z = ['null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
                EStatus = ['null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
            }
            if (nozzle_size === 0.6) {
                GStatus = ['null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1'];
                EStatus = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null'];
                relative_pos_x = ['null',	'-0.239',	'-0.145',	'-0.2',	'-0.25',	'-0.129',	'-0.014',	'0.025',	'0.04',	'0.11',	'0.262',	'0.361',	'0.405',	'0.418',	'0.37',	'0.289',	'0.084',	'0.089',	'0.03',	'0.004',	'-0.025',	'-0.079',	'-0.076',	'-0.154',	'-0.329',	'-0.161',	'-0.256',	'-0.259',	'-0.171',	'-0.137',	'-0.336',	'-0.238',	'-0.276',	'-0.187',	'-0.19',	'-0.112',	'-0.081',	'-0.023',	'0.035',	'0.068',	'0.148',	'0.151',	'0.244',	'0.216',	'0.31',	'0.26',	'0.348',	'0.276',	'0.336',	'0.256',	'0.298',	'0.209',	'0.221',	'0.136',	'0.123',	'0.05',	'0.006',	'-0.039',	'-0.112',	'-0.124',	'-0.213',	'-0.199',	'-0.293',	'-0.251',	'-0.346',	'-0.046',	'-0.356',	'-0.269',	'0.152',	'0.119',	'-0.197',	'-0.241',	'-0.081',	'0.032',	'0.199',	'0.191',	'0.208',	'0.221',	'0.19',	'0.172',	'0.088',	'-0.008',	'-0.075',	'-0.077',	'-0.214',	'-0.189',	'-0.219',	'0.525',	'-0.501',	'-0.254',	'-0.789',	'-0.276',	'null',	'2.392',	'null',	'0.082',	'null',	'-0.384',	'null',	'-0.101',	'null',	'-30.142',	'null',	'-0.256',	'-0.259',	'-0.171',	'-0.239',	'-0.145',	'-0.2',	'-0.25',	'-0.129',	'-0.014',	'0.025',	'0.04',	'0.11',	'0.262',	'0.361',	'0.405',	'0.418',	'0.37',	'0.289',	'0.084',	'0.089',	'0.03',	'0.004',	'-0.025',	'-0.079',	'-0.076',	'-0.154',	'-0.329',	'-0.161',	'0.194',	'-0.346',	'-0.046',	'-0.356',	'-0.269',	'-0.336',	'-0.238',	'-0.276',	'-0.187',	'-0.19',	'-0.112',	'-0.081',	'-0.023',	'0.035',	'0.068',	'0.148',	'0.151',	'0.244',	'0.216',	'0.31',	'0.26',	'0.348',	'0.276',	'0.336',	'0.256',	'0.298',	'0.209',	'0.221',	'0.136',	'0.123',	'0.05',	'0.006',	'-0.039',	'-0.112',	'-0.124',	'-0.213',	'-0.199',	'-0.293',	'-0.251',	'-0.213',	'-0.125',	'-0.189',	'-0.219',	'-0.197',	'-0.241',	'-0.081',	'0.032',	'0.199',	'0.191',	'0.208',	'0.221',	'0.19',	'0.172',	'0.088',	'-0.008',	'-0.075',	'-0.077',	'-0.214',	'-0.16',	'-0.503',	'-0.821',	'0.456',	'null',	'-0.768',	'null',	'0.147',	'null',	'2.268',	'null',	'0.086',	'null',	'0',	'-0.974',	'null',	'null',	'-0.367',	'-0.306',	'-0.312',	'-0.229',	'-0.103',	'-0.152',	'-0.044',	'-0.037',	'0.042',	'0.109',	'0.197',	'0.231',	'0.148',	'0.324',	'0.141',	'0.361',	'0.356',	'0.306',	'0.312',	'0.229',	'0.103',	'0.154',	'0.04',	'0.039',	'-0.041',	'-0.11',	'-0.197',	'-0.231',	'-0.148',	'-0.323',	'-0.148',	'-0.344',	'-0.004',	'-0.477',	'-0.237',	'-0.235',	'-0.394',	'-0.19',	'-0.156',	'-0.144',	'-0.196',	'-0.07',	'-0.051',	'0.055',	'0.067',	'0.1',	'0.249',	'0.171',	'0.178',	'0.207',	'0.412',	'0.248',	'0.471',	'0.469',	'0.237',	'0.235',	'0.394',	'0.19',	'0.156',	'0.144',	'0.196',	'0.07',	'0.051',	'-0.055',	'-0.067',	'-0.1',	'-0.249',	'-0.171',	'-0.178',	'-0.207',	'-0.412',	'-0.246',	'-0.465',	'0.001',	'0.007',	'-0.418',	'-0.2',	'-0.188',	'-0.113',	'-0.041',	'0.091',	'0.126',	'0.208',	'0.237',	'0.291',	'0.409',	'0.2',	'0.19',	'0.11',	'0.042',	'-0.092',	'-0.274',	'-0.061',	'-0.239',	'-0.278',	'-0.08',	'0.769',	'-0.326',	'-0.976',	'null',	'30.609',	'null',	'-0.367',	'-0.306',	'-0.312',	'-0.229',	'-0.103',	'-0.152',	'-0.044',	'-0.037',	'0.042',	'0.109',	'0.197',	'0.231',	'0.148',	'0.324',	'0.141',	'0.361',	'0.356',	'0.306',	'0.312',	'0.229',	'0.103',	'0.154',	'0.04',	'0.039',	'-0.041',	'-0.11',	'-0.197',	'-0.231',	'-0.148',	'-0.323',	'-0.148',	'-0.344',	'-0.004',	'-0.477',	'-0.237',	'-0.235',	'-0.394',	'-0.19',	'-0.156',	'-0.144',	'-0.196',	'-0.07',	'-0.051',	'0.055',	'0.067',	'0.1',	'0.249',	'0.171',	'0.178',	'0.207',	'0.412',	'0.248',	'0.471',	'0.469',	'0.237',	'0.235',	'0.394',	'0.19',	'0.156',	'0.144',	'0.196',	'0.07',	'0.051',	'-0.055',	'-0.067',	'-0.1',	'-0.249',	'-0.171',	'-0.178',	'-0.207',	'-0.412',	'-0.246',	'-0.465',	'0.001',	'0.007',	'-0.418',	'-0.2',	'-0.188',	'-0.113',	'-0.041',	'0.091',	'0.126',	'0.208',	'0.237',	'0.291',	'0.409',	'0.2',	'0.19',	'0.11',	'0.042',	'-0.092',	'-0.274',	'-0.061',	'-0.239',	'-0.278',	'-0.328',	'0.951',	'-0.49',	'-0.829',	'null',	'0',	'-29.117',	'null',	'null',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'0.054',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.055',	'null',	'29.611',	'null',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.054',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'0.055',	'0.286',	'-1.559',	'null',	'0',	'-28.338',	'null',	'null',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'0.054',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.055',	'null',	'29.611',	'null',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.054',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'0.055',	'0.549',	'-1.785',	'null',	'0',	'-28.375',	'null',	'null',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'0.054',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.055',	'null',	'29.611',	'null',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.054',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'0.055',	'0.771',	'-1.929',	'null',	'0',	'-28.453',	'null',	'null',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'0.054',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.055',	'null',	'29.611',	'null',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.054',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'0.055',	'0.973',	'-2.033',	'null',	'0',	'-28.551',	'null',	'null',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'0.054',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.055',	'null',	'29.611',	'null',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.054',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'0.055',	'1.139',	'-2.066',	'null',	'0',	'-28.684',	'null',	'null',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'0.054',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.055',	'null',	'29.611',	'null',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.054',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'0.055',	'1.294',	'-2.072',	'null',	'0',	'-28.833',	'null',	'null',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'0.054',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.055',	'null',	'29.611',	'null',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.054',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'0.055',	'null',	'1.427',	'null',	'-2.039',	'null',	'0',	'-28.999',	'null',	'null',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'0.054',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.055',	'null',	'29.611',	'null',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.054',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'0.055',	'null',	'1.411',	'null',	'0.247',	'-0.125',	'-1.951',	'null',	'0',	'-29.193',	'null',	'null',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'0.054',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.055',	'-0.051',	'-0.286',	'-0.056',	'-0.265',	'-0.245',	'-0.184',	'-0.092',	'-0.01',	'0',	'0.01',	'0.092',	'0.184',	'0.245',	'0.265',	'0.056',	'0.286',	'0.056',	'0.265',	'0.245',	'0.184',	'0.092',	'0.01',	'0',	'-0.01',	'-0.092',	'-0.184',	'-0.245',	'-0.265',	'-0.056',	'0.238',	'-1.038',	'0.488',	'0.912',	'null',	'29.062',	'null',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.054',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'0.055',	'0.051',	'-0.056',	'-0.265',	'-0.245',	'-0.184',	'-0.092',	'-0.01',	'0',	'0.01',	'0.092',	'0.184',	'0.245',	'0.265',	'0.056',	'0.286',	'0.056',	'0.265',	'0.245',	'0.184',	'0.092',	'0.01',	'0',	'-0.01',	'-0.092',	'-0.184',	'-0.245',	'-0.265',	'-0.056',	'-0.286',	'0.31',	'-0.912',	'0.363',	'1.037',	'null',	'0',	'-30.46',	'null',	'null',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'0.054',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.055',	'-0.051',	'-0.286',	'-0.056',	'-0.265',	'-0.245',	'-0.184',	'-0.092',	'-0.01',	'0',	'0.01',	'0.092',	'0.184',	'0.245',	'0.265',	'0.056',	'0.286',	'0.056',	'0.265',	'0.245',	'0.184',	'0.092',	'0.01',	'0',	'-0.01',	'-0.092',	'-0.184',	'-0.245',	'-0.265',	'-0.056',	'-0.279',	'0.889',	'-0.346',	'-1.045',	'null',	'30.443',	'null',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.054',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'0.055',	'0.051',	'-0.056',	'-0.265',	'-0.245',	'-0.184',	'-0.092',	'-0.01',	'0',	'0.01',	'0.092',	'0.184',	'0.245',	'0.265',	'0.056',	'0.286',	'0.056',	'0.265',	'0.245',	'0.184',	'0.092',	'0.01',	'0',	'-0.01',	'-0.092',	'-0.184',	'-0.245',	'-0.265',	'-0.056',	'-0.286',	'null',	'0.815',	'null',	'-1.031',	'-0.374',	'0.932',	'null',	'0',	'-30.004',	'null',	'null',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'0.054',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.055',	'-0.051',	'-0.286',	'-0.056',	'-0.265',	'-0.245',	'-0.184',	'-0.092',	'-0.01',	'0',	'0.01',	'0.092',	'0.184',	'0.245',	'0.265',	'0.056',	'0.286',	'0.056',	'0.265',	'0.245',	'0.184',	'0.092',	'0.01',	'0',	'-0.01',	'-0.092',	'-0.184',	'-0.245',	'-0.265',	'-0.056',	'0.238',	'-1.038',	'0.488',	'0.912',	'null',	'29.062',	'null',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.054',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'0.055',	'0.051',	'-0.056',	'-0.265',	'-0.245',	'-0.184',	'-0.092',	'-0.01',	'0',	'0.01',	'0.092',	'0.184',	'0.245',	'0.265',	'0.056',	'0.286',	'0.056',	'0.265',	'0.245',	'0.184',	'0.092',	'0.01',	'0',	'-0.01',	'-0.092',	'-0.184',	'-0.245',	'-0.265',	'-0.056',	'-0.286',	'0.31',	'-0.912',	'0.363',	'1.037',	'null',	'0',	'-1.001',	'null',	'null',	'-0.369',	'-0.282',	'-0.25',	'-0.103',	'-0.162',	'-0.076',	'0',	'0.029',	'0.131',	'0.179',	'0.248',	'0.147',	'0.339',	'0.336',	'0.193',	'0.332',	'0.369',	'0.282',	'0.25',	'0.103',	'0.162',	'0.076',	'0',	'-0.029',	'-0.123',	'-0.199',	'-0.241',	'-0.136',	'-0.345',	'-0.336',	'-0.359',	'-0.166',	'-0.155',	'-0.46',	'-0.219',	'-0.195',	'-0.192',	'-0.15',	'-0.151',	'-0.208',	'-0.068',	'-0.041',	'-0.014',	'0.014',	'0.044',	'0.163',	'0.122',	'0.139',	'0.173',	'0.168',	'0.216',	'0.434',	'0.244',	'0.235',	'0.265',	'0.23',	'0.253',	'0.46',	'0.219',	'0.195',	'0.192',	'0.15',	'0.151',	'0.208',	'0.068',	'0.041',	'0.014',	'-0.014',	'-0.044',	'-0.162',	'-0.262',	'-0.173',	'-0.168',	'-0.214',	'-0.436',	'-0.244',	'-0.235',	'-0.265',	'-0.23',	'-0.253',	'0.167',	'0.132',	'-0.251',	'-0.34',	'-0.046',	'-0.111',	'-0.048',	'0.013',	'0.09',	'0.276',	'0.066',	'0.232',	'0.321',	'0.212',	'0.241',	'0.34',	'0.046',	'0.111',	'0.048',	'-0.014',	'-0.082',	'-0.131',	'-0.209',	'-0.241',	'-0.21',	'-0.313',	'null',	'0.869',	'null',	'-1.02',	'-0.38',	'0.93',	'-1.152',	'-0.099',	'null',	'-28.431',	'null',	'-0.336',	'-0.359',	'-0.166',	'-0.369',	'-0.282',	'-0.25',	'-0.103',	'-0.162',	'-0.076',	'0',	'0.029',	'0.131',	'0.179',	'0.248',	'0.147',	'0.339',	'0.336',	'0.193',	'0.332',	'0.369',	'0.282',	'0.25',	'0.103',	'0.162',	'0.076',	'0',	'-0.029',	'-0.123',	'-0.199',	'-0.241',	'-0.136',	'-0.345',	'0.211',	'-0.244',	'-0.235',	'-0.265',	'-0.23',	'-0.253',	'-0.46',	'-0.219',	'-0.195',	'-0.192',	'-0.15',	'-0.151',	'-0.208',	'-0.068',	'-0.041',	'-0.014',	'0.014',	'0.044',	'0.163',	'0.122',	'0.139',	'0.173',	'0.168',	'0.216',	'0.434',	'0.244',	'0.235',	'0.265',	'0.23',	'0.253',	'0.46',	'0.219',	'0.195',	'0.192',	'0.15',	'0.151',	'0.208',	'0.068',	'0.041',	'0.014',	'-0.014',	'-0.044',	'-0.162',	'-0.262',	'-0.173',	'-0.168',	'-0.214',	'-0.436',	'-0.232',	'-0.173',	'-0.21',	'-0.313',	'-0.251',	'-0.34',	'-0.046',	'-0.111',	'-0.048',	'0.013',	'0.09',	'0.276',	'0.066',	'0.232',	'0.321',	'0.212',	'0.241',	'0.34',	'0.046',	'0.111',	'0.048',	'-0.014',	'-0.082',	'-0.131',	'-0.209',	'-0.241',	'0.425',	'-0.877',	'-0.51',	'1.04',	'0.351',	'0.085',	'null',	'-1.606',	'null',	'-0.086'];
                relative_pos_y = ['null',	'-0.079',	'-0.076',	'-0.154',	'-0.329',	'-0.395',	'-0.175',	'-0.25',	'-0.156',	'-0.238',	'-0.311',	'-0.216',	'-0.081',	'0.057',	'0.189',	'0.303',	'0.143',	'0.242',	'0.156',	'0.252',	'0.171',	'0.239',	'0.145',	'0.2',	'0.25',	'0.072',	'0.062',	'0.004',	'-0.025',	'0.587',	'-0.112',	'-0.124',	'-0.213',	'-0.199',	'-0.293',	'-0.251',	'-0.332',	'-0.275',	'-0.35',	'-0.26',	'-0.32',	'-0.225',	'-0.251',	'-0.161',	'-0.156',	'-0.082',	'-0.044',	'0.008',	'0.072',	'0.098',	'0.18',	'0.178',	'0.27',	'0.231',	'0.333',	'0.262',	'0.35',	'0.269',	'0.336',	'0.238',	'0.276',	'0.187',	'0.19',	'0.112',	'0.084',	'0.007',	'0.006',	'-0.039',	'-0.642',	'-0.522',	'-0.075',	'-0.265',	'-0.285',	'-0.216',	'-0.288',	'-0.115',	'-0.041',	'0.029',	'0.097',	'0.182',	'0.245',	'0.228',	'0.197',	'0.099',	'0.162',	'0.055',	'-0.009',	'-0.523',	'-0.501',	'-1.102',	'0.483',	'1.422',	'null',	'0.695',	'null',	'0.082',	'null',	'-2.505',	'null',	'-0.102',	'null',	'2.587',	'null',	'0.062',	'0.004',	'-0.025',	'-0.079',	'-0.076',	'-0.154',	'-0.329',	'-0.395',	'-0.175',	'-0.25',	'-0.156',	'-0.238',	'-0.311',	'-0.216',	'-0.081',	'0.057',	'0.189',	'0.303',	'0.143',	'0.242',	'0.156',	'0.252',	'0.171',	'0.239',	'0.145',	'0.2',	'0.25',	'0.072',	'0.57',	'0.084',	'0.007',	'0.006',	'-0.039',	'-0.112',	'-0.124',	'-0.213',	'-0.199',	'-0.293',	'-0.251',	'-0.332',	'-0.275',	'-0.35',	'-0.26',	'-0.32',	'-0.225',	'-0.251',	'-0.161',	'-0.156',	'-0.082',	'-0.044',	'0.008',	'0.072',	'0.098',	'0.18',	'0.178',	'0.27',	'0.231',	'0.333',	'0.262',	'0.35',	'0.269',	'0.336',	'0.238',	'0.276',	'0.187',	'0.19',	'0.112',	'-0.624',	'-0.528',	'0.055',	'-0.009',	'-0.075',	'-0.265',	'-0.285',	'-0.216',	'-0.288',	'-0.115',	'-0.041',	'0.029',	'0.097',	'0.182',	'0.245',	'0.228',	'0.197',	'0.099',	'0.162',	'-0.206',	'-0.504',	'-0.821',	'-0.392',	'null',	'1.778',	'null',	'0.146',	'null',	'0.571',	'null',	'0.087',	'null',	'0',	'0.294',	'null',	'null',	'-0.042',	'-0.109',	'-0.197',	'-0.231',	'-0.148',	'-0.319',	'-0.157',	'-0.346',	'-0.36',	'-0.306',	'-0.312',	'-0.229',	'-0.103',	'-0.154',	'-0.04',	'-0.039',	'0.042',	'0.109',	'0.197',	'0.231',	'0.148',	'0.324',	'0.141',	'0.361',	'0.349',	'0.313',	'0.312',	'0.229',	'0.103',	'0.153',	'0.043',	'0.037',	'0.604',	'-0.055',	'-0.067',	'-0.1',	'-0.249',	'-0.171',	'-0.178',	'-0.207',	'-0.412',	'-0.25',	'-0.469',	'-0.469',	'-0.237',	'-0.235',	'-0.394',	'-0.19',	'-0.156',	'-0.144',	'-0.196',	'-0.07',	'-0.051',	'0.055',	'0.067',	'0.1',	'0.249',	'0.171',	'0.178',	'0.207',	'0.412',	'0.248',	'0.471',	'0.468',	'0.238',	'0.235',	'0.394',	'0.19',	'0.156',	'0.144',	'0.196',	'0.07',	'0.051',	'-0.66',	'-0.538',	'-0.091',	'-0.126',	'-0.208',	'-0.238',	'-0.285',	'-0.414',	'-0.2',	'-0.189',	'-0.112',	'-0.041',	'0.091',	'0.126',	'0.212',	'0.231',	'0.294',	'0.409',	'0.346',	'0.043',	'0.113',	'0.039',	'-0.264',	'-0.769',	'-0.522',	'0.976',	'null',	'1.173',	'null',	'-0.042',	'-0.109',	'-0.197',	'-0.231',	'-0.148',	'-0.319',	'-0.157',	'-0.346',	'-0.36',	'-0.306',	'-0.312',	'-0.229',	'-0.103',	'-0.154',	'-0.04',	'-0.039',	'0.042',	'0.109',	'0.197',	'0.231',	'0.148',	'0.324',	'0.141',	'0.361',	'0.349',	'0.313',	'0.312',	'0.229',	'0.103',	'0.153',	'0.043',	'0.037',	'0.604',	'-0.055',	'-0.067',	'-0.1',	'-0.249',	'-0.171',	'-0.178',	'-0.207',	'-0.412',	'-0.25',	'-0.469',	'-0.469',	'-0.237',	'-0.235',	'-0.394',	'-0.19',	'-0.156',	'-0.144',	'-0.196',	'-0.07',	'-0.051',	'0.055',	'0.067',	'0.1',	'0.249',	'0.171',	'0.178',	'0.207',	'0.412',	'0.248',	'0.471',	'0.468',	'0.238',	'0.235',	'0.394',	'0.19',	'0.156',	'0.144',	'0.196',	'0.07',	'0.051',	'-0.66',	'-0.538',	'-0.091',	'-0.126',	'-0.208',	'-0.238',	'-0.285',	'-0.414',	'-0.2',	'-0.189',	'-0.112',	'-0.041',	'0.091',	'0.126',	'0.212',	'0.231',	'0.294',	'0.409',	'0.346',	'0.043',	'0.113',	'0.039',	'-0.318',	'-0.951',	'-0.358',	'0.829',	'null',	'0',	'1.431',	'null',	'null',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0.6',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'-0.657',	'null',	'0.057',	'null',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'0.6',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.657',	'-0.063',	'-1.559',	'null',	'0',	'1.679',	'null',	'null',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0.6',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'-0.657',	'null',	'0.057',	'null',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'0.6',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.657',	'-0.1',	'-1.785',	'null',	'0',	'1.942',	'null',	'null',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0.6',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'-0.657',	'null',	'0.057',	'null',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'0.6',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.657',	'-0.178',	'-1.929',	'null',	'0',	'2.164',	'null',	'null',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0.6',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'-0.657',	'null',	'0.057',	'null',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'0.6',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.657',	'-0.276',	'-2.033',	'null',	'0',	'2.366',	'null',	'null',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0.6',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'-0.657',	'null',	'0.057',	'null',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'0.6',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.657',	'-0.409',	'-2.067',	'null',	'0',	'2.533',	'null',	'null',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0.6',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'-0.657',	'null',	'0.057',	'null',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'0.6',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.657',	'-0.556',	'-2.072',	'null',	'0',	'2.685',	'null',	'null',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0.6',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'-0.657',	'null',	'0.057',	'null',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'0.6',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.657',	'null',	'-0.722',	'null',	'-2.04',	'null',	'0',	'2.819',	'null',	'null',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0.6',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'-0.657',	'null',	'0.057',	'null',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'0.6',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.657',	'null',	'-0.705',	'null',	'-0.92',	'0.708',	'-1.95',	'null',	'0',	'2.924',	'null',	'null',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0.6',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'-0.657',	'-0.533',	'0',	'-0.01',	'-0.092',	'-0.184',	'-0.245',	'-0.265',	'-0.056',	'-0.286',	'-0.056',	'-0.265',	'-0.245',	'-0.184',	'-0.092',	'-0.01',	'0',	'0.01',	'0.092',	'0.184',	'0.245',	'0.265',	'0.056',	'0.286',	'0.056',	'0.265',	'0.245',	'0.184',	'0.092',	'0.01',	'-0.341',	'-1.037',	'-0.361',	'0.912',	'null',	'1.417',	'null',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'0.6',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.657',	'-0.533',	'-0.01',	'-0.092',	'-0.184',	'-0.245',	'-0.265',	'-0.056',	'-0.286',	'-0.056',	'-0.265',	'-0.245',	'-0.184',	'-0.092',	'-0.01',	'0',	'0.01',	'0.092',	'0.184',	'0.245',	'0.265',	'0.056',	'0.286',	'0.056',	'0.265',	'0.245',	'0.184',	'0.092',	'0.01',	'0',	'-0.253',	'-0.912',	'-0.485',	'1.036',	'null',	'0',	'1.204',	'null',	'null',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0.6',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'-0.657',	'-0.533',	'0',	'-0.01',	'-0.092',	'-0.184',	'-0.245',	'-0.265',	'-0.056',	'-0.286',	'-0.056',	'-0.265',	'-0.245',	'-0.184',	'-0.092',	'-0.01',	'0',	'0.01',	'0.092',	'0.184',	'0.245',	'0.265',	'0.056',	'0.286',	'0.056',	'0.265',	'0.245',	'0.184',	'0.092',	'0.01',	'-0.242',	'-0.889',	'-0.503',	'1.044',	'null',	'1.18',	'null',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'0.6',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.657',	'-0.533',	'-0.01',	'-0.092',	'-0.184',	'-0.245',	'-0.265',	'-0.056',	'-0.286',	'-0.056',	'-0.265',	'-0.245',	'-0.184',	'-0.092',	'-0.01',	'0',	'0.01',	'0.092',	'0.184',	'0.245',	'0.265',	'0.056',	'0.286',	'0.056',	'0.265',	'0.245',	'0.184',	'0.092',	'0.01',	'0',	'null',	'-1.353',	'null',	'1.032',	'-0.474',	'-0.933',	'null',	'0',	'2.318',	'null',	'null',	'0',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0.6',	'0',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'-0.657',	'-0.533',	'0',	'-0.01',	'-0.092',	'-0.184',	'-0.245',	'-0.265',	'-0.056',	'-0.286',	'-0.056',	'-0.265',	'-0.245',	'-0.184',	'-0.092',	'-0.01',	'0',	'0.01',	'0.092',	'0.184',	'0.245',	'0.265',	'0.056',	'0.286',	'0.056',	'0.265',	'0.245',	'0.184',	'0.092',	'0.01',	'-0.341',	'-1.037',	'-0.361',	'0.912',	'null',	'1.417',	'null',	'-0.026',	'-0.125',	'-0.076',	'-0.23',	'-0.288',	'-0.137',	'-0.355',	'-0.153',	'-0.39',	'-0.153',	'-0.355',	'-0.137',	'-0.288',	'-0.23',	'-0.076',	'-0.125',	'-0.026',	'0',	'0.026',	'0.125',	'0.076',	'0.23',	'0.288',	'0.137',	'0.355',	'0.153',	'0.39',	'0.153',	'0.355',	'0.137',	'0.288',	'0.23',	'0.076',	'0.125',	'0.026',	'0',	'0.6',	'-0.042',	'-0.16',	'-0.123',	'-0.305',	'-0.382',	'-0.222',	'-0.455',	'-0.247',	'-0.498',	'-0.247',	'-0.455',	'-0.222',	'-0.382',	'-0.305',	'-0.123',	'-0.16',	'-0.042',	'0',	'0.042',	'0.16',	'0.123',	'0.305',	'0.382',	'0.222',	'0.455',	'0.247',	'0.498',	'0.247',	'0.455',	'0.222',	'0.382',	'0.305',	'0.123',	'0.16',	'0.042',	'0',	'-0.657',	'-0.533',	'-0.01',	'-0.092',	'-0.184',	'-0.245',	'-0.265',	'-0.056',	'-0.286',	'-0.056',	'-0.265',	'-0.245',	'-0.184',	'-0.092',	'-0.01',	'0',	'0.01',	'0.092',	'0.184',	'0.245',	'0.265',	'0.056',	'0.286',	'0.056',	'0.265',	'0.245',	'0.184',	'0.092',	'0.01',	'0',	'-0.253',	'-0.912',	'-0.485',	'1.036',	'null',	'0',	'1.178',	'null',	'null',	'-0.131',	'-0.179',	'-0.248',	'-0.147',	'-0.339',	'-0.336',	'-0.359',	'-0.166',	'-0.369',	'-0.282',	'-0.25',	'-0.103',	'-0.162',	'-0.076',	'-0.01',	'0.039',	'0.131',	'0.179',	'0.248',	'0.147',	'0.339',	'0.336',	'0.359',	'0.166',	'0.349',	'0.316',	'0.241',	'0.095',	'0.165',	'0.076',	'0',	'-0.029',	'0.582',	'-0.163',	'-0.122',	'-0.139',	'-0.173',	'-0.168',	'-0.216',	'-0.434',	'-0.244',	'-0.235',	'-0.265',	'-0.23',	'-0.253',	'-0.46',	'-0.219',	'-0.195',	'-0.192',	'-0.15',	'-0.151',	'-0.208',	'-0.068',	'-0.041',	'-0.014',	'0.014',	'0.044',	'0.163',	'0.122',	'0.139',	'0.173',	'0.168',	'0.216',	'0.434',	'0.244',	'0.235',	'0.265',	'0.23',	'0.253',	'0.458',	'0.416',	'0.192',	'0.15',	'0.15',	'0.209',	'0.068',	'0.041',	'0.014',	'-0.014',	'-0.044',	'-0.638',	'-0.518',	'-0.09',	'-0.276',	'-0.066',	'-0.232',	'-0.21',	'-0.313',	'-0.251',	'-0.34',	'-0.046',	'-0.111',	'-0.056',	'0.025',	'0.086',	'0.276',	'0.066',	'0.232',	'0.21',	'0.313',	'0.232',	'0.209',	'0.192',	'0.115',	'0.048',	'-0.013',	'null',	'-1.337',	'null',	'1.02',	'-0.469',	'-0.93',	'-0.12',	'0.098',	'null',	'2.265',	'null',	'0.076',	'0',	'-0.029',	'-0.131',	'-0.179',	'-0.248',	'-0.147',	'-0.339',	'-0.336',	'-0.359',	'-0.166',	'-0.369',	'-0.282',	'-0.25',	'-0.103',	'-0.162',	'-0.076',	'-0.01',	'0.039',	'0.131',	'0.179',	'0.248',	'0.147',	'0.339',	'0.336',	'0.359',	'0.166',	'0.349',	'0.316',	'0.241',	'0.095',	'0.165',	'0.564',	'0.068',	'0.041',	'0.014',	'-0.014',	'-0.044',	'-0.163',	'-0.122',	'-0.139',	'-0.173',	'-0.168',	'-0.216',	'-0.434',	'-0.244',	'-0.235',	'-0.265',	'-0.23',	'-0.253',	'-0.46',	'-0.219',	'-0.195',	'-0.192',	'-0.15',	'-0.151',	'-0.208',	'-0.068',	'-0.041',	'-0.014',	'0.014',	'0.044',	'0.163',	'0.122',	'0.139',	'0.173',	'0.168',	'0.216',	'0.434',	'0.244',	'0.235',	'0.265',	'0.23',	'0.253',	'0.458',	'0.416',	'0.192',	'0.15',	'0.15',	'0.209',	'-0.617',	'-0.509',	'0.048',	'-0.013',	'-0.09',	'-0.276',	'-0.066',	'-0.232',	'-0.21',	'-0.313',	'-0.251',	'-0.34',	'-0.046',	'-0.111',	'-0.056',	'0.025',	'0.086',	'0.276',	'0.066',	'0.232',	'0.21',	'0.313',	'0.232',	'0.209',	'0.192',	'0.115',	'-1.08',	'0.877',	'-0.338',	'-1.04',	'-0.351',	'-0.086',	'null',	'2.031',	'null',	'0.086'];
                relative_pos_z = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                layerStatus = ['LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
            }
            if (nozzle_size === 0.8) {
                GStatus = ['null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1'];
                EStatus = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                relative_pos_x = ['null',	'-0.305',	'-0.25',	'-0.164',	'-0.057',	'0.056',	'0.162',	'0.244',	'0.309',	'0.175',	'0.328',	'0.304',	'0.233',	'0.144',	'0.032',	'-0.075',	'-0.185',	'-0.259',	'-0.34',	'-0.352',	'-0.177',	'-0.299',	'-0.258',	'-0.254',	'-0.197',	'-0.174',	'-0.119',	'-0.075',	'-0.026',	'0.03',	'0.071',	'0.132',	'0.159',	'0.22',	'0.228',	'0.286',	'0.267',	'0.316',	'0.293',	'0.298',	'0.28',	'0.266',	'0.226',	'0.198',	'0.148',	'0.111',	'0.057',	'0.005',	'-0.038',	'-0.099',	'-0.132',	'-0.193',	'-0.206',	'-0.265',	'-0.263',	'-0.314',	'-0.071',	'-0.324',	'-0.284',	'0.197',	'0.151',	'-0.106',	'-0.039',	'0.043',	'0.123',	'0.142',	'0.073',	'-0.009',	'-0.08',	'-0.147',	'0.496',	'0.371',	'0.504',	'-0.335',	'-0.911',	'null',	'-29.604',	'null',	'-0.34',	'-0.352',	'-0.305',	'-0.25',	'-0.164',	'-0.057',	'0.056',	'0.162',	'0.244',	'0.309',	'0.175',	'0.328',	'0.304',	'0.233',	'0.144',	'0.032',	'-0.075',	'-0.185',	'-0.259',	'0.124',	'-0.314',	'-0.071',	'-0.324',	'-0.284',	'-0.299',	'-0.258',	'-0.254',	'-0.197',	'-0.174',	'-0.119',	'-0.075',	'-0.026',	'0.03',	'0.071',	'0.132',	'0.159',	'0.22',	'0.228',	'0.286',	'0.267',	'0.316',	'0.293',	'0.298',	'0.28',	'0.266',	'0.226',	'0.198',	'0.148',	'0.111',	'0.057',	'0.005',	'-0.038',	'-0.099',	'-0.132',	'-0.193',	'-0.206',	'-0.265',	'-0.263',	'-0.287',	'-0.211',	'-0.147',	'-0.106',	'-0.039',	'0.043',	'0.123',	'0.142',	'0.073',	'-0.009',	'-0.08',	'0.731',	'-0.369',	'0.869',	'-0.332',	'-0.868',	'-0.082',	'null',	'0',	'-0.047',	'null',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'null',	'30',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'0.133',	'-0.234',	'null',	'0',	'-29.899',	'null',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'null',	'30',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'null',	'0',	'-30',	'null',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'null',	'30',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'0.133',	'-0.234',	'null',	'0',	'-29.899',	'null',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0.81',	'-1.592',	'null',	'1.909',	'null',	'-0.177',	'null',	'29.05',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'null',	'0',	'-30',	'null',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0.556',	'0.415',	'0.011',	'-1.536',	'null',	'30.554',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'null',	'0',	'-30',	'null',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'null',	'30',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'null',	'0',	'-30',	'null',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'null',	'30',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'0.133',	'-0.234',	'null',	'0',	'-29.899',	'null',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'null',	'30',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'null',	'0',	'-30',	'null',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'null',	'30',	'null',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'0',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'0',	'0',	'-0.222',	'-0.169',	'-0.098',	'0',	'0.098',	'0.169',	'0.222',	'0.222',	'0.169',	'0.098',	'0',	'-0.098',	'-0.169',	'-0.222',	'0.133',	'-0.234'];
                relative_pos_y = ['null',	'-0.127',	'-0.219',	'-0.293',	'-0.33',	'-0.329',	'-0.293',	'-0.218',	'-0.131',	'-0.023',	'0.039',	'0.147',	'0.236',	'0.308',	'0.328',	'0.319',	'0.289',	'0.202',	'0.112',	'-0.017',	'0.783',	'-0.099',	'-0.132',	'-0.193',	'-0.206',	'-0.265',	'-0.263',	'-0.305',	'-0.289',	'-0.311',	'-0.284',	'-0.285',	'-0.242',	'-0.228',	'-0.172',	'-0.145',	'-0.087',	'-0.041',	'0.006',	'0.063',	'0.104',	'0.16',	'0.19',	'0.238',	'0.249',	'0.298',	'0.282',	'0.316',	'0.284',	'0.299',	'0.258',	'0.254',	'0.197',	'0.174',	'0.119',	'0.077',	'0.012',	'0.005',	'-0.038',	'-0.857',	'-0.71',	'-0.07',	'-0.117',	'-0.122',	'-0.072',	'0.039',	'0.106',	'0.12',	'0.095',	'0.021',	'1.117',	'-0.194',	'-1.193',	'-0.901',	'-0.345',	'null',	'2.205',	'null',	'0.112',	'-0.017',	'-0.127',	'-0.219',	'-0.293',	'-0.33',	'-0.329',	'-0.293',	'-0.218',	'-0.131',	'-0.023',	'0.039',	'0.147',	'0.236',	'0.308',	'0.328',	'0.319',	'0.289',	'0.202',	'0.822',	'0.077',	'0.012',	'0.005',	'-0.038',	'-0.099',	'-0.132',	'-0.193',	'-0.206',	'-0.265',	'-0.263',	'-0.305',	'-0.289',	'-0.311',	'-0.284',	'-0.285',	'-0.242',	'-0.228',	'-0.172',	'-0.145',	'-0.087',	'-0.041',	'0.006',	'0.063',	'0.104',	'0.16',	'0.19',	'0.238',	'0.249',	'0.298',	'0.282',	'0.316',	'0.284',	'0.299',	'0.258',	'0.254',	'0.197',	'0.174',	'0.119',	'-0.831',	'-0.701',	'0.021',	'-0.07',	'-0.117',	'-0.122',	'-0.072',	'0.039',	'0.106',	'0.12',	'0.095',	'0.936',	'0.197',	'-1.393',	'-0.898',	'-0.303',	'-0.082',	'null',	'0',	'2.672',	'null',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'null',	'0.794',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'-0.602',	'0.234',	'null',	'0',	'1.162',	'null',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'null',	'0.794',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'null',	'0',	'0.794',	'null',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'null',	'0.794',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'-0.602',	'0.234',	'null',	'0',	'1.162',	'null',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.439',	'-1.593',	'null',	'0.755',	'null',	'0.66',	'null',	'0.692',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'null',	'0',	'0.075',	'null',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.24',	'-1.55',	'1.123',	'-1.536',	'null',	'2.278',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'null',	'0',	'0.075',	'null',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'null',	'0.794',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'null',	'0',	'0.794',	'null',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'null',	'0.794',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'-0.602',	'0.234',	'null',	'0',	'1.162',	'null',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'null',	'0.794',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'null',	'0',	'0.794',	'null',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'null',	'0.794',	'null',	'-0.032',	'-0.099',	'-0.152',	'-0.205',	'-0.242',	'-0.284',	'-0.281',	'-0.281',	'-0.284',	'-0.242',	'-0.205',	'-0.152',	'-0.099',	'-0.032',	'0.032',	'0.099',	'0.152',	'0.205',	'0.242',	'0.284',	'0.281',	'0.281',	'0.284',	'0.242',	'0.205',	'0.152',	'0.099',	'0.032',	'0.805',	'-0.052',	'-0.157',	'-0.251',	'-0.329',	'-0.399',	'-0.451',	'-0.461',	'-0.461',	'-0.451',	'-0.399',	'-0.329',	'-0.251',	'-0.157',	'-0.052',	'0.052',	'0.157',	'0.251',	'0.329',	'0.399',	'0.451',	'0.461',	'0.461',	'0.451',	'0.399',	'0.329',	'0.251',	'0.157',	'0.052',	'-0.88',	'-0.719',	'-0.054',	'-0.137',	'-0.212',	'-0.196',	'-0.212',	'-0.137',	'-0.054',	'0.054',	'0.137',	'0.212',	'0.196',	'0.212',	'0.137',	'0.054',	'-0.602',	'0.234'];
                relative_pos_z = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                layerStatus = ['LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
            }
            return [GStatus, layerStatus, relative_pos_x, relative_pos_y, relative_pos_z, EStatus];
        }
    }

    OCTOPRINT_VIEWMODELS.push({
        construct: calibrationcompanionViewModel_retra,
        dependencies: [  "settingsViewModel", "calibrationcompanionViewModel"  ],
        elements: [ "#retraction-calibrationcompanion" ]
    });
});
